      SUBROUTINE ARITHMETIC_FITS_SIMPLE
C
C       This subroutine will perform simple arithmetic on a FITS file, and
C  save to the same map, the end of the same file, the end of a different
C  file, or a new file.
C			Donald H. Gudehus, Jan. 6, 2008
C
	INCLUDE 'miipspar.for'
	INCLUDE 'fitsfacts.for'
C
	CHARACTER*3 PRGFMAT,FILEFMT
	CHARACTER*50 CHFITSMHV
	CHARACTER*80 FILENAME_IN
	INTEGER PLANEKEY,STATUS
	INTEGER MAPS_IN(MAPMAX),NCOLS_ARRAY(MAPMAX),NROWS_ARRAY(MAPMAX)
	LOGICAL IOFL
	REAL*4 DATA(MAXSIZE)
	REAL*8 BIAS_DP,FACTOR_DP,DATADP(MAXSIZE)
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
	CHARACTER*80 DNAME
	COMMON /DFILE/ DNAME
C
C  Open the input file and select the map.  We simplify things
C  by working with only one map and only one plane.
C
	LU_IN=11
	IOFL=.TRUE.
	FILENAME_IN=' '
	MAPKEY=0
	PLANEKEY=0
	NCOLS=0
	NROWS=0
	PRGFMAT=' '
	CALL OPENFITS(LU_IN,IOFL,'FILE=',FILENAME_IN,MAPKEY,PLANEKEY,NMAPS,
	1NPLNS,NCOLS,NROWS,PRGFMAT,STATUS)
C
C  Create a temporary file.  This allows for several options when we save our
C  results.
C
	LU_TEMP=12
	MAPS_IN(1)=IMNUM
	NMAPS_IN=1 !  Only 1 map is used here
	NCOLS_ARRAY(1)=NCOLS
	NROWS_ARRAY(1)=NROWS
	CALL OPEN_TEMP_FITS(LU_IN,LU_TEMP,FILENAME_IN,MAPS_IN,NMAPS_IN,
	1NCOLS_ARRAY,NROWS_ARRAY,STATUS)
C
C  Carry out the arithmetic
C
	IROWSTART=1
	IROWEND=NAXIS2(IMNUM,LU_IN)
	ICOLSTART=1
	ICOLEND=NAXIS1(IMNUM,LU_IN)
	FILEFMT=CHFITSMHV(LU_IN,IMNUM,'BITPIX','R4')
	IF (FILEFMT.EQ.'I1'.OR.FILEFMT.EQ.'I2'.OR.FILEFMT.EQ.'I4'.OR.
	1FILEFMT.EQ.'R4'.OR.FILEFMT.EQ.'C8') THEN
	  BIAS=0.0
	  CALL USRINP(BIAS,1,'F',4,1,'BIAS=',
	1 'Enter a bias value:  (default = 0.0)')
	  FACTOR=1.0
	  CALL USRINP(FACTOR,1,'F',4,1,'FACTOR=',
	1 'Enter a factor:  (default = 1.0)')
	  DO IR=IROWSTART,IROWEND
	     CALL RDFITSROW(LU_IN,IMNUM,IPNUM,DATA,MAXSIZE,IR)
	     DO I=ICOLSTART,ICOLEND
	       DATA(I)=(DATA(I)+BIAS)*FACTOR
	     END DO
	     CALL WRFITSROW(LU_TEMP,IMNUM,IPNUM,DATA,MAXSIZE,IR)
	  END DO
	ELSE IF (FILEFMT.EQ.'R8'.OR.FILEFMT.EQ.'C16') THEN
	  BIAS_DP=0.0D0
	  CALL USRINP(BIAS_DP,1,'F',8,1,'BIAS=',
	1 'Enter a bias value:  (default = 0.0)')
	  FACTOR_DP=1.0D0
	  CALL USRINP(FACTOR_DP,1,'F',8,1,'FACTOR=',
	1 'Enter a factor:  (default = 1.0)')
	  DO IR=IROWSTART,IROWEND
	    CALL RDDPFITSROW(LU_IN,IMNUM,IPNUM,DATADP,MAXSIZE,IR)
	    DO I=ICOLSTART,ICOLEND
	      DATADP(I)=(DATADP(I)+BIAS_DP)*FACTOR_DP
	    END DO
	    CALL WRDPFITSROW(LU_TEMP,IMNUM,IPNUM,DATADP,MAXSIZE,IR)
	  END DO
	END IF
	LU_OUT=13
	CALL SAVE_SAVE_AS(LU_IN,LU_TEMP,LU_OUT,MAPS_IN,NMAPS_IN,STATUS)
	RETURN
	END
