	CHARACTER*(*) FUNCTION CHFITSMHC(LU,MAP_NUMBER,KEYWORD,DEFAULT)
C
C       This function returns a character comment from or associated with a 
C  FITS header keyword.  There are no single quotes surrounding the comment,
C  unlike the keyword's value.
C			Donald H. Gudehus, June 25, 2005
C
C	LU		(C)	The logical unit that the file was opened on
C	MAP_NUMBER	(C)	The map number within the file.  If more than
C				one map exists, then there will also be a
C				primary header which can be referenced with
C				MAP_NUMBER=0.
C	KEYWORD		(C)	The FITS keyword
C	DEFAULT         (C/R)   The comment to be returned if keyword not found
C
	CHARACTER*(*) KEYWORD,DEFAULT
C
	BYTE PHYSREC(3000)
	CHARACTER*80 KEYCARD
	CHARACTER*3000 CHARPHYSREC
	EQUIVALENCE (PHYSREC,CHARPHYSREC)
C
	INCLUDE 'fitsfacts.for'
C
	IF (LU.LT.LUMIN.OR.LU.GT.LUMAX) THEN
	  CALL ERROR(-4,'LU out of range in CHFITSMHC')
	END IF
	IF (MAP_NUMBER.LT.0.OR.MAP_NUMBER.GT.NUMMAPS(LU))
	1CALL ERROR(-4,'MAP_NUMBER out of range in CHFITSMHC')
	IBLKLEN=2880
C
C  Search through the keywords in the header
	KEYCARD=' '
	CHFITSMHC=' '
	N=LEN(KEYWORD)
	IR=HEADERRECORDS(1,MAP_NUMBER,LU)
	DO WHILE(KEYCARD(1:3).NE.'END')
	  IBPTR=1
	  READ(LU,REC=IR,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	  IF (ISTAT.NE.0) THEN
	    CALL ERROR(-3,'Error in reading physical record')
	  END IF
	  DO WHILE(KEYCARD(1:3).NE.'END'.AND.IBPTR.LE.2801)
	    KEYCARD=CHARPHYSREC(IBPTR:IBPTR+79)
C  Eliminate control characters
	    DO I=1,80
	      IF (ICHAR(KEYCARD(I:I)).LT.32) KEYCARD(I:I)=' '
	    END DO
	    IF (KEYCARD(1:N).EQ.KEYWORD(1:N)) THEN
	      IND=INDEX(KEYCARD,'/')
C  Strip trailing blanks
	      I=80
	      DO WHILE(KEYCARD(I:I).EQ.' ')
	        I=I-1
	      END DO
	      IF (IND.EQ.0.OR.(IND.EQ.I)) THEN
	        IFOUND=0
	      ELSE
	        IFOUND=1
	        CHFITSMHC=KEYCARD(IND+2:I)
	      END IF
	    END IF
	    IBPTR=IBPTR+80
	  END DO
	  IR=IR+1
	END DO
C
	IF (IFOUND.NE.1) CHFITSMHC=DEFAULT
C
	RETURN
	END
