	SUBROUTINE GET_INPUT_FITS_MAPS(LU_IN,FILENAME_IN,MAPS_IN,
	1NMAPS_IN,STATUS)
C
C       This subroutine prompts for the user for an input FITS file, and
C  prompts for any of its maps if the number of maps exceeds one.  This
C  subroutine is useful for when several maps need to be selected for 
C  operations that loop through maps.
C				Donald H. Gudehus, July 18, 2006
C
C	LU_IN		(C)	The input logical unit
C	FILENAME_IN	(C)	The name of the input file;  if it is blank,
C				in the call, it is prompted for.
C	MAPS_IN		(R)	The input map numbers
C	NMAPS_IN	(R)	The number of input maps requested
C	STATUS		(R)	The status.  If there were no errors in
C				opening the file, the value will be 0.
C
	PARAMETER (MAPMAX=256)
C
	CHARACTER*(*) FILENAME_IN
	INTEGER MAPS_IN(MAPMAX),MAPKEY,PLANEKEY,STATUS
C
	CHARACTER*3 PRGFMAT
	LOGICAL IOFL
C
C  Open the input file
	STATUS=0
	IOFL=.TRUE.
	MAPKEY=1
C  When looping on maps, we process all planes in any map.  Therefore we
C  do not request a prompt for the plane number.
	PLANEKEY=1
	NMAPS=0
	NPLNS=0
	NROWS=0
	NCOLS=0
	PRGFMAT=' '
	CALL MESSAGE('Open the input file')
	CALL OPENFITS(LU_IN,IOFL,'FILE_IN=',FILENAME_IN,MAPKEY,PLANEKEY,
	1NMAPS,NPLNS,NCOLS,NROWS,PRGFMAT,STATUS)
	IF (STATUS.NE.0) RETURN
C
	DO M=1,MAPMAX
	  J=ISETEND(MAPS_IN(M))
	END DO
	NOOFMAPS_IN=NO_OF_FITS_MAPS(LU_IN) !  Present number of maps in file.
	IF (NOOFMAPS_IN.GT.1) THEN !  Input file
	  DO M=1,NOOFMAPS_IN
	    MAPS_IN(M)=M
	  END DO
	  CALL USRINP(MAPS_IN,NOOFMAPS_IN,'I',4,3,'MAPS_IN=',
	1 'Enter the input map numbers:  (default = all)')
	  NMAPS_IN=INEL(MAPS_IN,MAPMAX)
	ELSE
	  NMAPS_IN=1
	  MAPS_IN(1)=1
	END IF
C  Check that the requested input maps actually exist. If any do not exist,
C  declare an error.
	DO I=1,NMAPS_IN
	  IF (MAPS_IN(I).GT.NOOFMAPS_IN) THEN
	    CALL ERROR(-3,
	1   'You have requested an input map which does not exist')
	    STATUS=1
	  END IF
	END DO
C
	RETURN
	END
