	INTEGER*4 FUNCTION I4FITSMHV(LU,MAP_NUMBER,KEYWORD,DEFAULT)
C
C       This function returns an integer value from or associated with a
C FITS header keyword.
C			Donald H. Gudehus, June 16, 2005
C
C	LU		(C)	The logical unit that the file was opened on
C	MAP_NUMBER	(C)	The map number within the file.  If more than
C				one map exists, then there will also be a
C				primary header which can be referenced with
C				MAP_NUMBER=0.

C	KEYWORD		(C)	The FITS keyword
C	DEFAULT		(C/R)	The value to be returned if keyword not found
C
	CHARACTER*(*) KEYWORD
	INTEGER DEFAULT
C
	INCLUDE 'fitsfacts.for'
C
	BYTE PHYSREC(3000)
	CHARACTER*80 KEYCARD
	CHARACTER*3000 CHARPHYSREC
	EQUIVALENCE (PHYSREC,CHARPHYSREC)
C
	IF (LU.LT.LUMIN.OR.LU.GT.LUMAX) THEN
	  CALL ERROR(-4,'LU out of range in I4FITSMHV')
	END IF
	IF (MAP_NUMBER.LT.0.OR.MAP_NUMBER.GT.NUMMAPS(LU))
	1CALL ERROR(-4,'MAP_NUMBER out of range in I4FITSMHV')
	IBLKLEN=2880
C  If the keyword has a value already in one of the FITSFACTS COMMON blocks,
C  just retrieve the information from there.
	IFOUND=0
	IF (KEYWORD.EQ.'NAXIS') THEN
	  I4FITSMHV=NAXIS(MAP_NUMBER,LU)
	  IFOUND=1
	ELSE IF (KEYWORD.EQ.'NAXIS1') THEN
	  I4FITSMHV=NAXIS1(MAP_NUMBER,LU)
	  IFOUND=1
	ELSE IF (KEYWORD.EQ.'NAXIS2') THEN
	  I4FITSMHV=NAXIS2(MAP_NUMBER,LU)
	  IFOUND=1
	ELSE IF (KEYWORD.EQ.'NAXIS3') THEN
	  I4FITSMHV=NAXIS3(MAP_NUMBER,LU)
	  IFOUND=1
	ELSE
C  Search through the keywords in the header
	  KEYCARD=' '
	  N=LEN(KEYWORD)
	  IR=HEADERRECORDS(1,MAP_NUMBER,LU)
	  DO WHILE(KEYCARD(1:3).NE.'END')
	    IBPTR=1
	    READ(LU,REC=IR,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	    IF (ISTAT.NE.0) THEN
	      CALL ERROR(-3,'Error in reading physical record')
	    END IF
	    DO WHILE(KEYCARD(1:3).NE.'END'.AND.IBPTR.LE.2801)
	      KEYCARD=CHARPHYSREC(IBPTR:IBPTR+79)
C  Eliminate control characters
	      DO I=1,80
	        IF (ICHAR(KEYCARD(I:I)).LT.32) KEYCARD(I:I)=' '
	      END DO
	      IF (KEYCARD(1:N).EQ.KEYWORD(1:N)) THEN
	        DECODE (20,1020,KEYCARD(11:30)) I4FITSMHV
1020	        FORMAT(I20)
	        IFOUND=1
	      END IF
	      IBPTR=IBPTR+80
	    END DO
	    IR=IR+1
	  END DO
	END IF
C
	IF (IFOUND.NE.1) I4FITSMHV=DEFAULT
C
	RETURN
	END
