	SUBROUTINE LINEPL1_FITS(DATXY,IXLO,XSTART,ILX,IYLO,YSTART,ILY,THETA,
	1PLENGTH,DAT,MAPN,IPLN)
C
C       This subroutine helps LINEPL_FITS in the cases of plotting a line at
C  any angle or on the TV by allowing operation of the dynamic memory
C  assignment.
C				Donald H. Gudehus, April, l983
C
C	DATXY	(C)	The array which will contain the pixel values
C			from the two-dimensional area surrounding the 
C			line to be plotted
C	IXLO	(C)	The x pixel location in the map correspoinding
C			to the beginning of the array DAT
C	XSTART	(C)	The starting x pixel location for the line to
C			be plotted
C	ILX	(C)	The length of the array DATXY in the x direction
C	IYLO	(C)	Like IXLO but in the y direction
C	YSTART	(C)	Like XSTART but in the y direction
C	ILY	(C)	The length of the array DATXY in the y direction
C	THETA	(C)	The angle in degrees of the line to be plotted
C	PLENGTH (C/R)	The number of points which will be plotted.
C			This will be the same as the value in the call
C			if the edge of the map is not encountered.
C	DAT	(R)	The array containing the line of pixel values to
C			be plotted
C	MAPN	(C)	The map number
C	IPLN	(C)	The plane number
C
	INCLUDE 'miipspar.for'	
C
	DIMENSION DATXY(ILX,ILY),DAT(MAXPLOTSIZE)
	LOGICAL PROCEED
C	REAL SINTERP2D
C
	CALL RDFITSXY(11,MAPN,IPLN,DATXY,ILX,ILY,IXLO,ILX,IYLO,ILY)
C  Initialize DAT
	DO K=1,MAXPLOTSIZE
	  DAT(K)=0.0
	END DO
	CS=COSD(THETA)
	SN=SIND(THETA)
C  Adjust the positions to be 1.xxx at the beginning of the array DAT
	XSTART=XSTART-FLOAT(IXLO)+1.0
	YSTART=YSTART-FLOAT(IYLO)+1.0
	K=0
	PROCEED=.TRUE.
	DO 100 WHILE (PROCEED)
	  XX=XSTART+FLOATJ(K)*CS
	  YY=YSTART+FLOATJ(K)*SN
	  IXX=JINT(XX)
	  IYY=JINT(YY)
C  Never read beyond the limits of the array DATXY
	  IF (IXX.GT.ILX.OR.IXX.LT.1.OR.IYY.GT.ILY.OR.
	1 IYY.LT.1) THEN
	    PROCEED=.FALSE.
	    GO TO 100
	  END IF
C  Don't read more points than requested
	  IF (K.GT.PLENGTH) THEN
	    PROCEED=.FALSE.
	    GO TO 100
	  END IF
	  K=K+1
C	  DAT(K)=SINTERP2D(DATXY,ILX,ILY,XX,YY,5,1.33)
	  DAT(K)=DATXY(IXX,IYY)
 100	CONTINUE
	PLENGTH=FLOATJ(K)
	RETURN
	END
