	SUBROUTINE COPY_FITS_RECORDS(LU_IN,LU_OUT,FILENAME_OUT,MAPS_IN,
	1NMAPS_IN,MAPS_OUT,STATUS)
C
C       This subroutine copies records from the input file maps to the
C  output file maps.
C		Donald H. Gudehus, July 10, 2006
C		Version 1UM, D. Gudehus, Aug. 23, 2006
C		Modified USRINP to work with Absoft compiler on Mac OS X
C
C	LU_IN		(C)	The logical unit of the input file
C	LU_OUT		(C)	The logical unit of the output file
C	FILENAME_OUT	(C/R)	The name of the output file.  If it is blank
C				in the call then it is prompted for.
C	MAPS_IN		(C)	The input map numbers
C	MAPS_OUT	(R)	The map numbers written to in the output
C				file
C	STATUS		(R)	The status.  If all went well, zero is
C				returned.
C
	INCLUDE 'fitsfacts.for'
C
	CHARACTER*(*) FILENAME_OUT
	INTEGER MAPS_IN(MAPMAX),MAPS_OUT(MAPMAX),STATUS
C
	BYTE PHYSREC(3000),PHYSREC_2(3000)
	CHARACTER*3000 CHARPHYSREC,CHARPHYSREC_2
	EQUIVALENCE (PHYSREC,CHARPHYSREC),(PHYSREC_2,CHARPHYSREC_2)
	CHARACTER*80 KEYCARD,KEYCARD_PREVIOUS,KEYCARD_TEMP
	LOGICAL FILE_EXISTS,FILE_IS_OPEN,DONE
C
	IBLKLEN=2880
C
	IF (FILENAME_OUT.EQ.' ') THEN
	  CALL MESSAGE('Open the output file')
	  CALL USRINP_CHAR(1,'A',80,0,'FILE_OUT=',
	1 'Enter the filename:',%REF(FILENAME_OUT))
	  CALL ALPHA(%REF(FILENAME_OUT),1,80,NCHAR,NFULL,NREST,2)
	END IF	
C
	INQUIRE(FILE=FILENAME_OUT,EXIST=FILE_EXISTS,OPENED=FILE_IS_OPEN)
	IF (FILE_IS_OPEN) THEN
	  CALL ERROR(-3,'The file is already open')
	  STATUS=1
	  RETURN
	END IF
C
	NMAPS_IN_EXISTING=NUMMAPS(LU_IN)
	IF (.NOT.FILE_EXISTS) THEN !  3 Possible Cases
C  Create the output file
	  CALL MESSAGE('Creating new file')
	  OPEN(LU_OUT,STATUS='NEW',ACCESS='DIRECT',RECL=IBLKLEN,
	1 FORM='UNFORMATTED',FILE=FILENAME_OUT,IOSTAT=ISTAT)
	  IF (ISTAT.NE.0) THEN
	    CALL ERROR(-3,'Occurred while opening file')
	    STATUS=1
	  END IF
C
C
	  IF (NMAPS_IN_EXISTING.EQ.1) THEN !
C  Simply copy the input records to the output file since there
C  is only one map.
	    IM=1 !  Only one map
	    IR_OUT=1 !  Output file is new
	    MAPS_OUT(1)=1
	    DO IRH=HEADERRECORDS(1,IM,LU_IN),HEADERRECORDS(2,IM,LU_IN)
	      READ(LU_IN,REC=IRH,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	      IF (ISTAT.NE.0) THEN
	        CALL ERROR(-3,'Error in reading physical record')
	        STATUS=2
	      END IF
	      WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1     (PHYSREC(I),I=1,IBLKLEN)
	      IF (ISTAT.NE.0) THEN
	        CALL ERROR(-3,'Error in writing physical record')
	        STATUS=2
	      END IF
	      IR_OUT=IR_OUT+1
	    END DO
	    DO IRD=MAPRECORDS(1,IM,LU_IN),MAPRECORDS(2,IM,LU_IN)
	      READ(LU_IN,REC=IRD,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	      IF (ISTAT.NE.0) THEN
	        CALL ERROR(-3,'Error in reading physical record')
	        STATUS=2
	      END IF
	      WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1     (PHYSREC(I),I=1,IBLKLEN)
	      IF (ISTAT.NE.0) THEN
	        CALL ERROR(-3,'Error in writing physical record')
	        STATUS=2
	      END IF
	      IR_OUT=IR_OUT+1
	    END DO
C
C
	  ELSE !  NMAPS_IN_EXISTING greater than 1
	    IF (NMAPS_IN.EQ.1) THEN !
C  Create one header and one map.  We replace the XTENSION keyword
C  with the SIMPLE keyword, and retain all the other keycards except
C  for those with keywords EXTNAME, EXTVER, PCOUNT, GCOUNT.
	      IR_OUT=1 !  Output file is new
	      IM=MAPS_IN(1)
	      DONE=.FALSE.
	      DO IR_IN=HEADERRECORDS(1,IM,LU_IN),HEADERRECORDS(2,IM,LU_IN)
	        IBPTR_RD=1
	        READ(LU_IN,REC=IR_IN,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in reading physical record')
	          STATUS=2
	        END IF
	        DO WHILE(IBPTR_RD.LE.2801.AND..NOT.DONE)
	          KEYCARD=CHARPHYSREC(IBPTR_RD:IBPTR_RD+79)
	          IF (KEYCARD(1:8).EQ.'XTENSION') THEN
	            KEYCARD(1:80)=' '
	            KEYCARD(1:9)='SIMPLE  ='
	            KEYCARD(30:30)='T'
	            KEYCARD(31:51)=' / Standard FITS file'
	            CHARPHYSREC(IBPTR_RD:IBPTR_RD+79)=KEYCARD
	          ELSE IF (KEYCARD(1:7).EQ.'EXTNAME'.OR.
	1         KEYCARD(1:6).EQ.'EXTVER'.OR.KEYCARD(1:6).EQ.'PCOUNT'.OR.
	2         KEYCARD(1:6).EQ.'GCOUNT') THEN
	            KEYCARD(1:80)=' '
	            CHARPHYSREC(IBPTR_RD:IBPTR_RD+79)=KEYCARD
	          END IF
	          IF (KEYCARD(1:3).EQ.'END') DONE=.TRUE.
	          IBPTR_RD=IBPTR_RD+80
	        END DO
	        WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1       (PHYSREC(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in reading physical record')
	          STATUS=2
	        END IF
	        IR_OUT=IR_OUT+1
	      END DO
C  Now copy the data
	      DO IRD=MAPRECORDS(1,IM,LU_IN),MAPRECORDS(2,IM,LU_IN)
	        READ(LU_IN,REC=IRD,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in reading physical record')
	          STATUS=2
	        END IF
	        WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1       (PHYSREC(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in writing physical record')
	          STATUS=2
	        END IF
	        IR_OUT=IR_OUT+1
	      END DO
C
C
	    ELSE !  NMAPS_IN greater than 1  Passeed ********
C  Create an output file with a primary header and several map headers.
C  Just copy the primary header and desired map header records to the
C  new file.
	      IR_OUT=1 !  Output file is new
	      IM=0 !  Primary header
C  Write the primary header
	      DO IRH=HEADERRECORDS(1,IM,LU_IN),HEADERRECORDS(2,IM,LU_IN)
	        READ(LU_IN,REC=IRH,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in reading physical record')
	          STATUS=2
	        END IF
	        WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1       (PHYSREC(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in writing physical record')
	          STATUS=2
	        END IF
	        IR_OUT=IR_OUT+1
	      END DO
C  Write the remaining records	         
	      DO N=1,NMAPS_IN 
	        WRITE(6,1000) MAPS_IN(N)
1000	        FORMAT(' ','Writing map ',I4)
	        WRITE(7,1000) MAPS_IN(N)
	        IM=MAPS_IN(N)
	        DO IRH=HEADERRECORDS(1,IM,LU_IN),HEADERRECORDS(2,IM,LU_IN)
	          READ(LU_IN,REC=IRH,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	          IF (ISTAT.NE.0) THEN
	            CALL ERROR(-3,'Error in reading physical record')
	            STATUS=2
	          END IF
	          WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1         (PHYSREC(I),I=1,IBLKLEN)
	          IF (ISTAT.NE.0) THEN
	            CALL ERROR(-3,'Error in writing physical record')
	            STATUS=2
	          END IF
	          IR_OUT=IR_OUT+1
	        END DO
	        DO IRD=MAPRECORDS(1,IM,LU_IN),MAPRECORDS(2,IM,LU_IN)
	          READ(LU_IN,REC=IRD,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	          IF (ISTAT.NE.0) THEN
	            CALL ERROR(-3,'Error in reading physical record')
	            STATUS=2
	          END IF
	          WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1         (PHYSREC(I),I=1,IBLKLEN)
	          IF (ISTAT.NE.0) THEN
	            CALL ERROR(-3,'Error in writing physical record')
	            STATUS=2
	          END IF
	          IR_OUT=IR_OUT+1
	        END DO
	      END DO
	    END IF
	  END IF
C
C
	ELSE !  Output file already exists.  5 Possible Cases
C
C  Find out how many maps are already in the output file
	  IOFL=.TRUE.
	  MAPKEY=1
	  PLANEKEY=1
	  PRGFMAT=' '
	  CALL OPENFITS(LU_OUT,IOFL,'FILE=',FILENAME_OUT,MAPKEY,PLANEKEY,
	1 NMAPS,NPLNS,NCOLS,NROWS,PRGFMAT,STATUS)
	  NMAPS_OUT_EXISTING=NUMMAPS(LU_OUT)
	  IRECLAST=MAPRECORDS(2,NMAPS_OUT_EXISTING,LU_OUT)
C
C
	  IF (NMAPS_OUT_EXISTING.EQ.1) THEN
C
C  Modify the existing output header to make it into a primary header, create
C  a map header, and preserve the image data.  The following code is based
C  on code from OPENFITS.
C
C       The primary header may be slightly longer in length now, since it
C  must contain the EXTEND keyword.  Note that a preexisting EXTEND keyword
C  does not guarantee that extensions are actually present.  The keyword
C  BLOCKED is deprecated and will produce a warning if it is included in
C  the primary header.  Other keywords that will produce warnings in the 
C  primary header are CRPIX1, CRPIX2, etc., CRVAL1, CRVAL2, etc.,
C  CDELT1 CDELT2, etc., CTYPE1, CTYPE2, etc., CUNIT1, CUNIT2, etc.
C       The extension header for existing map #1 will be slightly
C  longer than the orginal header since it must now contain the
C  PCOUNT and GCOUNT keywords.  The SIMPLE keyword  gets replaced with
C  XTENSION keyword, and any preexisting EXTEND keyword will need to be
C  removed.
C
C  First, get the number of keycards (blank and nonblank up to and including
C  the END keyword) in the original header.
	    NKEY=NUMKEYCARDS(1,LU_OUT)
C  Compute the number of keycards modulo 36.  36 is the number of
C  keycards which can fit into a record, i.e., 2880/80
	    NKEY_36=MOD(NKEY,36)
C  Compute the number of records needed for the new primary header.
C  First find out if the EXTEND keyword exists.  If it does, then
C  the new header will be the same size as the old one.
	    LEN_PH=HEADERRECORDS(2,1,LU_OUT)-HEADERRECORDS(1,1,LU_OUT)+1
	    IF (EXTEND(LU_OUT).EQ.0) THEN !  Keyword not present
	      IF (NKEY_36.EQ.0) LEN_PH=LEN_PH+1 !  Units of records
	    END IF
C  Compute the number of records needed for the new header of map #1
	    LEN_H1=HEADERRECORDS(2,1,LU_OUT)-HEADERRECORDS(1,1,LU_OUT)+1
C  If the EXTEND keyword is present it will be removed, freeing up space for
C  an additional keyword.  We, at the same time, account for two additional
C  spaces needed for PCOUNT and GCOUNT.
	    IF (EXTEND(LU_OUT).EQ.0) THEN !  Keyword not present
	      IF (NKEY_36.EQ.35) LEN_H1=LEN_H1+1
	    ELSE
	      IF (NKEY_36.EQ.0) LEN_H1=LEN_H1+1
	    END IF
C  Calculate the additional number of records for the primary and first map
C  headers.
	    NRECSTOADD=LEN_PH+LEN_H1-
	1   (HEADERRECORDS(2,1,LU_OUT)-HEADERRECORDS(1,1,LU_OUT)+1)
C  Write empty records to the end of the file to allow room for possible extra
C  records at the beginning of the file for the primary header and map #1 header.
C  Here we write ASCII nulls.
	    DO I=1,IBLKLEN
	      PHYSREC(I)=0
	    END DO
	    IRECLAST=MAPRECORDS(2,NMAPS_OUT_EXISTING,LU_OUT)
	    DO IR=1+IRECLAST,NRECSTOADD+IRECLAST
	      WRITE(LU_OUT,REC=IR,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	      IF (ISTAT.NE.0) THEN
	        CALL ERROR(-3,'Error in writing physical record')
	        STATUS=2
	      END IF
	    END DO
C  Shift the image data for map #1
	    IRSTART=MAPRECORDS(1,1,LU_OUT)
	    IREND=MAPRECORDS(2,1,LU_OUT)
	    DO IR=IREND,IRSTART,-1
	      READ(LU_OUT,REC=IR,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
              IF (ISTAT.NE.0) THEN
	        CALL ERROR(-3,'Error in reading physical record')
	        STATUS=2
	      END IF
	      IRWRITE=LEN_PH+LEN_H1+IR-IRSTART+1
	      WRITE(LU_OUT,REC=IRWRITE,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	      IF (ISTAT.NE.0) THEN
	        CALL ERROR(-3,'Error in writing physical record')
	        STATUS=2
	      END IF
	    END DO
C  Write the header for map #1.  We'll insert PCOUNT and GCOUNT right
C  after the NAXIS keywords
	    IRSTART=HEADERRECORDS(1,1,LU_OUT)
	    IREND=HEADERRECORDS(2,1,LU_OUT)
	    IRWRITE=HEADERRECORDS(1,1,LU_OUT)+LEN_PH
	    IBPTR_WR=1
	    INAXIS_DETECT=0
	    DONE=.FALSE.
	    CHARPHYSREC_2=' ' !  ASCII blanks
	    DO IR=IRSTART,IREND !  Loops on records for reading
	      IBPTR_RD=1
	      READ(LU_OUT,REC=IR,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	      IF (ISTAT.NE.0) THEN
	        CALL ERROR(-3,'Error in reading physical record')
	        STATUS=2
	      END IF
	      DO WHILE(IBPTR_RD.LE.2801.AND..NOT.DONE)
	        IF (INAXIS_DETECT.EQ.0.OR.INAXIS_DETECT.EQ.1
	1       .OR.INAXIS_DETECT.EQ.4) THEN
	          KEYCARD=CHARPHYSREC(IBPTR_RD:IBPTR_RD+79)
	        END IF
C  Replace the SIMPLE keyword with XTENSION
	        IF (KEYCARD(1:6).EQ.'SIMPLE') THEN !  The first keycard
	          KEYCARD(1:80)=' '
	          KEYCARD(1:9)='XTENSION='
	          KEYCARD(11:20)='''IMAGE   '''
	          KEYCARD(31:48)=' / Image extension'
	        ELSE IF (KEYCARD(1:5).EQ.'NAXIS') THEN
	          INAXIS_DETECT=1
	        ELSE IF (INAXIS_DETECT.EQ.1.AND.KEYCARD(1:5).NE.'NAXIS') THEN
	          INAXIS_DETECT=2
	        END IF
C  After the NAXIS keywords come PCOUNT and GCOUNT
	        IF (INAXIS_DETECT.EQ.2) THEN
	          KEYCARD(1:80)=' '
	          KEYCARD(1:9)='PCOUNT  ='
	          KEYCARD(30:30)='0'
	          KEYCARD(31:33)=' / '
	          INAXIS_DETECT=3
	        ELSE IF (INAXIS_DETECT.EQ.3) THEN
	          KEYCARD(1:80)=' '
	          KEYCARD(1:9)='GCOUNT  ='
	          KEYCARD(30:30)='1'
	          KEYCARD(31:33)=' / '
	          INAXIS_DETECT=4
	          IBPTR_RD=IBPTR_RD-80
	        END IF
	        IF (KEYCARD(1:3).EQ.'END') THEN
	          DONE=.TRUE.
	        END IF
C  If the EXTEND keycard exists, don't write it to the new header
C  Also, don't write the deprecated BLOCKED keyword.
	        IF (KEYCARD(1:6).NE.'EXTEND'.AND.
	1       KEYCARD(1:7).NE.'BLOCKED') THEN
	          CHARPHYSREC_2(IBPTR_WR:IBPTR_WR+79)=KEYCARD
	          IBPTR_WR=IBPTR_WR+80
	          IF (IBPTR_WR.EQ.2881) THEN
	            WRITE(LU_OUT,REC=IRWRITE,IOSTAT=ISTAT)
	1           (PHYSREC_2(I),I=1,IBLKLEN)
	            IF (ISTAT.NE.0) THEN
	              CALL ERROR(-3,'Error in writing physical record')
	              STATUS=2
	            END IF
	            IRWRITE=IRWRITE+1
	            IBPTR_WR=1
	            CHARPHYSREC_2=' '
	          END IF
	        END IF
	        IF (INAXIS_DETECT.EQ.0.OR.INAXIS_DETECT.EQ.1
	1       .OR.INAXIS_DETECT.EQ.4) IBPTR_RD=IBPTR_RD+80
	      END DO
	    END DO
C  Flush the buffer
	    IF (IBPTR_WR.NE.1) THEN
	      WRITE(LU_OUT,REC=IRWRITE,IOSTAT=ISTAT) (PHYSREC_2(I),I=1,IBLKLEN)
	      IF (ISTAT.NE.0) THEN
	        CALL ERROR(-3,'Error in writing physical record')
	        STATUS=2
	      END IF
	    END IF
C
C  Write the primary header.  We don't replace the SIMPLE keyword.  If the 
C  EXTEND keyword is not already present we will put it after the NAXIS
C  keyword.
	    IRSTART=HEADERRECORDS(1,1,LU_OUT)
	    IREND=HEADERRECORDS(2,1,LU_OUT)
	    IRWRITE=HEADERRECORDS(1,1,LU_OUT)
	    IBPTR_WR=1
	    DONE=.FALSE.
	    CHARPHYSREC_2=' ' !  ASCII blanks
	    KEYCARD_PREVIOUS=' '
	    DO IR=IRSTART,IREND !  Loops on records for reading
	      IBPTR_RD=1
	      READ(LU_OUT,REC=IR,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	      IF (ISTAT.NE.0) THEN
	        CALL ERROR(-3,'Error in reading physical record')
	        STATUS=2
	      END IF
	      DO WHILE(IBPTR_RD.LE.2801.AND..NOT.DONE)
	        KEYCARD=CHARPHYSREC(IBPTR_RD:IBPTR_RD+79)
	        IF (KEYCARD(1:3).EQ.'END') DONE=.TRUE.
C  Put in the EXTEND keycard if it is missing and write if
C  necessary.  
	        IF (EXTEND(LU_OUT).EQ.0.AND.KEYCARD(1:5).NE.'NAXIS'.AND.
	1       KEYCARD_PREVIOUS(1:5).EQ.'NAXIS') THEN
	          KEYCARD_TEMP=' '
	          KEYCARD_TEMP(1:9)='EXTEND  ='
	          KEYCARD_TEMP(30:30)='T'
	          KEYCARD_TEMP(31:58)=' / There are FITS extensions'
	          CHARPHYSREC_2(IBPTR_WR:IBPTR_WR+79)=KEYCARD_TEMP
	          IBPTR_WR=IBPTR_WR+80
	          IF (IBPTR_WR.EQ.2881) THEN
	            WRITE(LU_OUT,REC=IRWRITE,IOSTAT=ISTAT)
	1           (PHYSREC_2(I),I=1,IBLKLEN)
	            IF (ISTAT.NE.0) THEN
	              CALL ERROR(-3,'Error in writing physical record')
	              STATUS=2
	            END IF
	            IRWRITE=IRWRITE+1
	            IBPTR_WR=1
	            CHARPHYSREC_2=' '
	          END IF
	          EXTEND(LU_OUT)=1
C  Change the keycard to true if it is false
	        ELSE IF (EXTEND(LU_OUT).EQ.2.AND.KEYCARD.EQ.'EXTEND') THEN
	          KEYCARD(30:30)='T'
	          EXTEND(LU_OUT)=1
	        END IF
	        IF (KEYCARD(1:9).EQ.'NAXIS   =') THEN
	          KEYCARD_TEMP=' '
	          KEYCARD_TEMP(1:9)='NAXIS   ='
	          KEYCARD_TEMP(30:30)='0'
	          KEYCARD_TEMP(32:32)='/'
	          CHARPHYSREC_2(IBPTR_WR:IBPTR_WR+79)=KEYCARD_TEMP
	          IBPTR_WR=IBPTR_WR+80
C  Exclude certain keycards from the primary header
	        ELSE IF (KEYCARD(1:6).NE.'NAXIS1'.AND.KEYCARD(1:6).NE.'NAXIS2'
	1       .AND.KEYCARD(1:6).NE.'NAXIS3'.AND.KEYCARD(1:7).NE.'BLOCKED'
	2       .AND.KEYCARD(1:5).NE.'CRPIX'.AND.KEYCARD(1:5).NE.'CRVAL'.AND.
	3       KEYCARD(1:5).NE.'CDELT'.AND.KEYCARD(1:5).NE.'CTYPE'.AND.
	4       KEYCARD(1:5).NE.'CUNIT') THEN
	          CHARPHYSREC_2(IBPTR_WR:IBPTR_WR+79)=KEYCARD
	          IBPTR_WR=IBPTR_WR+80
	        END IF
	        IF (IBPTR_WR.EQ.2881) THEN
	          WRITE(LU_OUT,REC=IRWRITE,IOSTAT=ISTAT)
	1         (PHYSREC_2(I),I=1,IBLKLEN)
	          IF (ISTAT.NE.0) THEN
	            CALL ERROR(-3,'Error in writing physical record')
	            STATUS=2
	          END IF
	          IRWRITE=IRWRITE+1
	          IBPTR_WR=1
	          CHARPHYSREC_2=' '
	        END IF
	        IBPTR_RD=IBPTR_RD+80
	        KEYCARD_PREVIOUS=KEYCARD
	      END DO
	    END DO
C  Flush the buffer if more keywords have been added to it
	    IF (IBPTR_WR.NE.1) THEN
	      WRITE(LU_OUT,REC=IRWRITE,IOSTAT=ISTAT) (PHYSREC_2(I),I=1,IBLKLEN)
	      IF (ISTAT.NE.0) THEN
	        CALL ERROR(-3,'Error in writing physical record')
	        STATUS=2
	      END IF
	    END IF
C  Update the number of recors
	    NUMRECORDS(LU_OUT)=NRECSTOADD+IRECLAST
C
C
	    IF (NMAPS_IN_EXISTING.EQ.1) THEN
C  Modify the input header to make it an extension header and write
C  it to the output file.
	      IRSTART=HEADERRECORDS(1,1,LU_IN)
	      IREND=HEADERRECORDS(2,1,LU_IN)
	      IRWRITE=NUMRECORDS(LU_OUT)+1
	      IBPTR_WR=1
	      INAXIS_DETECT=0
	      DONE=.FALSE.
	      CHARPHYSREC_2=' ' !  ASCII blanks
	      DO IR=IRSTART,IREND !  Loops on records for reading
	        IBPTR_RD=1
	        READ(LU_IN,REC=IR,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in reading physical record')
	          STATUS=2
	        END IF
	        DO WHILE(IBPTR_RD.LE.2801.AND..NOT.DONE)
	          IF (INAXIS_DETECT.EQ.0.OR.INAXIS_DETECT.EQ.1
	1         .OR.INAXIS_DETECT.EQ.4) THEN
	            KEYCARD=CHARPHYSREC(IBPTR_RD:IBPTR_RD+79)
	          END IF
C  Replace the SIMPLE keyword with XTENSION
	          IF (KEYCARD(1:6).EQ.'SIMPLE') THEN !  The first keycard
	            KEYCARD(1:80)=' '
	            KEYCARD(1:9)='XTENSION='
	            KEYCARD(11:20)='''IMAGE   '''
	            KEYCARD(31:48)=' / Image extension'
	          ELSE IF (KEYCARD(1:5).EQ.'NAXIS') THEN
	            INAXIS_DETECT=1
	          ELSE IF (INAXIS_DETECT.EQ.1.AND.KEYCARD(1:5)
	1         .NE.'NAXIS') THEN
	            INAXIS_DETECT=2
	          END IF
C  After the NAXIS keywords come PCOUNT and GCOUNT
	          IF (INAXIS_DETECT.EQ.2) THEN
	            KEYCARD(1:80)=' '
	            KEYCARD(1:9)='PCOUNT  ='
	            KEYCARD(30:30)='0'
	            KEYCARD(31:33)=' / '
	            INAXIS_DETECT=3
	          ELSE IF (INAXIS_DETECT.EQ.3) THEN
	            KEYCARD(1:80)=' '
	            KEYCARD(1:9)='GCOUNT  ='
	            KEYCARD(30:30)='1'
	            KEYCARD(31:33)=' / '
	            INAXIS_DETECT=4
	            IBPTR_RD=IBPTR_RD-80
	          END IF
	          IF (KEYCARD(1:3).EQ.'END') THEN
	            DONE=.TRUE.
	          END IF
C  If the EXTEND keycard exists, don't write it to the new header
C  Also, don't write the deprecated BLOCKED keyword.
	          IF (KEYCARD(1:6).NE.'EXTEND'.AND.
	1         KEYCARD(1:7).NE.'BLOCKED') THEN
	            CHARPHYSREC_2(IBPTR_WR:IBPTR_WR+79)=KEYCARD
	            IBPTR_WR=IBPTR_WR+80
	            IF (IBPTR_WR.EQ.2881) THEN
	              WRITE(LU_OUT,REC=IRWRITE,IOSTAT=ISTAT)
	1             (PHYSREC_2(I),I=1,IBLKLEN)
	              IF (ISTAT.NE.0) THEN
	                CALL ERROR(-3,'Error in writing physical record')
	                STATUS=2
	              END IF
	              IRWRITE=IRWRITE+1
	              IBPTR_WR=1
	              CHARPHYSREC_2=' '
	            END IF
	          END IF
	          IF (INAXIS_DETECT.EQ.0.OR.INAXIS_DETECT.EQ.1
	1         .OR.INAXIS_DETECT.EQ.4) IBPTR_RD=IBPTR_RD+80
	        END DO
	      END DO
C  Flush the buffer
	      IF (IBPTR_WR.NE.1) THEN
	        WRITE(LU_OUT,REC=IRWRITE,IOSTAT=ISTAT)
	1       (PHYSREC_2(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in writing physical record')
	          STATUS=2
	        END IF
	      END IF
C  Now copy the map data from the input file to the output file
	      NUMRECORDS(LU_OUT)=IRWRITE
	      IR_OUT=NUMRECORDS(LU_OUT)+1
	      WRITE(6,1000) NMAPS_OUT_EXISTING+1
	      WRITE(7,1000) NMAPS_OUT_EXISTING+1
	      IM=1 !  Just one input map
	      DO IRD=MAPRECORDS(1,IM,LU_IN),MAPRECORDS(2,IM,LU_IN)
	        READ(LU_IN,REC=IRD,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in reading physical record')
	          STATUS=2
	        END IF
	        WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1       (PHYSREC(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in writing physical record')
	          STATUS=2
	        END IF
	        IR_OUT=IR_OUT+1
	      END DO
C  End of section for NMAPS_IN_EXISTING equals 1
C
C
	    ELSE !  NMAPS_IN_EXISTING greater than 1
C  Just add map headers by copying header records.
	      IR_OUT=NUMRECORDS(LU_OUT)+1
	      DO N=1,NMAPS_IN
	        WRITE(6,1000) NMAPS_OUT_EXISTING+N
	        WRITE(7,1000) NMAPS_OUT_EXISTING+N
	        IM=MAPS_IN(N)
	        DO IRH=HEADERRECORDS(1,IM,LU_IN),HEADERRECORDS(2,IM,LU_IN)
	          READ(LU_IN,REC=IRH,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	          IF (ISTAT.NE.0) THEN
	            CALL ERROR(-3,'Error in reading physical record')
	            STATUS=2
	          END IF
	          WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1         (PHYSREC(I),I=1,IBLKLEN)
	          IF (ISTAT.NE.0) THEN
	            CALL ERROR(-3,'Error in writing physical record')
	            STATUS=2
	          END IF
	          IR_OUT=IR_OUT+1
	        END DO
	        DO IRD=MAPRECORDS(1,IM,LU_IN),MAPRECORDS(2,IM,LU_IN)
	          READ(LU_IN,REC=IRD,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	          IF (ISTAT.NE.0) THEN
	            CALL ERROR(-3,'Error in reading physical record')
	            STATUS=2
	          END IF
	          WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1         (PHYSREC(I),I=1,IBLKLEN)
	          IF (ISTAT.NE.0) THEN
	            CALL ERROR(-3,'Error in writing physical record')
	            STATUS=2
	          END IF
	          IR_OUT=IR_OUT+1
	        END DO
	      END DO
C  End of section for NMAPS_IN_EXISTING greater than 1
	    END IF
C  End of section for NMAPS_OUT_EXISTING equals 1
C
C
	  ELSE !  NMAPS_OUT_EXISTING greater than 1
	       !  The output file already has a primary header.
	    IF (NMAPS_IN_EXISTING.EQ.1) THEN
C  Modify the input header to make it an extension header and write
C  it to the output file.
	      WRITE(6,1000) NMAPS_OUT_EXISTING+1
	      WRITE(7,1000) NMAPS_OUT_EXISTING+1
	      IR_OUT=NUMRECORDS(LU_OUT)+1
	      IBPTR_WR=1
	      INAXIS_DETECT=0
	      DONE=.FALSE.
	      CHARPHYSREC_2=' ' !  ASCII blanks
	      DO IRH=HEADERRECORDS(1,1,LU_IN),HEADERRECORDS(2,1,LU_IN)
	        IBPTR_RD=1
	        READ(LU_IN,REC=IRH,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in reading physical record')
	          STATUS=2
	        END IF
	        DO WHILE(IBPTR_RD.LE.2801.AND..NOT.DONE)
	          IF (INAXIS_DETECT.EQ.0.OR.INAXIS_DETECT.EQ.1
	1         .OR.INAXIS_DETECT.EQ.4) THEN
	            KEYCARD=CHARPHYSREC(IBPTR_RD:IBPTR_RD+79)
	          END IF
C  Replace the SIMPLE keyword with XTENSION
	          IF (KEYCARD(1:6).EQ.'SIMPLE') THEN !  The first keycard
	            KEYCARD(1:80)=' '
	            KEYCARD(1:9)='XTENSION='
	            KEYCARD(11:20)='''IMAGE   '''
	            KEYCARD(31:48)=' / Image extension'
	          ELSE IF (KEYCARD(1:5).EQ.'NAXIS') THEN
	            INAXIS_DETECT=1
	          ELSE IF (INAXIS_DETECT.EQ.1.AND.
	1         KEYCARD(1:5).NE.'NAXIS') THEN
	            INAXIS_DETECT=2
	          END IF
C  After the NAXIS keywords come PCOUNT and GCOUNT
	          IF (INAXIS_DETECT.EQ.2) THEN
	            KEYCARD(1:80)=' '
	            KEYCARD(1:9)='PCOUNT  ='
	            KEYCARD(30:30)='0'
	            KEYCARD(31:33)=' / '
	            INAXIS_DETECT=3
	          ELSE IF (INAXIS_DETECT.EQ.3) THEN
	            KEYCARD(1:80)=' '
	            KEYCARD(1:9)='GCOUNT  ='
	            KEYCARD(30:30)='1'
	            KEYCARD(31:33)=' / '
	            INAXIS_DETECT=4
	            IBPTR_RD=IBPTR_RD-80
	          END IF
	          IF (KEYCARD(1:3).EQ.'END') THEN
	            DONE=.TRUE.
	          END IF
C  If the EXTEND keycard exists, don't write it to the new header
C  Also, don't write the deprecated BLOCKED keyword to the header.
	          IF (KEYCARD(1:6).NE.'EXTEND'.AND.
	1         KEYCARD(1:7).NE.'BLOCKED') THEN
	            CHARPHYSREC_2(IBPTR_WR:IBPTR_WR+79)=KEYCARD
	            IBPTR_WR=IBPTR_WR+80
	            IF (IBPTR_WR.EQ.2881) THEN
	              WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1             (PHYSREC_2(I),I=1,IBLKLEN)
	              IF (ISTAT.NE.0) THEN
	                CALL ERROR(-3,'Error in writing physical record')
	                STATUS=2
	              END IF
	              IR_OUT=IR_OUT+1
	              IBPTR_WR=1
	              CHARPHYSREC_2=' '
	            END IF
	          END IF
	          IF (INAXIS_DETECT.EQ.0.OR.INAXIS_DETECT.EQ.1
	1         .OR.INAXIS_DETECT.EQ.4) IBPTR_RD=IBPTR_RD+80
	        END DO
	      END DO
C  Flush the buffer
	      IF (IBPTR_WR.NE.1) THEN
	        WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1       (PHYSREC_2(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in writing physical record')
	          STATUS=2
	        END IF
	        IR_OUT=IR_OUT+1
	      END IF
	      DO IRD=MAPRECORDS(1,1,LU_IN),MAPRECORDS(2,1,LU_IN)
	        READ(LU_IN,REC=IRD,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in reading physical record')
	          STATUS=2
	        END IF
	        WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1       (PHYSREC(I),I=1,IBLKLEN)
	        IF (ISTAT.NE.0) THEN
	          CALL ERROR(-3,'Error in writing physical record')
	          STATUS=2
	        END IF
	        IR_OUT=IR_OUT+1
	      END DO
C
C
	    ELSE !  NMAPS_IN_EXISTING greater than 1
		 !  Just add map headers by copying header records.
	      IR_OUT=NUMRECORDS(LU_OUT)+1
	      DO N=1,NMAPS_IN
	        WRITE(6,1000) NMAPS_OUT_EXISTING+N
	        WRITE(7,1000) NMAPS_OUT_EXISTING+N
	        IM=MAPS_IN(N)
	        DO IRH=HEADERRECORDS(1,IM,LU_IN),HEADERRECORDS(2,IM,LU_IN)
	          READ(LU_IN,REC=IRH,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	          IF (ISTAT.NE.0) THEN
	            CALL ERROR(-3,'Error in reading physical record')
	            STATUS=2
	          END IF
	          WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1         (PHYSREC(I),I=1,IBLKLEN)
	          IF (ISTAT.NE.0) THEN
	            CALL ERROR(-3,'Error in writing physical record')
	            STATUS=2
	          END IF
	          IR_OUT=IR_OUT+1
	        END DO
	        DO IRD=MAPRECORDS(1,IM,LU_IN),MAPRECORDS(2,IM,LU_IN)
	          READ(LU_IN,REC=IRD,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	          IF (ISTAT.NE.0) THEN
	            CALL ERROR(-3,'Error in reading physical record')
	            STATUS=2
	          END IF
	          WRITE(LU_OUT,REC=IR_OUT,IOSTAT=ISTAT)
	1         (PHYSREC(I),I=1,IBLKLEN)
	          IF (ISTAT.NE.0) THEN
	            CALL ERROR(-3,'Error in writing physical record')
	            STATUS=2
	          END IF
	          IR_OUT=IR_OUT+1
	        END DO
	      END DO
	    END IF
	  END IF
C  Update the FITS COMMON block
	  CALL GET_FITS_INFO(LU_OUT)
	END IF
C
	RETURN
	END
