	PROGRAM TESTFITS
C
C       This program tests the various FITS subroutines in the MIIPS
C  FITS package.
C
C			Donald H. Gudehus, March, 2006
C			Version 1UM, D. Gudehus, Aug. 23, 2006
C			Modified USRINP for Absoft compiler on Mac OS X PPC
C			Version 2, D. Gudehus, January, 2008
C			Added examples for simple arithmetic and
C			simple cropping.
C
	INCLUDE 'miipspar.for'
	INCLUDE 'fitsfacts.for'
C
	CHARACTER*1 KEYWORD_CHOICE
	CHARACTER*3 FILEFMT,PRGFMAT
	CHARACTER*8 KEYWORD
	CHARACTER*40 FILEKEYWORD
	CHARACTER*80 FILENAME,CARD,MHFITSCRD,STRING,STRING2
	CHARACTER*68 CHFITSMHV
	INTEGER ITEST,IROWS(2),ICOLS(2),PLANEKEY,NPLNS,STATUS
	LOGICAL IOFL,IOFL_INQUIRE,DUPLICATE
	REAL*4 DATA(MAXSIZE),VALUE
	REAL*4 DATAXY(MAXSIZE,MAXSIZE)
	REAL*8 DATADP(MAXSIZE),VALUEDP,BSCALEDP,BZERODP
	REAL*8 DATADPXY(MAXSIZE,MAXSIZE)
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
	CALL GET_ENDIAN
C
	CALL MESSAGE('Enter the number of the FITS file test to perform:')
	CALL MESSAGE('     1 = Reads all or part of a row (default)')
	CALL MESSAGE('     2 = Plots a cut through a file')
	CALL MESSAGE('     3 = Reads an xy area')
	CALL MESSAGE('     4 = Displays an image on SAOimage '//
	1'(Enhanced version)')
	CALL MESSAGE('     5 = Writes all or part of a row for a new or '//
	1'existing file')
	CALL MESSAGE('     6 = Writes an xy area for a new or existing file')
	CALL MESSAGE('     7 = Performs simple rotations on a file')
	CALL MESSAGE('     8 = Performs simple arithmetic on a file')
	CALL MESSAGE('     9 = Performs a simple crop on a file')
	CALL MESSAGE('    10 = Copies one or more maps (image extensions) '//
	1'from one file to another')
	CALL MESSAGE('    11 = Copies a set of maps from one file to a '//
	1'set of planes in another file')
	CALL MESSAGE('    12 = Prints the header')
	CALL MESSAGE('    13 = Writes a COMMENT or HISTORY keycard to the '//
	1'header of an existing file')
	CALL MESSAGE('    14 = Updates or creates a keycard with a string '//
	1'value, e.g., AUTHOR,')
	CALL MESSAGE('         CTYPEn, BUNIT, DATE, DATE-OBS, etc.')
	CALL MESSAGE('    15 = Updates or creates the BSCALE and BZERO '//
	1'keycards for an existing file')
	CALL MESSAGE('    16 = Replaces a keycard with blanks')
	CALL MESSAGE('    17 = Quits')
	ITEST=1
	CALL USRINP(ITEST,1,'I',4,1,'ITEST=',' ')
	LU=11
C  Initialize some variables for the options whose code is within this
C  program
	IF (ITEST.EQ.1.OR.ITEST.EQ.3.OR.ITEST.EQ.5
	1.OR.ITEST.EQ.6.OR.ITEST.EQ.12.OR.ITEST.EQ.13.OR.ITEST.EQ.14.OR.ITEST
	2.EQ.15.OR.ITEST.EQ.16) THEN
	  FILEKEYWORD='FILE='
	  FILENAME=' '
	  IOFL=.TRUE.
	  MAPKEY=0
	  IF (ITEST.EQ.12.OR.ITEST.EQ.13.OR.ITEST.EQ.14.OR.ITEST.EQ.15
	1 .OR.ITEST.EQ.16) THEN
C  If we are reading the map header or writing to it, it doesn't matter what
C  the plane number is
	    PLANEKEY=1
	  ELSE
C  For the other tests, we let OPENFITS prompt for the plane number
	    PLANEKEY=0
	  END IF
	  NMAPS=0
	  NPLNS=0
	  NROWS=0
	  NCOLS=0
	  PRGFMAT=' '
	  IF (ITEST.EQ.5.OR.ITEST.EQ.6) THEN
C  This question is not absolutely necessary.  We could more simply
C  just call OPENFITS with IOFL=.FALSE. to cover any possible case,
C  however then the default map number would be one after the last one
C  if the map actually did exist.
	    IOFL_INQUIRE=.TRUE.
	    CALL USRINP(IOFL_INQUIRE,1,'L',4,1,'IOFL=',
	1   'Does the map storage exist?  (default = Y)')
	    IOFL=IOFL_INQUIRE
	  END IF
	  CALL OPENFITS(LU,IOFL,FILEKEYWORD,FILENAME,MAPKEY,PLANEKEY,NMAPS,
	1 NPLNS,NCOLS,NROWS,PRGFMAT,STATUS)
C  Eliminate cases which are not handled by this package
	  IF (ITEST.NE.12) THEN
	    DO M=1,NMAPS
	      IF (NAXIS(M,LU).NE.1.AND.NAXIS(M,LU).NE.2.AND.
	1     NAXIS(M,LU).NE.3) THEN
	        CALL ERROR(-4,'Sorry, NAXIS must be 1, 2, or 3!')
	      END IF
	    END DO
	  END IF
	END IF
C  Stop if for certain cases, the file does not exist 
	IF ((ITEST.EQ.1.OR.ITEST.EQ.3.OR.ITEST.EQ.12.OR.ITEST.EQ.13.OR.
	1ITEST.EQ.14.OR.ITEST.EQ.15.OR.ITEST.EQ.16).AND.STATUS.EQ.1) STOP
C  Determine which display and plot devices are available
	IF (ITEST.EQ.2.OR.ITEST.EQ.4) CALL GET_DP_AVAILABILITY
C
	FILEFMT=CHFITSMHV(LU,IMNUM,'BITPIX','R4')
	IF (ITEST.EQ.1.) THEN
	  IROW=1
	  CALL USRINP(IROW,1,'I',4,1,'IROW=',
	1 'Enter the row number:  (default = 1)')	
	  CALL USRINP(ICOLS,2,'I',4,0,'COLUMNS=',
	1 'Enter the start column and end column:')
	  IF (FILEFMT.EQ.'I1'.OR.FILEFMT.EQ.'I2'.OR.FILEFMT.EQ.'I4'.OR.
	1 FILEFMT.EQ.'R4'.OR.FILEFMT.EQ.'C8') THEN
	    CALL RDFITSROW(LU,IMNUM,IPNUM,DATA,MAXSIZE,IROW)
	    CALL MESSAGE('COLUMN       VALUE')
	    DO I=ICOLS(1),ICOLS(2)
	      WRITE(6,1005) I,DATA(I)
1005	      FORMAT(' ',2X,I4,4X,G15.7)
	      WRITE(7,1005) I,DATA(I)
	    END DO
	  ELSE IF (FILEFMT.EQ.'R8'.OR.FILEFMT.EQ.'C16') THEN
	    CALL RDDPFITSROW(LU,IMNUM,IPNUM,DATADP,MAXSIZE,IROW)
	    CALL MESSAGE('COLUMN       VALUE')
	    DO I=ICOLS(1),ICOLS(2)
	      WRITE(6,1010) I,DATADP(I)
1010	      FORMAT(' ',2X,I4,4X,G25.16)
	      WRITE(7,1010) I,DATADP(I)
	    END DO
	  END IF
	ELSE IF (ITEST.EQ.2) THEN
	  CALL LINEPL_FITS(STATUS)
	ELSE IF (ITEST.EQ.3) THEN
	  CALL USRINP(ICOLS,2,'I',4,0,'COLUMNS=',
	1 'Enter the start column and end column:')
	  CALL USRINP(IROWS,2,'I',4,0,'ROWS=',
	1 'Enter the start row and end row:')
	  NX=ICOLS(2)-ICOLS(1)+1
	  NY=IROWS(2)-IROWS(1)+1
	  IF (FILEFMT.EQ.'I1'.OR.FILEFMT.EQ.'I2'.OR.FILEFMT.EQ.'I4'.OR.
	1 FILEFMT.EQ.'R4'.OR.FILEFMT.EQ.'C8') THEN
	    CALL RDFITSXY(LU,IMNUM,IPNUM,DATAXY,MAXSIZE,MAXSIZE,
	1   ICOLS(1),NX,IROWS(1),NY)
	    DO J=1,NY
	      WRITE (6,1015) IROWS(1)+J-1
1015	      FORMAT(' ','ROW =',I5)
	      WRITE (7,1015) IROWS(1)+J-1
	      DO I=1,NX
	        WRITE (6,1020) ICOLS(1)+I-1,DATAXY(I,J)
1020	        FORMAT(' ','COLUMN =',I5,4X,'VALUE = ',G15.7)
	        WRITE (7,1020) ICOLS(1)+I-1,DATAXY(I,J)
	      END DO
	    END DO
	  ELSE IF (FILEFMT.EQ.'R8'.OR.FILEFMT.EQ.'C16') THEN
	    CALL RDDPFITSXY(LU,IMNUM,IPNUM,DATADPXY,MAXSIZE,MAXSIZE,ICOLS(1),
	1   NX,IROWS(1),NY)
	    DO J=1,NY
	      WRITE (6,1015) IROWS(1)+J-1
	      WRITE (7,1015) IROWS(1)+J-1
	      DO I=1,NX
	        WRITE (6,1030) ICOLS(1)+I-1,DATADPXY(I,J)
1030	        FORMAT(' ','COLUMN =',I5,4X,'VALUE = ',G25.16)
	        WRITE (7,1030) ICOLS(1)+I-1,DATADPXY(I,J)
	      END DO
	    END DO
	  END IF
	ELSE IF (ITEST.EQ.4) THEN
	  CALL FITS_TO_SAO
	ELSE IF (ITEST.EQ.5) THEN
	  IROW=1
	  CALL USRINP(IROW,1,'I',4,1,'IROW=',
	1 'Enter the row number:  (default = 1)')
	  CALL USRINP(ICOLS,2,'I',4,0,'COLUMNS=',
	1 'Enter the start column and end column:')
	  IF (FILEFMT.EQ.'I1'.OR.FILEFMT.EQ.'I2'.OR.FILEFMT.EQ.'I4'.OR.
	1 FILEFMT.EQ.'R4'.OR.FILEFMT.EQ.'C8') THEN
	    CALL RDFITSROW(LU,IMNUM,IPNUM,DATA,MAXSIZE,IROW)
	    CALL USRINP(VALUE,1,'F',4,0,'VALUE=','Enter the value:')
	    DO I=ICOLS(1),ICOLS(2)
	      DATA(I)=VALUE
	    END DO
	    CALL WRFITSROW(LU,IMNUM,IPNUM,DATA,MAXSIZE,IROW)
	  ELSE IF (FILEFMT.EQ.'R8'.OR.FILEFMT.EQ.'C16') THEN
	    CALL RDDPFITSROW(LU,IMNUM,IPNUM,DATADP,MAXSIZE,IROW)
	    CALL USRINP(VALUEDP,1,'F',8,0,'VALUE=','Enter the value:')
	    DO I=ICOLS(1),ICOLS(2)
	      DATADP(I)=VALUEDP
	    END DO
	    CALL WRDPFITSROW(LU,IMNUM,IPNUM,DATADP,MAXSIZE,IROW)
	  END IF
	ELSE IF (ITEST.EQ.6) THEN
	  CALL USRINP(ICOLS,2,'I',4,0,'COLUMNS=',
	1 'Enter the start column and end column:')
	  CALL USRINP(IROWS,2,'I',4,1,'ROWS=',
	1 'Enter the start row and end row:')
	  NX=ICOLS(2)-ICOLS(1)+1
	  NY=IROWS(2)-IROWS(1)+1
	  IF (FILEFMT.EQ.'I1'.OR.FILEFMT.EQ.'I2'.OR.FILEFMT.EQ.'I4'.OR.
	1 FILEFMT.EQ.'R4'.OR.FILEFMT.EQ.'C8') THEN
	    CALL USRINP(VALUE,1,'F',4,0,'VALUE=','Enter the value:')
	    DO J=1,NY
	      DO I=1,NX
	        DATAXY(I,J)=VALUE
	      END DO
	    END DO
	    CALL WRFITSXY(LU,IMNUM,IPNUM,DATAXY,MAXSIZE,MAXSIZE,ICOLS(1),
	1   NX,IROWS(1),NY)
	  ELSE IF (FILEFMT.EQ.'R8'.OR.FILEFMT.EQ.'C16') THEN
	    CALL USRINP(VALUEDP,1,'F',8,0,'VALUE=','Enter the value:')
	    DO J=1,NY
	      DO I=1,NX
	        DATADPXY(I,J)=VALUEDP
	      END DO
	    END DO
	    CALL WRDPFITSXY(LU,IMNUM,IPNUM,DATADPXY,MAXSIZE,MAXSIZE,ICOLS(1),
	1   NX,IROWS(1),NY)
	  END IF
	ELSE IF (ITEST.EQ.7) THEN
	  CALL ROTATE_FITS_SIMPLE
	ELSE IF (ITEST.EQ.8) THEN
	  CALL ARITHMETIC_FITS_SIMPLE
	ELSE IF (ITEST.EQ.9) THEN
	  CALL CROP_FITS_SIMPLE
	ELSE IF (ITEST.EQ.10) THEN
	  CALL COPY_FITS_MAPS
	ELSE IF (ITEST.EQ.11) THEN
	  CALL FITS_MAPS_TO_PLANES
	ELSE IF (ITEST.EQ.12) THEN
	  CARD=' '
	  NKEY=1
	  NKEY_NONBLANK=1
	  IF (NUMMAPS(LU).GT.1) THEN
	    CALL MESSAGE('*** Primary Header ***')
	    DO WHILE(CARD.NE.'That''s all')
	      CARD=MHFITSCRD(LU,0,NKEY,'That''s all')
	      CALL MESSAGE(CARD)
	      NKEY=NKEY+1
	      IF (CARD.NE.' ') NKEY_NONBLANK=NKEY_NONBLANK+1
	    END DO
	    NKEY=NKEY-1
	    NKEY_NONBLANK=NKEY_NONBLANK-1
	    WRITE (6,1040) NKEY
1040	    FORMAT(' ','There are ',I4,' keycards, including the END ',
	1   'keycard, in the primary header')
	    WRITE (7,1040) NKEY
	    WRITE (6,1041) NKEY_NONBLANK
1041	    FORMAT(' ','Of these, ',I4,' are nonblank')
	    WRITE (7,1041) NKEY_NONBLANK
	  END IF
	  CALL MESSAGE('*** Map Header ***')
	  CARD=' '
	  NKEY=1
	  NKEY_NONBLANK=1
	  DO WHILE(CARD.NE.'That''s all')
	    CARD=MHFITSCRD(LU,IMNUM,NKEY,'That''s all')
	    CALL MESSAGE(CARD)
	    NKEY=NKEY+1
	    IF (CARD.NE.' ') NKEY_NONBLANK=NKEY_NONBLANK+1
	  END DO
	  NKEY=NKEY-1
	  NKEY_NONBLANK=NKEY_NONBLANK-1
	  WRITE (6,1045) NKEY
1045	  FORMAT(' ','There are ',I4,' keycards, including the END ',
	1 'keycard, in the map header')
	  WRITE (7,1045) NKEY
	  WRITE (6,1041) NKEY_NONBLANK
	  WRITE (7,1041) NKEY_NONBLANK
	ELSE IF (ITEST.EQ.13) THEN
	  KEYWORD_CHOICE='C'
	  CALL MESSAGE('Enter a keyword choice:')
	  CALL MESSAGE('     C = COMMENT (default)')
	  CALL MESSAGE('     H = HISTORY')
	  CALL USRINP_CHAR(1,'A',1,1,'KEYWORD_CHOICE=',' ',
	1 %REF(KEYWORD_CHOICE))
	  DUPLICATE=.TRUE.
	  CALL USRINP(DUPLICATE,1,'L',4,1,'DUPLICATE=',
	1 'Do you want to create/duplicate (T = default) or replace (F) a '//
	2 'keycard?')
	  CALL USRINP_CHAR(1,'A',80,0,'STRING=',
	1 'Enter the text (up to 72 characters):',%REF(STRING))
	  CALL ALPHA(%REF(STRING),1,80,NCHAR,NFULL,NREST,2)
	  STRING2=' '
	  IF (KEYWORD_CHOICE.EQ.'C') THEN
	    CALL WRFITSMHST(LU,IMNUM,'COMMENT',STRING,'C',STRING2,DUPLICATE)
	  ELSE IF (KEYWORD_CHOICE.EQ.'H') THEN
	    CALL WRFITSMHST(LU,IMNUM,'HISTORY',STRING,'C',STRING2,DUPLICATE)
	  END IF
	ELSE IF (ITEST.EQ.14) THEN
	  DUPLICATE=.FALSE.
	  CALL USRINP_CHAR(1,'A',8,0,'KEYWORD=',
	1 'Enter the desired keyword:',%REF(KEYWORD))
	  CALL ALPHA(%REF(KEYWORD),1,8,NCHAR,NFULL,NREST,2)
	  DUPLICATE=.TRUE.
	  CALL USRINP(DUPLICATE,1,'L',4,1,'DUPLICATE=',
	1 'Do you want to create (T = default) or update (F) a '//
	2 'keycard?')
	  CALL USRINP_CHAR(1,'A',80,0,'STRING_VALUE=',
	1 'Enter a value (up to 20 characters):',%REF(STRING))
	  CALL ALPHA(%REF(STRING),1,80,NCHAR,NFULL,NREST,2)
	  CALL USRINP_CHAR(1,'A',80,0,'STRING_COMMENT=',
	1 'Enter a comment (up to 47 characters):',%REF(STRING2))
	  CALL ALPHA(%REF(STRING2),1,80,NCHAR,NFULL,NREST,2)
	  CALL WRFITSMHST(LU,IMNUM,KEYWORD,STRING,'C',STRING2,DUPLICATE)
	ELSE IF (ITEST.EQ.15) THEN
	  DUPLICATE=.FALSE.
	  BSCALEDP=1.0D0
	  CALL USRINP(BSCALEDP,1,'F',8,1,'BSCALE=',
	1 'Enter a value for BSCALE (default = 1.0)')
	  CALL WRFITSMHV(LU,IMNUM,'BSCALE',BSCALEDP,'R8',
	1 'Scaling factor',.FALSE.)
	  BZERODP=0.0D0
	  CALL USRINP(BZERODP,1,'F',8,1,'BZERO=',
	1 'Enter a value for BZERO (default = 0.0)')
	  CALL WRFITSMHV(LU,IMNUM,'BZERO',BZERODP,'R8','Zero offset',DUPLICATE)
	ELSE IF (ITEST.EQ.16) THEN
	  DUPLICATE=.FALSE.
	  CALL USRINP_CHAR(1,'A',8,0,'KEYWORD=',
	1 'Enter the desired keyword:',%REF(KEYWORD))
	  CALL ALPHA(%REF(KEYWORD),1,8,NCHAR,NFULL,NREST,2)
	  STRING=' '
	  STRING2=' '
	  CALL WRFITSMHST(LU,IMNUM,KEYWORD,STRING,'X',STRING2,DUPLICATE)
	ELSE IF (ITEST.EQ.17) THEN
	  STOP
	END IF
C
	IF (ITEST.NE.2.AND.ITEST.NE.4.AND.ITEST.NE.7.AND.ITEST.NE.8
	1.AND.ITEST.NE.9.AND.ITEST.NE.10.AND.ITEST.NE.11)
	2CALL CLOSEFITS(11)
	END
