	CHARACTER*(*) FUNCTION MHFITSCRD(LU,MAP_NUMBER,NKEY,DEFAULT)
C
C       This function returns a header line from a FITS header. 
C			Donald H. Gudehus, February 28, 2006
C
C	LU		(C)	The logical unit that the file was opened on
C	MAP_NUMBER	(C)	The map number within the file.  If more than
C				one map exists, then there will also be a
C				primary header which can be referenced with
C				MAP_NUMBER=0.
C	NKEY		(C)	The number of the keycard to be read
C	DEFAULT         (C/R)   The value to be returned if keyword undefined
C
	CHARACTER*(*) DEFAULT
C
	INCLUDE 'fitsfacts.for'
C
	BYTE PHYSREC(3000)
	CHARACTER*80 KEYCARD
	CHARACTER*3000 CHARPHYSREC
	EQUIVALENCE (PHYSREC,CHARPHYSREC)
C
	IF (LU.LT.LUMIN.OR.LU.GT.LUMAX) THEN
	  CALL ERROR(-4,'LU out of range in CHFITSMHV')
	END IF
	IF (MAP_NUMBER.LT.0.OR.MAP_NUMBER.GT.NUMMAPS(LU))
	1CALL ERROR(-4,'MAP_NUMBER out of range in CHFITSMHV')
	IBLKLEN=2880
C
C  Search through the header
	KEYCARD=' '
	IR=HEADERRECORDS(1,MAP_NUMBER,LU)
	IK=1
	IFOUND=0
	DO WHILE(KEYCARD(1:3).NE.'END'.AND.IK.LE.NKEY)
	  IBPTR=1
	  READ(LU,REC=IR,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	  IF (ISTAT.NE.0) THEN
	    CALL ERROR(-3,'Error in reading physical record')
	  END IF
	  DO WHILE(KEYCARD(1:3).NE.'END'.AND.IBPTR.LE.2801.AND.
	1 IK.LE.NKEY)
	    IF (IK.EQ.NKEY) THEN
	      KEYCARD=CHARPHYSREC(IBPTR:IBPTR+79)
C  Eliminate control characters
	      DO I=1,80
	        IF (ICHAR(KEYCARD(I:I)).LT.32) KEYCARD(I:I)=' '
	      END DO
	      MHFITSCRD=KEYCARD
	      IFOUND=1
	    END IF
	    IBPTR=IBPTR+80
	    IK=IK+1
	  END DO
	  IR=IR+1
	END DO
C
	IF (IFOUND.NE.1.OR.KEYCARD.EQ.'END') MHFITSCRD=DEFAULT
C
	RETURN
	END
