	FUNCTION ALOGCODE(DECODE,FLAG)
C
C	This function codes a log value into the log, antilog 
C  combination used by ALOGAXIS.FOR and XYPLOT.FOR. 
C				Donald H. Gudehus, October, 1985
C
C	DECODE	(C)	A logarithmic value to be coded
C	FLAG	(C)	A flag such that when equal to 0, a straight
C			coding takes place;  when equal to 1, the
C			antilog multiple is rounded down to the next
C			integer multiple;  when equal to 2, the antilog
C			multiple is rounded up.
C
	INTEGER FLAG
	LOGICAL NEGATIVE
C
	NEGATIVE=.FALSE.
	IF (DECODE.LT.0.0) THEN
	  NEGATIVE=.TRUE.
	  FRACPART=DECODE-INT(DECODE)
	  OFFSET=INT(1.0+ABS(DECODE))
	  IF (FRACPART.EQ.0.0) OFFSET=OFFSET-1
	  DUMDECODE=DECODE+OFFSET  ! Makes it .GE. 0
	ELSE
	  DUMDECODE=DECODE
	END IF
C
	IF (FLAG.EQ.0) THEN
	  ALOGCODE=INT(DUMDECODE)+0.1*10.0**(DUMDECODE-INT(DUMDECODE))
	ELSE IF (FLAG.EQ.1) THEN
	  ALOGCODE=INT(DUMDECODE)+0.1*INT(10.0**(DUMDECODE-INT(DUMDECODE)))
	ELSE IF (FLAG.EQ.2) THEN
	  ALOGCODE=INT(DUMDECODE)+0.1*NHINT(10.0**(DUMDECODE-INT(DUMDECODE)))
	END IF
	IF (NEGATIVE) ALOGCODE=-ALOGCODE-OFFSET
	RETURN
	END
