	SUBROUTINE APPLEPLOT(COMMAND,SYMFIX,TEXT,XOFF,YOFF,SCALE,
	1COSR,SINR,ISTAT)
C
C  Note:  This is the Unix version
C
C       This subroutine is the online plot routine for the Apple
C  Laserwriter.  It takes the commands sent from the plot routines
C  and emulates a pen plotter.  This subroutine is called by
C  PLOTCOM.FOR.
C				Donald H. Gudehus, August, 1987
C		Version 2, Donald H. Gudehus, July, 1994
C		Applied scale factor to the pen width.
C		Version 3, Donald H. Gudehus, October, 1994
C		Eliminated code for unused commands
C		Version 4, Donald H. Gudehus, October, 1994
C		Added code for EPS
C		Version 4U, Donald H. Gudehus, February 5, 2000
C		Modified code for Unix
C
	COMMON /PLOT_CHAN/ NCHAN,NDEV
C
	COMMON /PLOT_LINESTYLE/ MODE
C
	COMMON /PLOT_DATALEVEL/ LEVEL
C
	COMMON /PLOT_FILLSTYLE/ FILL
C
	INTEGER WIDTH,OLDWIDTH
	COMMON /PLOT_PENWIDTH/ WIDTH
C
	LOGICAL LASERGRAFIX,APPLE0,APPLE2,APPLE3,APPLE4,APPLE5,APPLE6,
	1LPS40,EPS,POSTSCRIPT,IMAGEN0
	COMMON /LIB_/ LASERGRAFIX,APPLE0,APPLE2,APPLE3,APPLE4,APPLE5,APPLE6,
	1LPS40,EPS,POSTSCRIPT,IMAGEN0
C
	BYTE COMMAND(0:4),OPCODE,BCOM(4),TEXT(1)
	INTEGER*2 SYMFIX(0:2),I2COM(0:1)
	INTEGER*2 XORIGIN,YORIGIN,XPOS,YPOS,XCH,YCH,
	1XOFF,YOFF,DELX,DELY,NBS,DELXBS,DELYBS
	INTEGER*4 NEW(2),FILL
	LOGICAL PLOTIT,ENGLISH,GREEK,NORMAL,SUBSCRIPT,SUPERSCRIPT
	REAL FACTOR,R4COM,SCALE,TEMP(2)
	EQUIVALENCE (BCOM,I2COM(0),R4COM)
C
	INCLUDE 'plotpar.for'
C
	ISTAT=SSP$_NORMAL
	DO I=1,4
	  BCOM(I)=COMMAND(I)
	END DO
C
C  Get the opcode.
C
	OPCODE=COMMAND(PLT$B_OPC).AND.PLT$M_OPC
C
C  Endfile and endplot
C
	IF (OPCODE.EQ.PLT$OP_ENDFILE) THEN
	  ISTAT=PLT$S_ENDFILE
C  For on-line plotting, the following code is used.  When using the 
C  PLOT command, the code in PLOTCOM.FOR is used.
	  IF (APPLE0) THEN
c	    CALL LIB$DO_COMMAND('$PRINT/QUEUE=APPLELASERWRITER VECT.RPL/DEL')
	    APPLE0=.FALSE.
	  ELSE IF (APPLE2) THEN
c	    CALL LIB$DO_COMMAND('$PRINT/QUEUE=APPLELASERWRITER2 VECT.RPL/DEL')
C	    CALL LIB$DO_COMMAND('$PRINT/QUEUE=ALW/DEL VECT.RPL')
C	    CALL LIB$DO_COMMAND('$SUNPRINT VECT.RPL 2046 /DEL')
C  At Univ. of Michigan, the SUNPRINT command directed LaserWriters in
C  rooms 753 in Dennison, and rooms 1059, 2046, 2065, 3038, 3071, and 
C  4075 to produce output.
	    APPLE2=.FALSE.
	  ELSE IF (APPLE3) THEN
c	    CALL LIB$DO_COMMAND('$PRINT/QUEUE=APPLELASERWRITER3 VECT.RPL/DEL')
	    APPLE3=.FALSE.
	  ELSE IF (APPLE4) THEN
c	    CALL LIB$DO_COMMAND('$PRINT/QUEUE=APPLELASERWRITER4 VECT.RPL/DEL')
	    APPLE4=.FALSE.
	  ELSE IF (APPLE5) THEN
c	    CALL LIB$DO_COMMAND('$PRINT/QUEUE=APPLELASERWRITER5 VECT.RPL/DEL')
	    APPLE5=.FALSE.
	  ELSE IF (APPLE6) THEN
c	    CALL LIB$DO_COMMAND('$PRINT/QUEUE=APPLELASERWRITER6 VECT.RPL/DEL')
	    APPLE6=.FALSE.
	  ELSE IF (LPS40) THEN
c	    CALL LIB$DO_COMMAND('$PRINT/QUEUE=LPS40/DEL VECT.RPL')
	    LPS40=.FALSE.
	  ELSE IF (EPS) THEN
C  Don't do anything, since it is to be transported as a file.
	    EPS=.FALSE.
	  ELSE IF (POSTSCRIPT) THEN
C  Don't do anything, since it is to be transported as a file.
	    POSTSCRIPT=.FALSE.
	  END IF
	ELSE IF (OPCODE.EQ.PLT$OP_ENDPLOT) THEN
	  XPOS=I2COM(PLT$W_X)
	  YPOS=I2COM(PLT$W_Y)
	  ISTAT=PLT$S_ENDPLOT
	  CALL APPLE(0,0,15)
	  CALL APPLE(0,0,4)  ! Resets the graphics setups for the laserprinter
			     ! since these get erased when a page is printed.
	ELSE IF (OPCODE.EQ.PLT$OP_ENDALPHA) THEN
	  ISTAT=PLT$S_ENDALPHA
C
C  Plot (pen down)
C
	ELSE IF (OPCODE.EQ.PLT$OP_PLOTDOWN) THEN
	  XPOS=I2COM(PLT$W_X)
	  YPOS=I2COM(PLT$W_Y)
C  We do not multiply by PLT$C_APPLEPIX because this number is 1.  In
C  APPLE.FOR we convert to points and make the code independent of the
C  resolution of the device.
	  TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)
	  TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)
	  NEW(1)=NINT(COSR*TEMP(1)-SINR*TEMP(2))
	  NEW(2)=NINT(SINR*TEMP(1)+COSR*TEMP(2))
	  CALL LIMIT(NEW(1),PLT$C_APPLEXPIX,NEW(2),PLT$C_APPLEYPIX,
	1 PLOTIT)
	  IF (PLOTIT) CALL APPLE(NEW(1),NEW(2),2)
C
C  Move (pen up)
C
	ELSE IF (OPCODE.EQ.PLT$OP_PLOTUP) THEN
	  XPOS=I2COM(PLT$W_X)
	  YPOS=I2COM(PLT$W_Y)
	  TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)
	  TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)
	  NEW(1)=NINT(COSR*TEMP(1)-SINR*TEMP(2))
	  NEW(2)=NINT(SINR*TEMP(1)+COSR*TEMP(2))
	  CALL LIMIT(NEW(1),PLT$C_APPLEXPIX,NEW(2),PLT$C_APPLEYPIX,
	1 PLOTIT)
	  CALL APPLE(NEW(1),NEW(2),3)
C
C  Plot text string
C
	ELSE IF (OPCODE.EQ.PLT$OP_SYMBOL) THEN
	  ANGLE=SYMFIX(PLT$W_ANGLE)
	  COSA=COSD(ANGLE)
	  SINA=SIND(ANGLE)
	  ENGLISH=.TRUE.
	  GREEK=.FALSE.
	  NORMAL=.TRUE.
	  SUBSCRIPT=.FALSE.
	  SUPERSCRIPT=.FALSE.
C  Determine DELX and DELY for the initial location
	  I=1
	  NBS=0  ! Initializes the number of backspaces
	  CALL TEXTCNCH(TEXT,I2COM,I,NBS,ENGLISH,GREEK,NORMAL,SUBSCRIPT,
	1 SUPERSCRIPT,SINA,COSA,DELX,DELY,SSF,DELXBS,DELYBS)
	  IF ((COMMAND(PLT$B_OPC).AND.PLT$M_SYMBCONT).EQ.0) THEN
				! First character of string
	    XPOS=SYMFIX(PLT$W_SYMBX)+DELX
	    YPOS=SYMFIX(PLT$W_SYMBY)+DELY
	    TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)
	    TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)
	    NEW(1)=NINT(COSR*TEMP(1)-SINR*TEMP(2))
	    NEW(2)=NINT(SINR*TEMP(1)+COSR*TEMP(2))
	    CALL LIMIT(NEW(1),PLT$C_APPLEXPIX,NEW(2),
	1   PLT$C_APPLEYPIX,PLOTIT)
	    IF (SUBSCRIPT.OR.SUPERSCRIPT) THEN
	      IF (WIDTH.EQ.0) WIDTH=20
	      OLDWIDTH=WIDTH  ! Mills
	      WIDTH=INT(0.75*WIDTH)
	      CALL APPLE(0,0,12)  ! A call to PENMODE would produce a recursive
				  ! operation
	    END IF

	    CALL APPLE(NEW(1),NEW(2),3)
	  END IF
	  DO WHILE (I.LE.I2COM(PLT$W_NBYT))
	    IF (SUBSCRIPT.OR.SUPERSCRIPT) THEN
	      IF (WIDTH.EQ.0) WIDTH=20
	      OLDWIDTH=WIDTH
	      WIDTH=INT(0.75*WIDTH)
	      CALL APPLE(0,0,12)
	    END IF
	    IF (ENGLISH) THEN
	      CALL GETSYM(TEXT(I),NVECS)
	    ELSE IF (GREEK) THEN
	      CALL GETSYMGR(TEXT(I),NVECS)
	    END IF
	    IF (NVECS.GT.0) THEN
	      DO 450 J=1,NVECS
	        IF (ENGLISH) THEN
	          CALL VECSYM(J,XCH,YCH,IPEN)
	        ELSE IF (GREEK) THEN
	          CALL VECSYMGR(J,XCH,YCH,IPEN)
	        END IF
C  Note that PLT$C_CHARSIZE enters into the expression below because
C  it is necessary to scale down by the reciprocal of the maximum
C  value of YCH, 7.
	        TEMP(1)=((((XCH*COSA-YCH*SINA)*I2COM(PLT$W_HEIGHT)
	1       *PLT$C_CHARSIZE*SSF+XPOS)*FACTOR+XORIGIN)
	2       *SCALE-XOFF)
	        TEMP(2)=((((XCH*SINA+YCH*COSA)*I2COM(PLT$W_HEIGHT)
	1       *PLT$C_CHARSIZE*SSF+YPOS)*FACTOR+YORIGIN)
	2       *SCALE-YOFF)
	        NEW(1)=NINT(COSR*TEMP(1)-SINR*TEMP(2))
	        NEW(2)=NINT(SINR*TEMP(1)+COSR*TEMP(2))
	        CALL LIMIT(NEW(1),PLT$C_APPLEXPIX,NEW(2),
	1       PLT$C_APPLEYPIX,PLOTIT)
	        IF (IPEN) THEN
	          IF (PLOTIT) CALL APPLE(NEW(1),NEW(2),2)
	        ELSE
	          CALL APPLE(NEW(1),NEW(2),3)
	        END IF
 450	      CONTINUE  ! Ends loop for constructing a single character
	    END IF
	    IF (SUBSCRIPT.OR.SUPERSCRIPT) THEN
	      WIDTH=OLDWIDTH
	      CALL APPLE(0,0,12)
	    END IF
C  Advance to the next character location
	    XPOS=XPOS-DELX+DELXBS
	    YPOS=YPOS-DELY+DELYBS
	    I=I+1
	    NBS=0
	    CALL TEXTCNCH(TEXT,I2COM,I,NBS,ENGLISH,GREEK,NORMAL,
	1   SUBSCRIPT,SUPERSCRIPT,SINA,COSA,DELX,DELY,SSF,DELXBS,DELYBS)
	    XPOS=6*COSA*I2COM(PLT$W_HEIGHT)*PLT$C_CHARSIZE+XPOS+DELX
	    YPOS=6*SINA*I2COM(PLT$W_HEIGHT)*PLT$C_CHARSIZE+YPOS+DELY
	    TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)
	    TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)
	    NEW(1)=NINT(COSR*TEMP(1)-SINR*TEMP(2))
	    NEW(2)=NINT(SINR*TEMP(1)+COSR*TEMP(2))
	    CALL LIMIT(NEW(1),PLT$C_APPLEXPIX,NEW(2),PLT$C_APPLEYPIX,
	1   PLOTIT)
	    CALL APPLE(NEW(1),NEW(2),3)
	  END DO
	  IF (SUBSCRIPT.OR.SUPERSCRIPT) THEN
	    WIDTH=OLDWIDTH
	    CALL APPLE(0,0,12)
	  END IF
C  Set the plotting scale factor
C
	ELSE IF (OPCODE.EQ.PLT$OP_FACTOR) THEN
	  FACTOR=R4COM
C
C  Plot special symbol
C
	ELSE IF (OPCODE.EQ.PLT$OP_SYMBDOWN.OR.OPCODE.EQ.PLT$OP_SYMBUP) 
	1THEN
	  IF (OPCODE.EQ.PLT$OP_SYMBDOWN) THEN
	    XPOS=SYMFIX(PLT$W_SYMBX)
	    YPOS=SYMFIX(PLT$W_SYMBY)
	    TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)
	    TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)
	    NEW(1)=NINT(COSR*TEMP(1)-SINR*TEMP(2))
	    NEW(2)=NINT(SINR*TEMP(1)+COSR*TEMP(2))
	    CALL LIMIT(NEW(1),PLT$C_APPLEXPIX,NEW(2),
	1   PLT$C_APPLEYPIX,PLOTIT)
	    CALL APPLE(NEW(1),NEW(2),2)
	  ELSE IF ((COMMAND(PLT$B_OPC).AND.PLT$M_SYMBCONT).EQ.0) THEN
	    XPOS=SYMFIX(PLT$W_SYMBX)
	    YPOS=SYMFIX(PLT$W_SYMBY)
	    TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)
	    TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)
	    NEW(1)=NINT(COSR*TEMP(1)-SINR*TEMP(2))
	    NEW(2)=NINT(SINR*TEMP(1)+COSR*TEMP(2))
	    CALL LIMIT(NEW(1),PLT$C_APPLEXPIX,NEW(2),
	1   PLT$C_APPLEYPIX,PLOTIT)
	    CALL APPLE(NEW(1),NEW(2),3)
	  END IF
	  ANGLE=SYMFIX(PLT$W_ANGLE)
	  COSA=COSD(ANGLE)
	  SINA=SIND(ANGLE)
	  CALL SPECSYM(I2COM(PLT$W_SYMBNO),NVECS)
	  IF (NVECS.GT.0) THEN
	    DO 550 J=1,NVECS
	      CALL VECSYM(J,XCH,YCH,IPEN)
	      XCH=XCH-3
	      YCH=YCH-3
	      TEMP(1)=((((XCH*COSA-YCH*SINA)*I2COM(PLT$W_HEIGHT)
	1     *PLT$C_CHARSIZE+XPOS)*FACTOR+XORIGIN)
	2     *SCALE-XOFF)
	      TEMP(2)=((((XCH*SINA+YCH*COSA)*I2COM(PLT$W_HEIGHT)
	1     *PLT$C_CHARSIZE+YPOS)*FACTOR+YORIGIN)
	2     *SCALE-YOFF)
	      NEW(1)=NINT(COSR*TEMP(1)-SINR*TEMP(2))
	      NEW(2)=NINT(SINR*TEMP(1)+COSR*TEMP(2))
	      CALL LIMIT(NEW(1),PLT$C_APPLEXPIX,NEW(2),
	1     PLT$C_APPLEYPIX,PLOTIT)
	      IF (IPEN) THEN
	        IF (PLOTIT) CALL APPLE(NEW(1),NEW(2),2)
	      ELSE
	        CALL APPLE(NEW(1),NEW(2),3)
	      END IF
 550	    CONTINUE
	  END IF
	  XPOS=SYMFIX(PLT$W_SYMBX)
	  YPOS=SYMFIX(PLT$W_SYMBY)
	  TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)
	  TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)
	  NEW(1)=NINT(COSR*TEMP(1)-SINR*TEMP(2))
	  NEW(2)=NINT(SINR*TEMP(1)+COSR*TEMP(2))
	  CALL LIMIT(NEW(1),PLT$C_APPLEXPIX,NEW(2),PLT$C_APPLEYPIX,
	1 PLOTIT)
	  CALL APPLE(NEW(1),NEW(2),3)
C
C  Select the line style
C
	ELSE IF (OPCODE.EQ.PLT$OP_LINESTYLE) THEN
	  MODE=I2COM(PLT$B_LINESTYLE)
	  CALL APPLE(0,0,5)
C
C  Set the data level
C
	ELSE IF (OPCODE.EQ.PLT$OP_DATALEVEL) THEN
	  LEVEL=I2COM(PLT$B_DATALEVEL)
	  CALL APPLE(0,0,8)
C
C  Go to the point plot mode
C
	ELSE IF (OPCODE.EQ.PLT$OP_POINTPLOT) THEN
	  CALL APPLE(0,0,1)
C
C  Go to alphagraphics
C
	ELSE IF (OPCODE.EQ.PLT$OP_ALPHAGRAPHICS) THEN
	  CALL APPLE(0,0,10)
C
C  Go to rectilinear graphics
C
	ELSE IF (OPCODE.EQ.PLT$OP_RECTILINEAR) THEN
	  CALL APPLE(0,0,9)
C
C  Set the filling style
C
	ELSE IF (OPCODE.EQ.PLT$OP_FILLSTYLE) THEN
	  FILL=I2COM(PLT$B_FILLSTYLE)
C
C  Select the pen width
C
	ELSE IF (OPCODE.EQ.PLT$OP_PENWIDTH) THEN
	  WIDTH=I2COM(PLT$B_PENWIDTH)*SCALE
	  CALL APPLE(0,0,12)
C
C  Reorigin
C
	ELSE IF (OPCODE.EQ.PLT$OP_ORIG) THEN
	  IF (I2COM(PLT$W_X).EQ.(-50*PLT$C_NIBS)) THEN
	    XORIGIN=0
	    YORIGIN=0
	  ELSE IF (I2COM(PLT$W_X).EQ.(-50*PLT$C_OLDNIBS)) THEN
	    XORIGIN=0
	    YORIGIN=0
	    FACTOR=FACTOR*2.362205  ! 600/254
	  ELSE
	    XORIGIN=XORIGIN+I2COM(PLT$W_X)*FACTOR
	    YORIGIN=YORIGIN+I2COM(PLT$W_Y)*FACTOR
	  END IF
	END IF
	RETURN
	END
