	SUBROUTINE COLOR_24_TRIPLET(C24,RED,GREEN,BLUE,KEY)
C
C  Note:  This is the Unix version
C
C       This subroutine converts a 24-bit color into three 8-bits colors
C  and vice versa.
C			Donald H. Gudehus, April 19, 2000
C
C	C24	(C/R)	The 24-bit color
C	RED	(C/R)	The red 8-bit color
C	GREEN	(C/R)	The green 8-bit color
C	BLUE	(C/R)	The blue 8-bit color
C	KEY	(C)	The key which controls the operation.  If KEY=0
C			the 24-bit color is converted into three 8-bit colors.
C			If KEY=1, three 8-bit colors are converted into one
C			24-bit color.
C
	INTEGER C24,RED,GREEN,BLUE,KEY
	INCLUDE 'plotpar.for'
C
	IF (KEY.EQ.0) THEN
	  RED=IAND(PLT$M_THIRDBYTE,C24)/256**2
	  GREEN=IAND(PLT$M_SECONDBYTE,C24)/256
	  BLUE=IAND(PLT$M_FIRSTBYTE,C24)
	ELSE IF (KEY.EQ.1) THEN
	  IF (RED.GT.255.OR.GREEN.GT.255.OR.BLUE.GT.255)
	1 CALL ERROR(-3,'8-bit colors are too large')
	  IF (RED.LT.0.OR.GREEN.LT.0.OR.BLUE.LT.0)
	1 CALL ERROR(-3,'8-bit colors were negative')
	  C24=RED*256*256+GREEN*256+BLUE
	ELSE
	  CALL ERROR(-3,'Wrong value for KEY in color_24_triplet')
	END IF
	RETURN
	END
	  
