	SUBROUTINE COLORMODE(COLOR)
C
C       This subroutine sets the color of the vector to be displayed
C  on the plot device and puts the appropriate value in the common
C  block PLOT_COLOR and then calls PLOT to send the value to the
C  device driver or to a plot file.  The colors listed below are
C  mostly X window color names except for the ones followed by *.
C			Donald H. Gudehus, December 13, 1983
C
C	COLOR	(C)	The 24-bit color of the line desired on the plotting
C			device.  It is coded so that the first byte
C			corresponds to 8 bits of blue, the second byte
C			to 8 bits of green, and the third byte to 8 bits
C			of red.  The Grinnell only uses 4 bits for each
C			color gun;  therefore GRIN.FOR converts to 4 bits.
C			The Trapix uses 8 bits for each color, so no
C			conversion is necessary.  It can only display
C			256 colors at one time however. 
C	
C		24-BIT VALUE	Name
C		0		! Black (for the background)
C		8388564		! Aquamarine
C		15794175	! Azure
C		255		! Blue
C		9055202		! Blue Violet
C		10824234	! Brown
C		7811840		! Brown *
C		13789470	! Chocolate
C		6591981		! Cornflower Blue
C		65535		! Cyan
C		8943581		! Dark azure *
C		12433259	! Dark Khaki
C		5597999		! Dark olive green
C		4465152		! Dark olive *
C		16747520	! Dark orange
C		7982541		! DarkSlateGray3
C		9699539		! Dark violet
C		49151		! Deep sky blue
C		4456499		! Deep violet *
C		16716947	! Deep pink
C		2263842		! Forest green
C		16766720	! Gold
C		1118481		! Gray *
C		2236962		! Gray
C		3355443		! Gray
C		4473924		! Gray
C		5592405		! Gray
C		6710886		! Gray
C		7829367		! Gray
C		8947848		! Gray
C		10066329	! Gray
C		11184810	! Gray
C		12303291	! Gray
C		13421772	! Gray
C		14540253	! Gray
C		15658734	! Gray
C		16777215	! Gray (white)
C		65280		! Green 
C		11403055	! Green yellow 
C		16777200	! Ivory1
C		10061960	! Light brown *
C		8900346		! Light sky blue
C		8679679		! Light slate blue
C		16711935	! Magenta *
C		11546720	! Maroon
C		16760120	! Medium goldenrod
C		64154		! Medium Spring Green
C		13047173	! Medium Violet Red
C		16760120	! Moccasin
C		7820561		! Olive *
C		16753920	! Orange
C		16729344	! Orange red
C		16742144
C		10494192	! Purple
C		5570560		! Raspberry *
C		6689041
C		7798835
C		7803153
C		8912947
C		10031377
C		16711680	! Red
C		11149824	! Rust *
C		9127187		! Saddle brown
C		16416882	! Salmon
C		16032864	! Sandy Brown
C		3050327		! Sea green
C		65407		! Spring Green
C		10044433	! Tan *
C		4251856		! Turquoise
C		15631086	! Violet
C		13639824	! Violet red
C		16776960	! Yellow
C		16113331	! Wheat
C
	INTEGER COLOR,LCOLOR
	COMMON /PLOT_COLOR/ LCOLOR
C
	LCOLOR=COLOR
	CALL PLOT(0.0,0.0,6)
	RETURN
	END
