	SUBROUTINE DECODE_INTERVALS(N_INTERVALS_CODED,N_INTERVALS,
	1N_INTERVALS_OFFSET_L,N_INTERVALS_OFFSET_R)
C
C	This subroutine decodes the number of intervals for drawing plot
C  axes into the actual number of intervals per axis length and the 
C  offset of the first annotation along the axis.  The number of intervals 
C  per axis length is encoded as follows:  1) the integer part is the 
C  integer part of N_INTERVALS_CODED, 2) the fractional part at the left 
C  (or) bottom end of the axis is contained in the tenths and hundredths 
C  places, and 3) the fractional part at the right (or top) end of the 
C  axis is contained in the thousandths and ten thousandths places.  For 
C  example N_INTERVALS_CODED=6.102 means that there are a total of 6.3 
C  intervals, with 0.1 adjacent to the left (or bottom) end and 0.2 
C  adjacent to the right (or top) end.
C
C			Donald H. Gudehus, May 2, 2000
C			Version 2, D. Gudehus, February 28, 2004
C			Added extra variable in argument list:
C			N_INTERVALS_OFFSET_R
C
C	N_INTERVALS_CODED	(C) The number of intervals along a plot axis
C				    encoded as nn.llrr where nn is the integer
C				    part, .ll represents the left (or bottom)
C				    fractional part, and .rr represents the
C				    right (or top) fractional part of an
C				    interval.
C	N_INTERVALS		(R) The total number of intervals (integer
C				    part, left part, and right part)
C	N_INTERVALS_OFFSET_L	(R  The left or bottom fractional part
C	N_INTERVALS_OFFSET_R	(R) The right or top fractional part
C
	REAL*4 N_INTERVALS_CODED,N_INTERVALS,N_INTERVALS_OFFSET_L,
	1N_INTERVALS_OFFSET_R
	REAL*8 FRACTION,TEMP
C
	FRACTION=N_INTERVALS_CODED-INT(N_INTERVALS_CODED)
	TEMP=INT(100.0D0*FRACTION)
	N_INTERVALS_OFFSET_L=TEMP/100.0D0
	N_INTERVALS_OFFSET_R=(NINT(10000.0D0*FRACTION)-100.0D0*TEMP)/100.0D0
	N_INTERVALS=INT(N_INTERVALS_CODED)+N_INTERVALS_OFFSET_L+
	1N_INTERVALS_OFFSET_R
C
	RETURN
	END
