	SUBROUTINE GET_DP_AVAILABILITY
C
C  Note:  This is the Unix version
C
C       This subroutine searches for the file 
C  display-plotting_availability.dat, and if found, loads the
C  information on available display and plot devices into 2 COMMON blocks.
C  The information is then available for PLOTDEVICES.FOR in order to create
C  a meaningful prompt for the desired plot device(s), and is available
C  for the various MIIPS options which use display devices.
C
C			Donald H. Gudehus, July, 1993
C			Version 1U, Converted code to work under Unix
C
	CHARACTER*40 FILENAME
	CHARACTER*80 STRING
C
C  The COMMON block below will be loaded with information about what 
C  on-line plotting devices the user's facility has available
	CHARACTER*80 DISPLAY_PLOTTING$DEVICES(100)
	LOGICAL DP_AVAILABILITY$FOUND
	COMMON /PLOTTING_AVAILABILITY/ DISPLAY_PLOTTING$DEVICES,
	1DP_AVAILABILITY$FOUND,N_DP$DEVICES
C
C  The COMMON block below will be loaded with information about what 
C  on-line display devices the user's facility has available
	LOGICAL GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
	COMMON /DISPLAY_AVAILABILITY/ GRINNELL_270,TRAPIX,RAMTEK,
	1SAOIMAGE
C
	DATA DP_AVAILABILITY$FOUND /.FALSE./
	DATA GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
	1/.FALSE.,.FALSE.,.FALSE.,.FALSE./
C
	FILENAME='display-plotting_availability.dat'
	OPEN(UNIT=61,FILE=FILENAME,TYPE='OLD',READONLY,
	1CARRIAGECONTROL='NONE',ERR=199)
	DP_AVAILABILITY$FOUND=.TRUE.
 100	REWIND (61)
C  Get the identities of the devices supported at a given facility
	I=0
	DO WHILE (.TRUE.)
	  READ (61,3000,END=101) STRING
3000	  FORMAT (A)
	  IF (STRING(1:1).NE.'!') THEN
	    I=I+1
	    DISPLAY_PLOTTING$DEVICES(I)=STRING
	  END IF
	  IF (STRING.EQ.'Grinnell 270'.OR..NOT.DP_AVAILABILITY$FOUND) 
	1 GRINNELL_270=.TRUE.
	  IF (STRING.EQ.'Trapix'.OR..NOT.DP_AVAILABILITY$FOUND)
	1 TRAPIX=.TRUE.
	  IF (STRING.EQ.'Ramtek'.OR..NOT.DP_AVAILABILITY$FOUND)
	1 RAMTEK=.TRUE.
	  IF (STRING.EQ.'SAOimage'.OR..NOT.DP_AVAILABILITY$FOUND)
	1 SAOIMAGE=.TRUE.
	END DO
 101	N_DP$DEVICES=I
 199	IF (.NOT.DP_AVAILABILITY$FOUND) THEN
	  CALL ERROR(-1,'display-plotting_availability.dat was not found')
	  CALL MESSAGE('Prompts will include all supported devices')
	END IF
C
	CLOSE (UNIT=61)
	RETURN
	END
