	PROGRAM PLOTCOM
C
C  Note:  This is the Unix version
C
C       This program accepts, parses and executes the $PLOT command.
C  Note that the numbers for DEVICE do not correspond exactly to NDEVICE in
C  PLTDEV.FOR, since they are independent numbers.
C
C			Greg Quinn, October, 1980
C
C			Version 2, Greg Qunn, August, 1981
C			Added support for the Tektronix 4662 plotter
C			Version 3, Donald H. Gudehus, May, 1983
C			Corrected writing of ARRAY to unit 53 when
C			DEVICE=2
C			Version 4, Donald H. Gudehus, September, 1983
C			Added call to PLOT for Tektronix 4662
C			Version 5, Donald H. Gudehus, December, 1983
C			Added the Grinnell as a plotting device
C			Version 6, Donald H. Gudehus, October, 1984
C			Added the QMS Lasergrafix 1200 as a plotting
C			device and incorporated ROTATE
C			Version 7, Donald H. Gudehus, February, 1987
C			Added the GraphOn graphics terminal
C			as a plotting device.
C			Version 8, Donald H. Gudehus, March, 1987
C			Added the Codonics corrupted graphics terminal
C			as a plotting device.
C			Version 9, Donald H. Gudehus, September, 1987
C			Added the Apple Laser Writer as a plotting device.
C			Version 10, Donald H. Gudehus, August, 1988
C			Added the Imagen Laser writer as a plotting device.
C			Version 11, Donald H. Gudehus, November, 1988
C			Added the Micro-term graphics terminal
C			as a plotting device.
C			Version 12, Donald H. Gudehus, November, 1988
C			Added the Trapix as a plotting device.
C			Version 13, Donald H. Gudehus, September, 1989
C			Added capability to output a Postscript file which
C			can then be transported to a remote Postscript printer.
C			Version 14, Donald H. Gudehus, May, 1992
C			Added the Versaterm graphics terminal emulator
C			as a plotting device.
C			Version 15, Donald H. Gudehus, October, 1992
C			Added the Xterm graphics emulator
C			as a plotting device.
C			Version 16, Donald H. Gudehus, October, 1994
C			Added SAOimage as a plotting device
C			Version 17, Donald H. Gudehus, October, 1998
C			Made Xterm the default device (used to be LaserWriter).
C			Version 17U, Donald H. Gudehus, February 5, 2000
C			Converted code to work under Unix.  Under Unix,
C			a / cannot immediately follow the program name, and
C			/ and = can be replaced with blanks.
C			Version 18, Donald H. Gudehus, February 5, 2000
C			Added call to RESETTEK
C			Version 19, Donald H. Gudehus, March 14, 2004
C			Increased size of FILE_NAME to 40
C			Version 19UM, Donald H. Gudehus, February 7, 2005
C			Modified code to work with Absoft compiler on Mac OS
C			Version 20, Donald H. Gudehus, April 17, 2005
C			Improved the code for writing postscript and eps
C			files with overlapping plots.
C
	BYTE COMMAND(0:4)
	INTEGER*2 I2COM(0:1)
	EQUIVALENCE (COMMAND(1),I2COM(0))
	PARAMETER (MAXCOMMANDS=15)
C	PARAMETER (NBYTES=134)
	PARAMETER (NBYTES=130) !  Fudge for incorrectly configured Printronix
			     !  at UM
	PARAMETER (NLINES=790)
C	BYTE ARRAY(NBYTES,NLINES)
	BYTE TEXT(256)
	BYTE BCOMMAND(132*MAXCOMMANDS)
	CHARACTER*132 LCOMMAND(MAXCOMMANDS)
	EQUIVALENCE (BCOMMAND,LCOMMAND)
	CHARACTER*40 FILE_NAME,STRCOPIES*3
	CHARACTER*40 VFORMAT
	CHARACTER*15 TEST_STRING
	INTEGER*2 SYMFIX(0:2)
	INTEGER DEVICE,COPIES,NUMBER
C	INTEGER STR$UPCASE,PARSE
	INTEGER*2 XOFF,YOFF
	LOGICAL ENDPLOT,ENDFILE,ALLPLOTS,OVERLAP,FINISHED
C	LOGICAL FIRSTPLOT,PRINTIT
	REAL ROTATE,SCALE,RXOFF,RYOFF
	INCLUDE 'plotpar.for'
	BYTE CR,LF,FF
	PARAMETER (CR=13,LF=10,FF=12)
C
C  Initialize the command string
C	
	DO I=1,MAXCOMMANDS
	  LCOMMAND(I)=' '
	END DO
C
C  Get the command string.
C
	N=IARGC()
	DO I=1,N
	  CALL GETARG(I,LCOMMAND(I))
	END DO
C
C  Remove / and =
C
	DO J=1,N
	  DO I=1,132
	    IF (LCOMMAND(J)(I:I).EQ.'/'.OR.LCOMMAND(J)(I:I).EQ.'=')
	1   LCOMMAND(J)(I:I)=' '
	  END DO
	END DO
C
C  Move each word into an array element and count the words
C
	CALL ALPHA(%REF(LCOMMAND),MAXCOMMANDS,132,NCHAR,NFULL,NREST,4)
C
C  Find out if the file name was entered
C
	IF (NFULL.GT.(NFULL/2)*2) THEN !  Odd number of words, so file name
				       !  is the last word.
	  FILE_NAME=LCOMMAND(NFULL)
	ELSE
	  FILE_NAME='plot.plt'
	END IF
	N_COMMANDS=NFULL/2
C
C  Convert the commands and keywords to upper case
C
	DO K=1,132*NFULL
	  IF (BCOMMAND(K).GE.97.AND.BCOMMAND(K).LE.122) 
	1 BCOMMAND(K)=BCOMMAND(K)-32
	END DO
C
C  Get the commands and their parameters
C
	DO I=1,N_COMMANDS
	  K=I*2-1
	  KK=K+1
	  CALL ALPHA(LCOMMAND(K),1,132,NC_K,NF,NR,1)
	  CALL ALPHA(LCOMMAND(KK),1,132,NC_KK,NF,NR,1)
	  TEST_STRING='DEVICE'
	  IF (LCOMMAND(K)(1:NC_K).EQ.TEST_STRING(1:NC_K)) THEN
	    TEST_STRING='TEKTRONIX'
	    IF (LCOMMAND(KK)(1:NC_KK).EQ.TEST_STRING(1:NC_KK))
	1   DEVICE=1
	    TEST_STRING='GRAPHON'
	    IF (LCOMMAND(KK)(1:NC_KK).EQ.TEST_STRING(1:NC_KK))
	1   DEVICE=101
	    TEST_STRING='CODONICS'
	    IF (LCOMMAND(KK)(1:NC_KK).EQ.TEST_STRING(1:NC_KK))
	1   DEVICE=201
	    TEST_STRING='MICROTERM'
	    IF (LCOMMAND(KK)(1:NC_KK).EQ.TEST_STRING(1:NC_KK))
	1   DEVICE=301
	    TEST_STRING='VERSATERM'
	    IF (LCOMMAND(KK)(1:NC_KK).EQ.TEST_STRING(1:NC_KK))
	1   DEVICE=401
	    TEST_STRING='XTERM'
	    IF (LCOMMAND(KK)(1:NC_KK).EQ.TEST_STRING(1:NC_KK))
	1   DEVICE=10001
	    TEST_STRING='XGTERM'
	    IF (LCOMMAND(KK)(1:NC_KK).EQ.TEST_STRING(1:NC_KK))
	1   DEVICE=20001
	    TEST_STRING='APPLE0'
	    IF (LCOMMAND(KK)(1:NC_KK).EQ.TEST_STRING(1:NC_KK))
	1   DEVICE=11
	    TEST_STRING='EPS'
	    IF (LCOMMAND(KK)(1:NC_KK).EQ.TEST_STRING(1:NC_KK))
	1   DEVICE=999811
	    TEST_STRING='POSTSCRIPT'
	    IF (LCOMMAND(KK)(1:NC_KK).EQ.TEST_STRING(1:NC_KK))
	1   DEVICE=999911
	    TEST_STRING='SAOIMAGE'
	    IF (LCOMMAND(KK)(1:NC_KK).EQ.TEST_STRING(1:NC_KK))
	1   DEVICE=13
	    TEST_STRING='_SAOIMAGE'
	    IF (LCOMMAND(KK)(1:NC_KK).EQ.TEST_STRING(1:NC_KK))
	1   DEVICE=-13
	  END IF
	  TEST_STRING='COPIES'
	  IF (LCOMMAND(K).EQ.TEST_STRING(1:NC_K)) THEN
	    WRITE(VFORMAT,1000) NC_KK
1000	    FORMAT('(I',I4,')')
	    DECODE(NC_KK,VFORMAT,LCOMMAND(KK)(1:NC_KK)) COPIES
C	    DECODE(NC_KK,1000,LCOMMAND(KK)(1:NC_KK)) COPIES
C1000	    FORMAT(I<NC_KK>)
	  END IF
	  TEST_STRING='NUMBER'
	  IF (LCOMMAND(K).EQ.TEST_STRING(1:NC_K)) THEN
	    WRITE(VFORMAT,1000) NC_KK
	    DECODE(NC_KK,VFORMAT,LCOMMAND(KK)(1:NC_KK)) NUMBER
C	    DECODE(NC_KK,1000,LCOMMAND(KK)(1:NC_KK)) NUMBER
	  END IF
	  TEST_STRING='ROTATE'
	  IF (LCOMMAND(K).EQ.TEST_STRING(1:NC_K)) THEN
	    WRITE(VFORMAT,2000) NC_KK
2000	    FORMAT('(F'I,'.0)')
	    DECODE(NC_KK,VFORMAT,LCOMMAND(KK)(1:NC_KK)) ROTATE
C	    DECODE(NC_KK,2000,LCOMMAND(KK)(1:NC_KK)) ROTATE
C2000	    FORMAT(F<NC_KK>.0)
	  END IF
	  TEST_STRING='SCALE'
	  IF (LCOMMAND(K).EQ.TEST_STRING(1:NC_K)) THEN
	    WRITE(VFORMAT,2000) NC_KK
	    DECODE(NC_KK,VFORMAT,LCOMMAND(KK)(1:NC_KK)) SCALE
C	    DECODE(NC_KK,2000,LCOMMAND(KK)(1:NC_KK)) SCALE
	  END IF
	  TEST_STRING='XOFF'
	  IF (LCOMMAND(K).EQ.TEST_STRING(1:NC_K)) THEN
	    WRITE(VFORMAT,2000) NC_KK
	    DECODE(NC_KK,VFORMAT,LCOMMAND(KK)(1:NC_KK)) RXOFF
C	    DECODE(NC_KK,2000,LCOMMAND(KK)(1:NC_KK)) RXOFF
	  END IF
	  TEST_STRING='YOFF'
	  IF (LCOMMAND(K).EQ.TEST_STRING(1:NC_K)) THEN
	    WRITE(VFORMAT,2000) NC_KK
	    DECODE(NC_KK,VFORMAT,LCOMMAND(KK)(1:NC_KK)) RYOFF
C	    DECODE(NC_KK,2000,LCOMMAND(KK)(1:NC_KK)) RYOFF
	  END IF
	END DO
C
C  Calculate cosine, and sine of the angle of rotation 
C
	COSR=COSD(ROTATE)
	SINR=SIND(ROTATE)
C
C  Convert the offsets from inches to plotter increments.
C
	XOFF=-RXOFF*PLT$C_NIBS
	YOFF=-RYOFF*PLT$C_NIBS
C
C  One can overlap a previous plot if the device is called with a negative
C  number.
	OVERLAP=.FALSE.
	IF (NUMBER.EQ.-1) THEN
	  OVERLAP=.TRUE.
	  NUMBER=1
	END IF
C
C  Set up sensible defaults when zero values are returned.
C
C	IF (DEVICE.EQ.0) DEVICE=11 !  Apple
	IF (DEVICE.EQ.0) DEVICE=10001 !  Xterm
	IF (COPIES.EQ.0) COPIES=1
	IF (NUMBER.EQ.0) THEN
	  NUMBER=1
	  IF (DEVICE.NE.999811) THEN !  Not EPS
	    ALLPLOTS=.TRUE. !  Used for the Printronix, Lasergrafix,
			    !  Apple Laser Writers, and Imagen
	  ELSE !  EPS
	    ALLPLOTS=.FALSE.
	  END IF
	END IF
	IF (SCALE.EQ.0.0) SCALE=1.0
	IF (FILE_NAME(1:1).EQ.' ') FILE_NAME='plot.plt'
C
C  Now make the plots.
C
	OPEN(UNIT=79,FILE=FILE_NAME,STATUS='OLD',FORM='UNFORMATTED')
	FINISHED=.FALSE.
C
C  Tektronix plots
C
	IF (DEVICE.EQ.1.OR.DEVICE.EQ.101.OR.DEVICE.EQ.201.OR.DEVICE
	1.EQ.301.OR.DEVICE.EQ.401.OR.DEVICE.EQ.10001.OR.DEVICE
	2.EQ.20001) THEN
	  IF (DEVICE.EQ.1) THEN
	    CALL PLTDEV(1,.FALSE.)
	  ELSE IF (DEVICE.EQ.101) THEN
	    CALL PLTDEV(101,.FALSE.)
	  ELSE IF (DEVICE.EQ.201) THEN
	    CALL PLTDEV(201,.FALSE.)
	  ELSE IF (DEVICE.EQ.301) THEN
	    CALL PLTDEV(301,.FALSE.)
	  ELSE IF (DEVICE.EQ.401) THEN
	    CALL PLTDEV(401,.FALSE.)
	  ELSE IF (DEVICE.EQ.10001) THEN
	    CALL PLTDEV(10001,.FALSE.)
	  ELSE IF (DEVICE.EQ.20001) THEN
	    CALL PLTDEV(20001,.FALSE.)
	  END IF
C  Find the plot
	  CALL FINDPLOT(NUMBER,ISTAT)
	  IF (OVERLAP) THEN
	    DO WHILE (.NOT.ENDFILE)
	      CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
	      IF (.NOT.ENDFILE) CALL TEKPLOT(COMMAND,SYMFIX,TEXT,
	1     XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
	    END DO
	  ELSE
	    DO WHILE (ISTAT.NE.PLT$S_ENDPLOT.AND..NOT.ENDFILE)
	      CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
	      IF (.NOT.ENDFILE) CALL TEKPLOT(COMMAND,SYMFIX,TEXT,
	1     XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
	    END DO
	  END IF
C
C  Ramtek plots
C
	ELSE IF (DEVICE.EQ.3) THEN

C	CALL FINDPLOT(NUMBER,ISTAT)
C	CALL PLTDEV(3,.FALSE.)
C	DO WHILE (ISTAT.NE.PLT$S_ENDPLOT.AND..NOT.ENDFILE)
C	  CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
C	  IF (.NOT.ENDFILE) CALL RAMPLOT(COMMAND,SYMFIX,TEXT,
C	1 XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
C	END DO
C
C  Imagen plots
C
	ELSE IF (DEVICE.EQ.5) THEN
C	  CALL PLTDEV(5,.FALSE.)
C	  DO WHILE(.NOT.FINISHED)
C	    IF (ALLPLOTS.AND.NUMBER.GT.1) THEN
C  The form feeds are done by this routine since the device is a printer
C	      CALL IMAGEN(0,0,15)
C	      WRITE(6,1003) NUMBER
C	    END IF
C	    CALL FINDPLOT(NUMBER,ISTAT)
C	    IF (ISTAT.EQ.PLT$S_NOSUCHPLOT) THEN
C	      FINISHED=.TRUE.
C	      WRITE (6,1001)NUMBER
C	    END IF
C	    IF (OVERLAP) THEN !  Note that ALLPLOTS=.FALSE.
C	      DO WHILE (.NOT.ENDFILE)
C	        CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
C	        IF (.NOT.ENDFILE) CALL IMAGENPLOT(COMMAND,SYMFIX,TEXT,
C	1       XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
C	      END DO
C	    ELSE
C	      DO WHILE (ISTAT.NE.PLT$S_ENDPLOT.AND..NOT.ENDFILE)
C	        CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
C	        IF (.NOT.ENDFILE) CALL IMAGENPLOT(COMMAND,SYMFIX,TEXT,
C	1       XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
C	      END DO
C  Check if this is the last plot in the file;  if so, don't put out 
C  another page but exit.
C	      CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE) 
C	      IF (ENDFILE) FINISHED=.TRUE.
C	    END IF
C	    NUMBER=NUMBER+1
C	    IF (.NOT.ALLPLOTS) FINISHED=.TRUE.
C	  END DO
C	  ENCODE (3,1002,STRCOPIES) COPIES
C	  CALL LIB$DO_COMMAND('$RENAME VECT.RPL VECT.TEK')
C	  CALL LIB$DO_COMMAND('$PRINT/QUEUE=IMAGEN/NOFEED/DEL/
C	1 COP='//STRCOPIES//' VECT.TEK')
C
C  Printronix plots
C
	ELSE IF (DEVICE.EQ.6) THEN
C	  FIRSTPLOT=.TRUE.
C	  DO WHILE (.NOT.FINISHED)
C
C  For all but the first plot, put
C  out a leading form feed
C
C	    FIRSTPLOT=.FALSE.
C	    MAXX=1
C	    NL1=1
C	    DO WHILE (MAXX.GE.NL1)
C
C  Find the plot
C
C	      CALL FINDPLOT(NUMBER,ISTAT)
C	      IF (ISTAT.EQ.PLT$S_NOSUCHPLOT) THEN
C	        IF (.NOT.ALLPLOTS) WRITE (6,1001)NUMBER
C	        FINISHED=.TRUE.
C	        MAXX=0
C	      END IF
C
C  Initialize the raster array
C
C	      IF (.NOT.FINISHED) THEN
C	        DO I=1,NLINES
C	          DO J=1,NBYTES-2
C	            ARRAY(J,I)='C0'X
C	          END DO
C	          ARRAY(NBYTES-1,I)=5
C	          ARRAY(NBYTES,I)=LF
C	        END DO
C  The above could be replaced by a call to PLTDEV now.
C	        PRINTIT=.FALSE.
C
C  Loop through the plot commands.
C
C 400	        CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
C	        IF (ENDFILE) GO TO 450
C	        CALL PRINTPLOT(COMMAND,SYMFIX,TEXT,ARRAY,NL1,
C	1       MAXX,XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
C	        IF (.NOT.ISTAT) GO TO 450
C	        PRINTIT=.TRUE.
C	        GO TO 400
C
C  Write the raster array
C
C 450	        IF (PRINTIT) THEN
C	          DO IL1=1,NLINES
C	            WRITE(53)(ARRAY(J,IL1),J=1,NBYTES)
C	          END DO
C	        END IF
C	        ENDFILE=.FALSE.	
C	        NL1=NL1+NLINES
C	      END IF
C	    END DO
C	    NUMBER=NUMBER+1
C	    IF (.NOT.ALLPLOTS) FINISHED=.TRUE.
C	  END DO
C	  ENCODE (3,1002,STRCOPIES) COPIES
C	  CALL LIB$DO_COMMAND('$PRINT/QUEUE=PRINTRONIX/NOFEED/DEL/
C	1 COP='//STRCOPIES//' VECT.RPL')
C
C  Tektronix 4662 plots
C
	ELSE IF (DEVICE.EQ.7) THEN
C	  CALL FINDPLOT(NUMBER,ISTAT)
C	  CALL PLTDEV(7,.FALSE.)
C	  DO WHILE (ISTAT.NE.PLT$S_ENDPLOT.AND..NOT.ENDFILE)
C	    CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
C	    IF (.NOT.ENDFILE) CALL T4662PLOT(COMMAND,SYMFIX,TEXT,
C	1   XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
C	  END DO
C	  CALL PLOT(0.,0.,4) !  Turns plotter off
C
C  Grinnell plots
C
	ELSE IF (DEVICE.EQ.8) THEN
C	  CALL FINDPLOT(NUMBER,ISTAT)
C	  CALL PLTDEV(8,.FALSE.)
C	  IF (OVERLAP) THEN
C	    DO WHILE (.NOT.ENDFILE)
C	      CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
C	      IF (.NOT.ENDFILE) CALL GRINPLOT(COMMAND,SYMFIX,TEXT,
C	1     XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
C	    END DO
C	  ELSE
C	    DO WHILE (ISTAT.NE.PLT$S_ENDPLOT.AND..NOT.ENDFILE)
C	      CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
C	      IF (.NOT.ENDFILE) CALL GRINPLOT(COMMAND,SYMFIX,TEXT,
C	1     XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
C	    END DO
C	  END IF
C
C  Houston plots
C
	ELSE IF (DEVICE.EQ.9) THEN
C	  CALL FINDPLOT(NUMBER,ISTAT)
C	  CALL PLTDEV(9,.FALSE.)
C	  DO WHILE (ISTAT.NE.PLT$S_ENDPLOT.AND..NOT.ENDFILE)
C	    CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
C	    IF (.NOT.ENDFILE) CALL HOUSTPLOT(COMMAND,SYMFIX,TEXT,
C	1   XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
C	  END DO
C
C  Lasergrafix plots (Quick programming language)
C
	ELSE IF (DEVICE.EQ.10) THEN
C	  CALL PLTDEV(10,.FALSE.)
C	  DO WHILE(.NOT.FINISHED)
C	    IF (ALLPLOTS.AND.NUMBER.GT.1) THEN
C  The form feeds are done by this routine since the Lasergrafix is a printer
C	      CALL LASER(0,0,15)
C	      WRITE(6,1003) NUMBER
C	    END IF
C	    CALL FINDPLOT(NUMBER,ISTAT)
C	    IF (ISTAT.EQ.PLT$S_NOSUCHPLOT) THEN
C	      FINISHED=.TRUE.
C	      WRITE (6,1001)NUMBER
C	    END IF
C	    IF (OVERLAP) THEN !  Note that ALLPLOTS=.FALSE.
C	      DO WHILE (.NOT.ENDFILE)
C	        CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
C	        IF (.NOT.ENDFILE) CALL LASERPLOT(COMMAND,SYMFIX,TEXT,
C	1       XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
C	      END DO
C	    ELSE
C	      DO WHILE (ISTAT.NE.PLT$S_ENDPLOT.AND..NOT.ENDFILE)
C	        CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
C	        IF (.NOT.ENDFILE) CALL LASERPLOT(COMMAND,SYMFIX,TEXT,
C	1       XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
C	      END DO
C  Check if this is the last plot in the file;  if so, don't put out 
C  another page but exit.
C	      CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE) 
C	      IF (ENDFILE) FINISHED=.TRUE.
C	    END IF
C	    NUMBER=NUMBER+1
C	    IF (.NOT.ALLPLOTS) FINISHED=.TRUE.
C	  END DO
C	  CALL LASER(0,0,4) !  Courtesy reset of Lasergrafix
C	  ENCODE (3,1002,STRCOPIES) COPIES
C	  CALL LIB$DO_COMMAND('$PRINT/COP='//STRCOPIES//'
C	1 /QUEUE=LASERGRAFIX/DEL/NOFEED VECT.RPL')
C
C  Apple Laser Writer plots, LPS40 plots, a Postsript file, or an EPS file.
C
	ELSE IF (DEVICE.EQ.11.OR.DEVICE.EQ.111.OR.DEVICE.EQ.211.OR.
	1DEVICE.EQ.311.OR.DEVICE.EQ.411.OR.DEVICE.EQ.511.OR.DEVICE.EQ.611.OR.
	2DEVICE.EQ.9011.OR.DEVICE.EQ.999811.OR.DEVICE.EQ.999911) THEN
	  CALL PLTDEV(DEVICE,.FALSE.)
	  DO WHILE(.NOT.FINISHED)
	    IF (ALLPLOTS.AND.NUMBER.GE.1) THEN
C  The form feeds must be in the plot file for the postscript files.
	      WRITE(6,1003) NUMBER
	    END IF
	    CALL FINDPLOT(NUMBER,ISTAT)
	    IF (ISTAT.EQ.PLT$S_NOSUCHPLOT) THEN
	      FINISHED=.TRUE.
	      WRITE (6,1001)NUMBER
	    END IF
	    IF (OVERLAP) THEN !  Note that ALLPLOTS=.FALSE.
	      DO WHILE (.NOT.ENDFILE)
	        CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
C  When overlapping, don't write a showpage to the file
	        IF (.NOT.ENDPLOT.AND..NOT.ENDFILE) CALL APPLEPLOT(COMMAND,
	1       SYMFIX,TEXT,XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
	        IF (ENDPLOT) ENDPLOT=.FALSE.
	      END DO
	      CALL APPLE(0,0,15) !  Write a final showpage
	    ELSE
	      DO WHILE (ISTAT.NE.PLT$S_ENDPLOT.AND..NOT.ENDFILE)
	        CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
	        IF (.NOT.ENDFILE) CALL APPLEPLOT(COMMAND,SYMFIX,TEXT,
	1       XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
	      END DO
C  Check if this is the last plot in the file;  if so, don't put out 
C  another page but exit.
	      CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE) 
	      IF (ENDFILE) FINISHED=.TRUE.
	    END IF
	    NUMBER=NUMBER+1
	    IF (.NOT.ALLPLOTS) FINISHED=.TRUE.
	  END DO
	  ENCODE (3,1002,STRCOPIES) COPIES
C  The following code sends a Postscript file to one of several Apple 
C  Laserwriters 
	  IF (DEVICE.EQ.11) THEN
C	    CALL LIB$DO_COMMAND('$PRINT/COP='//STRCOPIES//'
C	1   /QUEUE=APPLELASERWRITER/DEL/NOFEED VECT.RPL')
	  ELSE IF (DEVICE.EQ.211) THEN
C	    CALL LIB$DO_COMMAND('$PRINT/COP='//STRCOPIES//'
C	1   /QUEUE=APPLELASERWRITER2/DEL/NOFEED VECT.RPL')
	  ELSE IF (DEVICE.EQ.311) THEN
C	    CALL LIB$DO_COMMAND('$PRINT/COP='//STRCOPIES//'
C	1   /QUEUE=APPLELASERWRITER3/DEL/NOFEED VECT.RPL')
	  ELSE IF (DEVICE.EQ.411) THEN
C	    CALL LIB$DO_COMMAND('$PRINT/COP='//STRCOPIES//'
C	1   /QUEUE=APPLELASERWRITER4/DEL/NOFEED VECT.RPL')
	  ELSE IF (DEVICE.EQ.511) THEN
C	    CALL LIB$DO_COMMAND('$PRINT/COP='//STRCOPIES//'
C	1   /QUEUE=APPLELASERWRITER5/DEL/NOFEED VECT.RPL')
	  ELSE IF (DEVICE.EQ.611) THEN
C	    CALL LIB$DO_COMMAND('$PRINT/COP='//STRCOPIES//'
C	1   /QUEUE=APPLELASERWRITER6/DEL/NOFEED VECT.RPL')
	  ELSE IF (DEVICE.EQ.9011) THEN
C	    CALL LIB$DO_COMMAND('$PRINT/COP='//STRCOPIES//'
C	1   /QUEUE=LPS40/DEL/NOFEED VECT.RPL')
	  ELSE IF (DEVICE.EQ.999811) THEN
	    CALL MESSAGE('Creating Encapsulated Postscript file')
C  Do nothing since the Postscript file is not to be printed or deleted.
	  ELSE IF (DEVICE.EQ.999911) THEN
	    CALL MESSAGE('Creating Postscript file')
C  Do nothing since the Postscript file is not to be printed or deleted.
	  END IF
C
C  Trapix plots
C
	ELSE IF (DEVICE.EQ.12) THEN
C	  CALL FINDPLOT(NUMBER,ISTAT)
C	  CALL PLTDEV(12,.FALSE.)
C	  IF (OVERLAP) THEN
C	    DO WHILE (.NOT.ENDFILE)
C	      CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
C	      IF (.NOT.ENDFILE) CALL TRAPIXPLOT(COMMAND,SYMFIX,TEXT,
C	1     XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
C	    END DO
C	  ELSE
C	    DO WHILE (ISTAT.NE.PLT$S_ENDPLOT.AND..NOT.ENDFILE)
C	      CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
C	      IF (.NOT.ENDFILE) CALL TRAPIXPLOT(COMMAND,SYMFIX,TEXT,
C	1     XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
C	    END DO
C	  END IF
C
C  SAOimage plots
C
	ELSE IF (ABS(DEVICE).EQ.13) THEN
	  CALL FINDPLOT(NUMBER,ISTAT)
	  CALL PLTDEV(DEVICE,.FALSE.)
	  CALL SAO(0,0,14) !  Delayed display (faster)
	  IF (OVERLAP) THEN
	    DO WHILE (.NOT.ENDFILE)
	      CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
	      IF (.NOT.ENDFILE) CALL SAOPLOT(COMMAND,SYMFIX,TEXT,
	1     XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
	    END DO
	  ELSE
	    DO WHILE (ISTAT.NE.PLT$S_ENDPLOT.AND..NOT.ENDFILE)
	      CALL PLT_READ(COMMAND,SYMFIX,TEXT,ENDPLOT,ENDFILE)
	      IF (.NOT.ENDFILE) CALL SAOPLOT(COMMAND,SYMFIX,TEXT,
	1     XOFF,YOFF,SCALE,COSR,SINR,ISTAT)
	    END DO
	  END IF
	  CALL SAO(0,0,15) !  Display the vectors all at once
	END IF
	CALL RESETTEK
C
1001	FORMAT(' Plot number ',I3,' does not exist ')
1002	FORMAT(I3)
1003	FORMAT(' Plot number ',I3,' being encoded ')
	END
