	SUBROUTINE PLT_WRITE(COMMAND,SYMFIX,FIXFLAG,TEXT,NCHARS,LU)
C
C  Note:  This is the Unix version
C
C       This subroutine writes plot commands to a file, or passes them
C  to an online plot utility.
C			Greg Quinn, Mount Stromlo Observatory, June, 1980
C
C			Version 2, Donald H. Gudehus, December, 1983
C			Added code for NDEV equals 7 and 8.
C			Version 3, Donald H. Gudehus, October, 1984
C			Added code for NDEV equals 10 and rotation
C			Version 4, Donald H. Gudehus, February 13, 1987
C			Added code for NDEV equals 101 and 104.
C			Version 5, Donald H. Gudehus, August, 1987
C			Added code for NDEV equals 11
C			Version 6, Donald H. Gudehus, March, 1988
C			Made provision for not writing FACTOR to the
C			plot file when it is changed during a session.
C			Version 7, Donald H. Gudehus, August, 1988
C			Added code for NDEV equals 5
C			Version 8, Donald H. Gudehus, November, 1988
C			Added code for NDEV equals 12
C			Version 9, Donald H. Gudehus, May, 1992
C			Added code for NDEV equals 401
C			Version 10, Donald H. Gudehus, June, 1993
C			Added code for on-line plotting with the Printronix
C			Version 11, Donald H. Gudehus, October, 1994
C			Added code for SAOimage
C			Version 11U, Donald H. Gudehus, January 17, 2000
C			Modified code for Unix
C			Version 11UM, Donald H. Gudehus, February 12, 2005
C			Modified code for Mac OS so that plot files are 
C			compatible between systems.
C
	INTEGER CHANNELS(10),DEVICENUMBERS(10),DEVICEINDEX
	COMMON /PLOT_DEVICES/ NUMBERDEVICES,CHANNELS,DEVICENUMBERS,DEVICEINDEX,
	1INDEXLOWER
C
	COMMON /PLOT_CHAN/ NCHAN,NDEV
C
	INCLUDE 'plotpar.for'
	BYTE COMMAND(0:4)
C	BYTE COMMAND_VMS(0:4)
	BYTE SYMFIX(PLT$C_SYMFIX)
	BYTE TEXT(1)
	INTEGER*2 NCHARS
	LOGICAL FIXFLAG
C  The following is for the Printronix
C	PARAMETER (NBYTES=134)
	PARAMETER (NBYTES=130)  ! Fudge for incorrectly configured Printronix
			      ! at UM
	PARAMETER (NLINES=790)
	BYTE ARRAY(NBYTES,NLINES)
	COMMON /PLOT_PRINTRONIX/ ARRAY
C
	DO N=NUMBERDEVICES,INDEXLOWER,-1  ! See explanation in PLOTDEVICES2
	  NCHAN=CHANNELS(N)
	  NDEV=DEVICENUMBERS(N)
	  IF (NDEV.EQ.1.OR.NDEV.EQ.4.OR.NDEV.EQ.101.OR.NDEV
	1 .EQ.201.OR.NDEV.EQ.301.OR.NDEV.EQ.401.OR.NDEV.EQ.10001.OR.
	2 NDEV.EQ.20001) THEN
	    CALL TEKPLOT(COMMAND,SYMFIX,TEXT,0,0,1.,1.,0.,ISTAT)
	  END IF
	  IF (NDEV.EQ.3) THEN
c	    CALL RAMPLOT(COMMAND,SYMFIX,TEXT,0,0,1.,1.,0.,ISTAT)
	  END IF
C  When writing to a file, the correct FACTOR will be received from
C  PLTDEV.  XYPLOT provides for the user to alter the factor during a
C  session.  Since this is intended only for the current plot devices, the
C  altered FACTOR should not be written to unit 79.  This is accomplished
C  by a call to FACTOR with the second argument equal to 7 and a test
C  for LU=7 below.
	  IF ((NDEV.EQ.2.OR.NDEV.EQ.4).AND.LU.NE.7) THEN
c	    DO I=0,4
c	      COMMAND_VMS(I)=COMMAND(I)
c	    END DO
c	    CALL COMMAND_TO_VMS(COMMAND_VMS)
c	    WRITE(LU) COMMAND_VMS  ! Command gets written to a file
C  The commented lines below work with Linux
C	    WRITE(LU) COMMAND
C	    IF (COMMAND(PLT$B_OPC).EQ.PLT$OP_ENDFILE) CLOSE(LU)
C	    IF (FIXFLAG.AND.NCHARS.LE.0) WRITE (LU) SYMFIX
C	    IF (FIXFLAG.AND.NCHARS.GT.0) 
C	1   WRITE (LU) SYMFIX,(TEXT(I),I=1,NCHARS)
C  The following lines are for Mac OS with the Absoft compiler
C  and permit the plot file to be compatible with the Linux version.
C  In addition, compiler switches of -N3 and -N27 must be used.
	    IF (COMMAND(PLT$B_OPC).EQ.PLT$OP_PLOTDOWN.OR.
	1   COMMAND(PLT$B_OPC).EQ.PLT$OP_PLOTUP.OR.
	2   COMMAND(PLT$B_OPC).EQ.PLT$OP_SYMBOL.OR.
	3   COMMAND(PLT$B_OPC).EQ.PLT$OP_ORIG.OR.
	4   COMMAND(PLT$B_OPC).EQ.PLT$OP_SYMBDOWN.OR.
	5   COMMAND(PLT$B_OPC).EQ.PLT$OP_SYMBUP.OR.
	6   COMMAND(PLT$B_OPC).EQ.PLT$OP_LINESTYLE.OR.
	7   COMMAND(PLT$B_OPC).EQ.PLT$OP_DATALEVEL.OR.
	8   COMMAND(PLT$B_OPC).EQ.PLT$OP_FILLSTYLE.OR.
	9   COMMAND(PLT$B_OPC).EQ.PLT$OP_PENWIDTH) THEN
	      WRITE(LU) COMMAND(0),COMMAND(2),COMMAND(1),COMMAND(4),
	1     COMMAND(3) !  Conversion from big endian to little endian for I2
	    ELSE
	      WRITE(LU) COMMAND(0),(COMMAND(I),I=4,1,-1) !  For I4 and REAL*4
	    END IF
	    IF (COMMAND(PLT$B_OPC).EQ.PLT$OP_ENDFILE) CLOSE(LU)
	    IF (FIXFLAG.AND.NCHARS.LE.0) THEN
	      WRITE(LU) SYMFIX(2),SYMFIX(1),SYMFIX(4),SYMFIX(3),SYMFIX(6),
	1     SYMFIX(5) !  For I2
	    END IF
	    IF (FIXFLAG.AND.NCHARS.GT.0) then
	      WRITE(LU) SYMFIX(2),SYMFIX(1),SYMFIX(4),SYMFIX(3),SYMFIX(6),
	1     SYMFIX(5),(TEXT(I),I=1,NCHARS)
	    END IF
	  END IF
	  IF (NDEV.EQ.5) THEN
c	    CALL IMAGENPLOT(COMMAND,SYMFIX,TEXT,0,0,1.,1.,0.,ISTAT)
	  END IF
	  IF (NDEV.EQ.6) THEN
	    MAXX=1
C  Array will have been initialized in PLTDEV
c	    CALL PRINTPLOT(COMMAND,SYMFIX,TEXT,ARRAY,1,MAXX,
c	1   0,0,1.,1.,0.,ISTAT)
	  END IF
	  IF (NDEV.EQ.7) THEN
c	    CALL T4662PLOT(COMMAND,SYMFIX,TEXT,0,0,1.,1.,0.,ISTAT)
	  END IF
	  IF (ABS(NDEV).EQ.8) THEN
c	    CALL GRINPLOT(COMMAND,SYMFIX,TEXT,0,0,1.,1.,0.,ISTAT)
	  END IF
	  IF (NDEV.EQ.9) THEN
c	    CALL HOUSTPLOT(COMMAND,SYMFIX,TEXT,0,0,1.,1.,0.,ISTAT)
	  END IF
	  IF (ABS(NDEV).EQ.10) THEN
c	    CALL LASERPLOT(COMMAND,SYMFIX,TEXT,0,0,1.,1.,0.,ISTAT)
	  END IF
	  IF (ABS(NDEV).EQ.11.OR.ABS(NDEV).EQ.211.OR.
	1 ABS(NDEV).EQ.311.OR.ABS(NDEV).EQ.411.OR.ABS(NDEV).EQ.511.OR.
	2 ABS(NDEV).EQ.611.OR.ABS(NDEV).EQ.9011) THEN
	    CALL APPLEPLOT(COMMAND,SYMFIX,TEXT,0,0,1.,1.,0.,ISTAT)
	  END IF
	  IF (ABS(NDEV).EQ.12) THEN
c	    CALL TRAPIXPLOT(COMMAND,SYMFIX,TEXT,0,0,1.,1.,0.,ISTAT)
	  END IF
	  IF (ABS(NDEV).EQ.13) THEN
	    CALL SAOPLOT(COMMAND,SYMFIX,TEXT,0,0,1.,1.,0.,ISTAT)
	  END IF
	END DO
	RETURN
	END
