	SUBROUTINE XYPLOT_SETUP(UNIT)
C
C  Note:  This is the Unix version
C
C       This subroutine helps XYPLOT_ASCII by obtaining the indexes
C  of the setup parameters for XYPLOT and putting them into a COMMON 
C  block for usage by XYPLOT_ASCII1.FOR.  By default, this subroutine
C  looks for xyplot_setup.dat unless the user specifies a different
C  file name.  If for some reason, the setup file cannot be found or doesn't
C  exist, INDEX_TOTAL is returned as zero, and is
C  used as a flag by XYPLOT_ASCII1 to use simple defaults.
C
C					Donald H. Gudehus, July, 1992
C				Version 2, D. Gudehus, October, 1994
C				Fixed bug in SYMBOL section
C				Version 2U, D. Gudehus, January 28, 2000
C				Converted code to Unix
C				Version 2UM, D. Gudehus, February 6, 2005
C				Modified USRINP for Absoft compiler on Mac OS
C				Version 3, D. Gudehus, March 13, 2008
C				Changed size of FILENAME
C
	INTEGER UNIT
	CHARACTER*80 STRING,STRING2
C
	CHARACTER*80 FILENAME
	COMMON /CFILE/ FILENAME
C
	COMMON /XYPLOT__SETUP/ INDEX_TOTAL,INDEX_LINVECT,INDEX_PENWIDTH,
	1INDEX_LINTYPE,INDEX_SYMBOL,INDEX_SYMBOLHEIGHT,INDEX_COLOR,
	2NUMBER_LINVECT,NUMBER_PENWIDTH,NUMBER_LINTYPE,
	3NUMBER_SYMBOL,NUMBER_SYMBOLHEIGHT,NUMBER_COLOR
C
	CHARACTER*7 INVERT_X,INVERT_Y
	CHARACTER*50 XLABEL,YLABEL,TITLE
	COMMON /XYPLOT__SETUP_CHAR/ INVERT_X,INVERT_Y,XLABEL,YLABEL,TITLE
C
	INDEX_TOTAL=0
	FILENAME='xyplot_setup.dat'
	CALL USRINP_CHAR(1,'A',80,1,'SETUP_FILE=',
	1'Open the setup file:  (default = xyplot_setup.dat)',
	2%REF(FILENAME))
	CALL ALPHA(%REF(FILENAME),1,80,NC,NF,NR,1)
	FILENAME=FILENAME(1:NC)
	OPEN(UNIT=UNIT,FILE=FILENAME,TYPE='OLD',READONLY,
	1CARRIAGECONTROL='NONE',ERR=99)
	GO TO 100  ! File was successfully opened
  99	CALL ERROR(-1,'xyplot_setup.dat was not found')
	CALL MESSAGE('Simple defaults will be used instead')
	RETURN  ! Returns with INDEX_TOTAL=0
 100	REWIND (UNIT)
C  Get the total number of lines
	DO WHILE (.TRUE.)
	  READ (UNIT,3000,END=199) STRING
3000	  FORMAT (A)
	  INDEX_TOTAL=INDEX_TOTAL+1
	END DO
C Get the LINE VECTOR STYLE indexes
 199	STRING=' '
	STRING2=' '
	INDEX_LINVECT=0
	NUMBER_LINVECT=0
	REWIND (UNIT)
C  Find a line with the characters LINE VECTOR STYLE
	DO WHILE (STRING(1:17).NE.'LINE VECTOR STYLE') 
	  READ (UNIT,3000,END=299) STRING
	  INDEX_LINVECT=INDEX_LINVECT+1
	  IF (STRING(1:17).EQ.'LINE VECTOR STYLE') THEN
C  Find some succeeding lines which are not descriptions
	    DO WHILE (STRING2(1:9).NE.'PEN WIDTH'.AND.STRING2(1:9).NE.
	1   'LINE TYPE'.AND.STRING2(1:6).NE.'SYMBOL'.AND.STRING2(1:13)
	2   .NE.'SYMBOL HEIGHT'.AND.STRING2(1:8).NE.
	2   'INVERT X'.AND.STRING2(1:8).NE.'INVERT Y'.AND.STRING2(1:5)
	2   .NE.'COLOR'.AND.STRING2(1:7).NE.'X LABEL'.AND.STRING2(1:7)
	3   .NE.'Y LABEL'.AND.STRING2(1:5).NE.'TITLE')
	      NUMBER_LINVECT=NUMBER_LINVECT+1
	      READ (UNIT,3000,END=299) STRING2
	    END DO
	  END IF
	END DO
 299	NUMBER_LINVECT=NUMBER_LINVECT-1
C Get the PEN WIDTH indexes
	STRING=' '
	STRING2=' '
	INDEX_PENWIDTH=0
	NUMBER_PENWIDTH=0
	REWIND (UNIT)
	DO WHILE (STRING(1:9).NE.'PEN WIDTH') 
	  READ (UNIT,3000,END=399) STRING
	  INDEX_PENWIDTH=INDEX_PENWIDTH+1
	  IF (STRING(1:9).EQ.'PEN WIDTH') THEN
	    DO WHILE (STRING2(1:17).NE.'LINE VECTOR STYLE'.AND.
	1   STRING2(1:9).NE.'LINE TYPE'.AND.STRING2(1:6).NE.'SYMBOL'
	2   .AND.STRING2(1:13).NE.'SYMBOL HEIGHT'.AND.
	2   STRING2(1:8).NE.'INVERT X'.AND.STRING2(1:8).NE.'INVERT Y'.AND.
	3   STRING2(1:5).NE.'COLOR'.AND.STRING2(1:7).NE.'X LABEL'.AND.
	4   STRING2(1:7).NE.'Y LABEL'.AND.STRING2(1:5).NE.'TITLE')
	      NUMBER_PENWIDTH=NUMBER_PENWIDTH+1
	      READ (UNIT,3000,END=399) STRING2
	    END DO
	  END IF
	END DO
 399	NUMBER_PENWIDTH=NUMBER_PENWIDTH-1
C Get the LINE TYPE indexes
	STRING=' '
	STRING2=' '
	INDEX_LINTYPE=0
	NUMBER_LINTYPE=0
	REWIND (UNIT)
	DO WHILE (STRING(1:9).NE.'LINE TYPE') 
	  READ (UNIT,3000,END=499) STRING
	  INDEX_LINTYPE=INDEX_LINTYPE+1
	  IF (STRING(1:9).EQ.'LINE TYPE') THEN
	    DO WHILE (STRING2(1:17).NE.'LINE VECTOR STYLE'.AND.STRING2(1:9).NE.
	1   'PEN WIDTH'.AND.STRING2(1:6).NE.'SYMBOL'.AND.STRING2(1:13)
	2   .NE.'SYMBOL HEIGHT'.AND.STRING2(1:8).NE.
	2   'INVERT X'.AND.STRING2(1:8).NE.'INVERT Y'.AND.STRING2(1:5)
	2   .NE.'COLOR'.AND.STRING2(1:7).NE.'X LABEL'.AND.STRING2(1:7)
	3   .NE.'Y LABEL'.AND.STRING2(1:5).NE.'TITLE')
	      NUMBER_LINTYPE=NUMBER_LINTYPE+1
	      READ (UNIT,3000,END=499) STRING2
	    END DO
	  END IF
	END DO
 499	NUMBER_LINTYPE=NUMBER_LINTYPE-1
C Get the SYMBOL indexes
	STRING=' '
	STRING2=' '
	INDEX_SYMBOL=0
	NUMBER_SYMBOL=0
	REWIND (UNIT)
	DO WHILE (STRING(1:6).NE.'SYMBOL') 
	  READ (UNIT,3000,END=599) STRING
	  INDEX_SYMBOL=INDEX_SYMBOL+1
	  IF (STRING(1:6).EQ.'SYMBOL') THEN
	    DO WHILE (STRING2(1:17).NE.'LINE VECTOR STYLE'.AND.STRING2(1:9).NE.
	1   'PEN WIDTH'.AND.STRING2(1:9).NE.'LINE TYPE'.AND.STRING2(1:13)
	2   .NE.'SYMBOL HEIGHT'.AND.STRING2(1:8).NE.
	2   'INVERT X'.AND.STRING2(1:8).NE.'INVERT Y'.AND.STRING2(1:5)
	2   .NE.'COLOR'.AND.STRING2(1:7).NE.'X LABEL'.AND.STRING2(1:7)
	3   .NE.'Y LABEL'.AND.STRING2(1:5).NE.'TITLE')
	      NUMBER_SYMBOL=NUMBER_SYMBOL+1
	      READ (UNIT,3000,END=599) STRING2
	    END DO
	  END IF
	END DO
 599	NUMBER_SYMBOL=NUMBER_SYMBOL-1
C Get the SYMBOL HEIGHT values
	STRING=' '
	STRING2=' '
	INDEX_SYMBOLHEIGHT=0
	NUMBER_SYMBOLHEIGHT=0
	REWIND (UNIT)
	DO WHILE (STRING(1:13).NE.'SYMBOL HEIGHT') 
	  READ (UNIT,3000,END=699) STRING
	  INDEX_SYMBOLHEIGHT=INDEX_SYMBOLHEIGHT+1
	  IF (STRING(1:13).EQ.'SYMBOL HEIGHT') THEN
	    DO WHILE (STRING2(1:17).NE.'LINE VECTOR STYLE'.AND.STRING2(1:9).NE.
	1   'PEN WIDTH'.AND.STRING2(1:9).NE.'LINE TYPE'.AND.STRING2(1:8).NE.
	2   'INVERT X'.AND.STRING2(1:8).NE.'INVERT Y'.AND.STRING2(1:5)
	2   .NE.'COLOR'.AND.STRING2(1:7).NE.'X LABEL'.AND.STRING2(1:7)
	3   .NE.'Y LABEL'.AND.STRING2(1:5).NE.'TITLE')
	      NUMBER_SYMBOLHEIGHT=NUMBER_SYMBOLHEIGHT+1
	      READ (UNIT,3000,END=699) STRING2
	    END DO
	  END IF
	END DO
 699	NUMBER_SYMBOLHEIGHT=NUMBER_SYMBOLHEIGHT-1
C Get INVERT for the X axis
	STRING=' '
	STRING2=' '
	REWIND (UNIT)
	DO WHILE (STRING(1:8).NE.'INVERT X') 
	  READ (UNIT,3000,END=799) STRING
	  IF (STRING(1:8).EQ.'INVERT X') THEN
	    READ (UNIT,3000,END=799) STRING2
	    INVERT_X=STRING2
	  END IF
	END DO
C Get INVERT for the Y axis
 799	STRING=' '
	STRING2=' '
	REWIND (UNIT)
	DO WHILE (STRING(1:8).NE.'INVERT Y') 
	  READ (UNIT,3000,END=899) STRING
	  IF (STRING(1:8).EQ.'INVERT Y') THEN
	    READ (UNIT,3000,END=899) STRING2
	    INVERT_Y=STRING2
	  END IF
	END DO
C Get the COLOR indexes
 899	STRING=' '
	STRING2=' '
	INDEX_COLOR=0
	NUMBER_COLOR=0
	REWIND (UNIT)
	DO WHILE (STRING(1:5).NE.'COLOR') 
	  READ (UNIT,3000,END=999) STRING
	  INDEX_COLOR=INDEX_COLOR+1
	  IF (STRING(1:5).EQ.'COLOR') THEN
	    DO WHILE (STRING2(1:17).NE.'LINE VECTOR STYLE'.AND.STRING2(1:9).NE.
	1   'PEN WIDTH'.AND.STRING2(1:9).NE.'LINE TYPE'.AND.STRING2(1:6)
	2   .NE.'SYMBOL'.AND.STRING2(1:13)
	2   .NE.'SYMBOL HEIGHT'.AND.STRING2(1:8).NE.'INVERT X'.AND.STRING2(1:8)
	3   .NE.'INVERT Y'.AND.STRING2(1:7).NE.'X LABEL'.AND.STRING2(1:7)
	4   .NE.'Y LABEL'.AND.STRING2(1:5).NE.'TITLE')
	      NUMBER_COLOR=NUMBER_COLOR+1
	      READ (UNIT,3000,END=999) STRING2
	    END DO
	  END IF
	END DO
 999	NUMBER_COLOR=NUMBER_COLOR-1
C Get the XLABEL
 	STRING=' '
	REWIND (UNIT)
	DO WHILE (STRING(1:8).NE.'X LABEL') 
	  READ (UNIT,3000,END=1099) STRING
3050	  FORMAT(A50)
	  IF (STRING(1:8).EQ.'X LABEL') THEN
	    READ (UNIT,3050,END=1099) XLABEL
	  END IF
	END DO
C Get the YLABEL
1099	STRING=' '
	REWIND (UNIT)
	DO WHILE (STRING(1:8).NE.'Y LABEL') 
	  READ (UNIT,3000,END=1199) STRING
	  IF (STRING(1:8).EQ.'Y LABEL') THEN
	    READ (UNIT,3050,END=1199) YLABEL
	  END IF
	END DO
C Get the TITLE
1199	STRING=' '
	REWIND (UNIT)
	DO WHILE (STRING(1:8).NE.'TITLE') 
	  READ (UNIT,3000,END=1299) STRING
	  IF (STRING(1:8).EQ.'TITLE') THEN
	    READ (UNIT,3050,END=1299) TITLE
	  END IF
	END DO
1299	RETURN
	END
