	SUBROUTINE PENMODE(LWIDTH)
C
C       This subroutine sets the width of the vector (in 1000ths of an
C  inch) to be displayed on the plot device and puts the value in the common
C  block PLOT$PENWIDTH and then calls PLOT to send the value to the
C  device driver or to a plot file.
C       For the LASERGRAFIX, the allowable values measured in pixels, range 
C  from 1 to 31  Only odd values are allowed;  even ones will be rounded up 
C  to the next higher odd number.  In thousandths of an inch, these values 
C  are 3, 10, 17, 23, 30, 37, 43, 50, 57, etc.  
C       For the Apple Laser Writer, there is no rounding of widths measured
C  in pixels.  The allowable values in thousandths of an inch are are 3, 7, 
C  10, 13, 17, 20, 23, 27, 30, 33, 37, 40, 43, 47, 50, 53, 57, etc.
C
C        LASERGRAFIX			LASERWRITER
C   1/1000 inch    pixels            1/1000 inch      pixels (300 dpi)
C      3             1                   3              1
C     10             3                   7              2
C     17             5                  10              3
C     23             7                  13              4
C     30             9                  17              5
C     37            11                  20              6
C     43            13                  23              7
C     50            15                  27              8
C     57            17                  30              9
C      .             .                  33             10
C      .             .                   .              .
C      .             .                   .              .
C      .             .                   .              .

C			Donald H. Gudehus, October, 1984
C
C	LWIDTH	(C)	The width of the line desired on the plotting
C			device, measured in thousandths of an inch.
C
	INTEGER*4 WIDTH
	COMMON /PLOT_PENWIDTH/ WIDTH
C
	WIDTH=LWIDTH
	CALL PLOT(0.0,0.0,12)
	RETURN
	END
