	SUBROUTINE PLOT(X,Y,IPEN)
C
C  Note:  This is the Unix version
C
C       This subroutine is a generalized plotting command where X and
C  Y are measured in inches (rather than in pixels of a particular
C  device).
C		Greg Quinn, Mount Stromlo Observatory, June 1980
C
C			Version 2, Donald H. Gudehus, October, 1982
C			Added command for IPEN=4 to return to the
C			transparent mode
C			Version 3, Donald H. Gudehus, October, 1983
C			Added command for IPEN=5 to set the line style
C			Version 4, Donald H. Gudehus, December, 1983
C			Added command for IPEN=6 to set the color mode
C			Version 5, Donald H. Gudehus, January, 1984
C			Added code for IPEN=1, to go to the point plot
C			mode, IPEN=7, to ring the device bell, and
C			IPEN=8, to set the data level
C			Version 6, Donald H. Gudehus, February, 1984
C			Added code for IPEN=9, to go to the rectilinear
C			graphics mode, IPEN=10, to go to the
C			alphagraphics mode, and IPEN=11, to set the
C			filling style.
C			Version 7, Donald H. Gudehus, October, 1984
C			Added code for IPEN=12
C			Version 8, Donald H. Gudehus, March, 1988
C			Declared SYS$NUMARGS 
C			Version 9, Donald H. Gudehus, October, 1994
C			Introduced IPEN=13 to 15 for SAOimage
C			Version 9U, Donald H. Gudehus, December, 1999
C			Introduced ENTRY PLOT_LU for Unix which can't
C			handle variable length argument lists. 
C			Version 10, Donald H. Gudehus, January 20, 2000
C			Introduced IPEN=18 for flushing the buffer, as
C			required under Unix.
C			Version 11, Donald H. Gudehus, January 22, 2000
C			Introduced IPEN=19 for setting the background color.
C			Version 12, Donald H. Gudehus, January 29, 2008
C			Introduced BCOM to avoid compiler warnings
C
	REAL X,Y
C
	BYTE COMMAND(0:4),BCOM(4)
	BYTE DUMMY1(1),DUMMY6(6)	
	INTEGER*2 I2COM(0:2)
	INTEGER FILL,WIDTH,I4COM
	LOGICAL ENTRY_P_LU,ENTRY_F_LU
	REAL R4COM
C	EQUIVALENCE (COMMAND(1),I2COM(0),R4COM,I4COM)
	EQUIVALENCE (BCOM(1),I2COM(0),R4COM,I4COM)
C
	INTEGER LCOLOR,LBCOLOR
	COMMON /PLOT_COLOR/ LCOLOR,LBCOLOR
C
	COMMON /PLOT_DATALEVEL/ LEVEL
C
	COMMON /PLOT_LINESTYLE/ MODE
C
	COMMON /PLOT_FILLSTYLE/ FILL
C
	COMMON /PLOT_PENWIDTH/ WIDTH
C
	COMMON /PLOT_SAVE/XSAVE,YSAVE,FACTSAVE
C
	LOGICAL SOFTVECTOR
	COMMON /PLOT_VECTOR2/ SOFTVECTOR,NIBSDOWN,NIBSUP,NIBSDOWN2,
	1NIBSUP2
C
	INCLUDE 'plotpar.for'
C
	ENTRY_P_LU=.FALSE.
	GO TO 1
C
	ENTRY PLOT_LU(X,Y,IPEN,LU)
C
	ENTRY_P_LU=.TRUE.
   1	IF (ENTRY_P_LU) THEN
	  LUFILE=LU
	ELSE
	  LUFILE=79
	END IF
C
	IF (IPEN.EQ.9999) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_ENDFILE
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.999) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_ENDPLOT
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.1) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_POINTPLOT
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.2.OR.IPEN.EQ.3) THEN
	  IF (IPEN.EQ.2) THEN
	    COMMAND(PLT$B_OPC)=PLT$OP_PLOTDOWN
	  ELSE
	    COMMAND(PLT$B_OPC)=PLT$OP_PLOTUP
	  END IF
	  I2COM(PLT$W_X)=NINT(X*PLT$C_NIBS)
	  I2COM(PLT$W_Y)=NINT(Y*PLT$C_NIBS)
	  DO I=1,4
	    COMMAND(I)=BCOM(I)
	  END DO
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.-2.OR.IPEN.EQ.-3) THEN
	  IF (IPEN.EQ.-2) THEN
	    COMMAND(PLT$B_OPC)=PLT$OP_PLOTDOWN
	  ELSE
	    COMMAND(PLT$B_OPC)=PLT$OP_PLOTUP
	  END IF
	  I2COM(PLT$W_X)=NINT(X*PLT$C_NIBS)
	  I2COM(PLT$W_Y)=NINT(Y*PLT$C_NIBS)
	  DO I=1,4
	    COMMAND(I)=BCOM(I)
	  END DO
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
	  COMMAND(PLT$B_OPC)=PLT$OP_ORIG
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.4) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_ENDALPHA
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.5) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_LINESTYLE
	  I2COM(PLT$B_LINESTYLE)=MODE
	  DO I=1,4
	    COMMAND(I)=BCOM(I)
	  END DO
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.6) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_COLOR
	  I4COM=LCOLOR
	  DO I=1,4
	    COMMAND(I)=BCOM(I)
	  END DO
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.7) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_BELL
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.8) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_DATALEVEL
	  I2COM(PLT$B_DATALEVEL)=LEVEL
	  DO I=1,4
	    COMMAND(I)=BCOM(I)
	  END DO
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.9) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_RECTILINEAR
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.10) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_ALPHAGRAPHICS
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.11) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_FILLSTYLE
	  I2COM(PLT$B_FILLSTYLE)=FILL
	  DO I=1,4
	    COMMAND(I)=BCOM(I)
	  END DO
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.12) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_PENWIDTH
	  I2COM(PLT$B_PENWIDTH)=WIDTH
	  DO I=1,4
	    COMMAND(I)=BCOM(I)
	  END DO
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.13) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_IMMEDIATE
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.14) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_DELAYED
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.15) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_SHOWVECT
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
C  IPEN=16 and IPEN=17 are used in SAO
C
	ELSE IF (IPEN.EQ.18) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_FLUSHBUFFER
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE IF (IPEN.EQ.19) THEN
	  COMMAND(PLT$B_OPC)=PLT$OP_BACKGROUNDCOLOR
	  I4COM=LBCOLOR
	  DO I=1,4
	    COMMAND(I)=BCOM(I)
	  END DO
	  CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
C
	ELSE
	  CALL PRTMSG(PLT$S_ILLIPEN,'F'X)
	END IF
	XSAVE=X
	YSAVE=Y
	RETURN
C
C
	ENTRY PLOTS
	RETURN
C
C
	ENTRY FACTOR(FACT)
C
	ENTRY_F_LU=.FALSE.
	GO TO 2
C
	ENTRY FACTOR_LU(FACT,LU)
C
	ENTRY_F_LU=.TRUE.
   2	IF (ENTRY_F_LU) THEN
	  LUFILE=LU
	ELSE
	  LUFILE=79
	END IF
	COMMAND(PLT$B_OPC)=PLT$OP_FACTOR
	R4COM=FACT
	DO I=1,4
	  COMMAND(I)=BCOM(I)
	END DO
	CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
	FACTSAVE=FACT
	RETURN
C
C
	ENTRY VWHERE(X,Y,FACT)
	X=XSAVE
	Y=YSAVE
	FACT=FACTSAVE
	RETURN
C
C
	ENTRY NEWPEN
	COMMAND(PLT$B_OPC)=PLT$OP_NEWPEN
	CALL PLT_WRITE(COMMAND,DUMMY6,.FALSE.,DUMMY1,0,LUFILE)
	RETURN
	END
