	SUBROUTINE PLOTDEVICES(DEVICES)
C
C  Note:  This is the Unix version.
C
C	This subroutine obtains the plot device or devices from the user.
C  and places the information in the array DEVICES.  The subroutine
C  PLOTDEVICES2 should then be called to intialize the devices.  This
C  subroutine is the user friendly interface to PLTDEV.  That subroutine
C  can still be called in the old way with a device number, but fewer 
C  combinations of plot devices will be available and if the LASERGRAFIX
C  (DEVICE=10) or Apple Laserwriter (DEVICE=11) is chosen, printing will
C  not occur immediately;  the user must submit VECT.RPL for printing with 
C  the /NOFEED qualifier in the case of the LASERGRAFIX.  In the case of 
C  multiple plotdevices, the first chosen device is used for readback of
C  cursor coordinates.  
C       The devices for which the user is prompted will depend on which
C  devices are supported at a particular facility.  The user should 
C  comment out with a ! in the file 
C  [MIIPS.PLOT]DISPLAY-PLOTTING_AVAILABILITY.DAT those devices which are
C  not supported.  If the file cannot be found, all devices will be prompted
C  for.
C       The object code for this module should be placed
C  in the PAN library.
C					Donald H. Gudehus, February, 1987
C			Version 2, Donald H. Gudehus, June, 1993
C			Added code for determining what devices are supported
C			at a facility, via the file 
C			DISPLAY-PLOTTING_AVAILABILITY.DAT.
C			Version 3, Donald H. Gudehus, October, 1994
C			Added code for SAOimage
C			Version 4, Donald H. Gudehus, November, 1994
C			Change logic for writing to a file
C			Version 5, Donald H. Gudehus, July, 1995
C			Fixed bug where if impossible device was selected,
C			an infinite loop resulted.
C			Version 6, Donald H. Gudehus, October, 1998
C			Made Xterm the default.
C			Version 6U, Donald H. Gudehus, December 2, 1999
C			Modified code for Unix.
C
C	DEVICES		(C)	An array containing the desired plot devices.
C				Up to 10 devices can be selected at the same
C				time.  One must use the 1 to 3 character
C				abbreviations for the devices listed below
C				in the code.  An arbitrary number of blanks
C				may be imbedded in the entry.  If DEVICES
C				is set to blank, then the user will be 
C				prompted for all the available devices,
C				providing that the setup file 
C				display-plotting_availability.dat can be 
C				found.  If this file is not found, then all 
C				supported devices are prompted for.

	CHARACTER*3 DEVICES(10)
	INTEGER CHANNELS(10),DEVICENUMBERS(10)
	COMMON /PLOT_DEVICES/ NUMBERDEVICES,CHANNELS,DEVICENUMBERS,NDEVICE,
	1NLOWER
C
	CHARACTER*3 DUMDEVICES(10)
	COMMON /PLOT_CHAR_DEVICES/ DUMDEVICES
C
C  The following COMMON block is loaded with information about what 
C  on-line plotting devices the user's facility has available
	CHARACTER*80 DISPLAY_PLOTTING$DEVICES(100)
	LOGICAL DP_AVAILABILITY$FOUND
	COMMON /PLOTTING_AVAILABILITY/ DISPLAY_PLOTTING$DEVICES,
	1DP_AVAILABILITY$FOUND,N_DP$DEVICES
C
	COMMON /PLOT_CHAN/ NCHAN,NDEV
C
   1	IF (DEVICES(1).EQ.' ') THEN
	  DO I=1,10
	    DEVICES(I)=' '
	  END DO
	  CALL MESSAGE('Enter the plot devices:')
	  IF (.NOT.DP_AVAILABILITY$FOUND) THEN
C Prompt for all devices if the file wasn't found
	    DEVICES(1)='X'
	    CALL MESSAGE('     G   = Graphics terminal (VT100/Retrographics'//
	1   ' and Visual 550)')
	    CALL MESSAGE('     G1  = Graphics terminal (GraphOn)')
	    CALL MESSAGE('     G2  = Graphics terminal (Codonics)')
	    CALL MESSAGE('     G3  = Graphics terminal (Micro-term)')
	    CALL MESSAGE('     G4  = Graphics terminal emulator '//
	1   '(Versaterm-Pro)')
	    CALL MESSAGE('     X   = Xterm (default)')
	    CALL MESSAGE('     XG  = Xgterm')
c	    CALL MESSAGE('     R   = Ramtek')
c	    CALL MESSAGE('     I   = Imagen')
c	    CALL MESSAGE('     P   = Printronix')
c	    CALL MESSAGE('     T   = Tektronix 4662 flat bed plotter'//
c	1   ' (1200 baud)')
c	    CALL MESSAGE('     GR  = Grinnell')
c	    CALL MESSAGE('    -GR  = Grinnell, no erasure of screen')
c	    CALL MESSAGE('     L   = QMS Lasergrafix 1200')
c	    CALL MESSAGE('     H   = Houston')
c	    CALL MESSAGE('     A   = Apple Laserwriter')
c	    CALL MESSAGE('     A2  = Apple Laserwriter #2')
c	    CALL MESSAGE('     A3  = Apple Laserwriter #3')
c	    CALL MESSAGE('     A4  = Apple Laserwriter #4')
c	    CALL MESSAGE('     A5  = Apple Laserwriter #5')
c	    CALL MESSAGE('     A6  = Apple Laserwriter #6')
c	    CALL MESSAGE('     LPS = LPS40')
c	    CALL MESSAGE('     TR  = Trapix')
c	    CALL MESSAGE('    -TR  = Trapix, no erasure of screen')
	    CALL MESSAGE('     S   = SAOimage (Enhanced version)')
	    CALL MESSAGE('    -S   = SAOimage, no erasure of screen')
	    CALL MESSAGE('     F   = File')
	  ELSE
	    DO I=1,N_DP$DEVICES
	      IF (DISPLAY_PLOTTING$DEVICES(I).EQ.
	1       'VT100/Retrographics, Visual 550') THEN
	        DEVICES(1)='X'
	        CALL MESSAGE('     G   = Graphics terminal'//
	1       ' (VT100/Retrographics and Visual 550)')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Graphon') THEN
	        CALL MESSAGE('     G1  = Graphics terminal (GraphOn)')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Codonics') THEN
	        CALL MESSAGE('     G2  = Graphics terminal (Codonics)')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Micro-term') THEN
	        CALL MESSAGE('     G3  = Graphics terminal (Micro-term)')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Versaterm') THEN
	        CALL MESSAGE('     G4  = Graphics terminal emulator'//
	1       ' (Versaterm)')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Xterm') THEN
	        CALL MESSAGE('     X   = Xterm (default)')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Xgterm') THEN
	        CALL MESSAGE('     XG  = Xgterm')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Imagen') THEN
c	        CALL MESSAGE('     I   = Imagen')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Printronix') THEN
c	        CALL MESSAGE('     P   = Printronix')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Tektronix 4662') THEN
c	      CALL MESSAGE('     T   = Tektronix 4662 flat bed plotter'//
c	1     ' (1200 baud)')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Houston') THEN
c	        CALL MESSAGE('     H   = Houston')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Lasergrafix 1200') THEN
c	        CALL MESSAGE('     L   = QMS Lasergrafix 1200')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I)
	1     .EQ.'Apple LaserWriter') THEN
c	        CALL MESSAGE('     A   = Apple Laserwriter')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I)
	1     .EQ.'Apple LaserWriter #2') THEN
c	        CALL MESSAGE('     A2  = Apple Laserwriter #2')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I)
	1     .EQ.'Apple LaserWriter #3') THEN
c	        CALL MESSAGE('     A3  = Apple Laserwriter #3')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I)
	1     .EQ.'Apple LaserWriter #4') THEN
c	        CALL MESSAGE('     A4  = Apple Laserwriter #4')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I)
	1     .EQ.'Apple LaserWriter #5') THEN
c	        CALL MESSAGE('     A5  = Apple Laserwriter #5')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I)
	1     .EQ.'Apple LaserWriter #6') THEN
c	        CALL MESSAGE('     A6  = Apple Laserwriter #6')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Digital LPS40') THEN
c	        CALL MESSAGE('     LPS = LPS40')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Grinnell 270') THEN
c	        CALL MESSAGE('     GR  = Grinnell')
c	        CALL MESSAGE('    -GR  = Grinnell, no erasure of screen')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Ramtek') THEN
c	        CALL MESSAGE('     R   = Ramtek')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'Trapix') THEN
c	        CALL MESSAGE('     TR  = Trapix')
c	        CALL MESSAGE('    -TR  = Trapix, no erasure of screen')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'SAOimage') THEN
	        CALL MESSAGE('     S   = SAOimage (Enhanced version)')
	        CALL MESSAGE('    -S   = SAOimage, no erasure of screen')
	      ELSE IF (DISPLAY_PLOTTING$DEVICES(I).EQ.'File') THEN
	        CALL MESSAGE('     F   = File')
	      END IF
	    END DO
	  END IF
	  CALL USRINP(%REF(DEVICES),10,'A',3,1,'DEVICES=',' ')
	END IF
	CALL ALPHA(%REF(DEVICES),10,3,NC,NF,NX,4)
C  Check for bad inputs
	DO I=1,NF
	  IF (DEVICES(I).NE.'G'.AND.DEVICES(I).NE.'G1'
	1 .AND.DEVICES(I).NE.'G2'.AND.DEVICES(I).NE.'G3'
	2 .AND.DEVICES(I).NE.'G4'
	3 .AND.DEVICES(I).NE.'X'.AND.DEVICES(I).NE.'XG'
	4 .AND.DEVICES(I).NE.'R'.AND.DEVICES(I).NE.'I'
	5 .AND.DEVICES(I).NE.'P'.AND.DEVICES(I).NE.'T'
	6 .AND.DEVICES(I).NE.'GR'.AND.DEVICES(I).NE.'-GR'
	7 .AND.DEVICES(I).NE.'L'.AND.DEVICES(I).NE.'H'
	8 .AND.DEVICES(I).NE.'A'.AND.DEVICES(I).NE.'A2'
	9 .AND.DEVICES(I).NE.'A3'.AND.DEVICES(I).NE.'A4'
	1 .AND.DEVICES(I).NE.'A5'.AND.DEVICES(I).NE.'A6'
	2 .AND.DEVICES(I).NE.'LPS'.AND.DEVICES(I).NE.'TR'
	3 .AND.DEVICES(I).NE.'-TR'.AND.DEVICES(I).NE.'S'
	4 .AND.DEVICES(I).NE.'-S'.AND.DEVICES(I).NE.'F') THEN
	    CALL MESSAGE('Impossible device selected;  try again')
	    DEVICES(1)=' '
	    GO TO 1
	  END IF
	END DO
	DO I=1,10
	  DUMDEVICES(I)=DEVICES(I)
	END DO
	NUMBERDEVICES=NF
	RETURN
	END
