	SUBROUTINE PLOTDEVICES2(DEVICES)
C
C	This subroutine obtains a channel and initializes each plot device
C  referenced in the array DEVICES and places the information in the 
C  COMMON block, PLOT_DEVICES.  This subroutine is the user friendly interface
C  to PLTDEV and allows more than one device to be used.  The first chosen
C  device is used for readback of cursor coordinates.  The object code for
C  this subroutine should be placed in the PLOT library.
C					Donald H. Gudehus, February, 1987
C			Version 2, Donald H. Gudehus, October, 1992
C			Added device numbers 401 and 10001.
C			Version 3, Donald H. Gudehus, June, 1993
C			Added device number 6.
C			Version 4, Donald H. Gudehus, October, 1994
C			Added device number 13.
C
	CHARACTER*3 DEVICES(10)
	INTEGER CHANNELS(10),DEVICENUMBERS(10),DEVICEINDEX
	COMMON /PLOT_DEVICES/ NUMBERDEVICES,CHANNELS,DEVICENUMBERS,DEVICEINDEX,
	1INDEXLOWER
C
	COMMON /PLOT_CHAN/ NCHAN,NDEV
C
	INDEXLOWER=1  ! The lower index in the loop in PLTWRITE
C  Operate this loop in reverse because the call to PLTDEV will call
C  FACTOR which will establish a local value of the factor for VWHERE
C  to use.  The first device given by the user is the one used for 
C  cursor coordinate readback;  therefore the factor corresponding to 
C  this device must be available for VWHERE to use.
	DO N=NUMBERDEVICES,1,-1
	  IF (DEVICES(N).EQ.'G') THEN
	    DEVICENUMBERS(N)=1
	  ELSE IF (DEVICES(N).EQ.'G1') THEN
	    DEVICENUMBERS(N)=101
	  ELSE IF (DEVICES(N).EQ.'G2') THEN
	    DEVICENUMBERS(N)=201
	  ELSE IF (DEVICES(N).EQ.'G3') THEN
	    DEVICENUMBERS(N)=301
	  ELSE IF (DEVICES(N).EQ.'G4') THEN
	    DEVICENUMBERS(N)=401
	  ELSE IF (DEVICES(N).EQ.'X') THEN
	    DEVICENUMBERS(N)=10001
	  ELSE IF (DEVICES(N).EQ.'XG') THEN
	    DEVICENUMBERS(N)=20001
	  ELSE IF (DEVICES(N).EQ.'F') THEN
	    DEVICENUMBERS(N)=2
	  ELSE IF (DEVICES(N).EQ.'R') THEN
	    DEVICENUMBERS(N)=3
	  ELSE IF (DEVICES(N).EQ.'I') THEN
	    DEVICENUMBERS(N)=5
	  ELSE IF (DEVICES(N).EQ.'P') THEN
	    DEVICENUMBERS(N)=6
	  ELSE IF (DEVICES(N).EQ.'T') THEN
	    DEVICENUMBERS(N)=7
	  ELSE IF (DEVICES(N).EQ.'GR') THEN
	    DEVICENUMBERS(N)=8
	  ELSE IF (DEVICES(N).EQ.'-GR') THEN
	    DEVICENUMBERS(N)=-8
	  ELSE IF (DEVICES(N).EQ.'H') THEN
	    DEVICENUMBERS(N)=9
	  ELSE IF (DEVICES(N).EQ.'L') THEN
	    DEVICENUMBERS(N)=10
	  ELSE IF (DEVICES(N).EQ.'A') THEN
	    DEVICENUMBERS(N)=11
	  ELSE IF (DEVICES(N).EQ.'A2') THEN
	    DEVICENUMBERS(N)=211
	  ELSE IF (DEVICES(N).EQ.'A3') THEN
	    DEVICENUMBERS(N)=311
	  ELSE IF (DEVICES(N).EQ.'A4') THEN
	    DEVICENUMBERS(N)=411
	  ELSE IF (DEVICES(N).EQ.'A5') THEN
	    DEVICENUMBERS(N)=511
	  ELSE IF (DEVICES(N).EQ.'A6') THEN
	    DEVICENUMBERS(N)=611
	  ELSE IF (DEVICES(N).EQ.'LPS') THEN
	    DEVICENUMBERS(N)=911
	  ELSE IF (DEVICES(N).EQ.'TR') THEN
	    DEVICENUMBERS(N)=12
	  ELSE IF (DEVICES(N).EQ.'-TR') THEN
	    DEVICENUMBERS(N)=-12
	  ELSE IF (DEVICES(N).EQ.'S') THEN
	    DEVICENUMBERS(N)=13
	  ELSE IF (DEVICES(N).EQ.'-S') THEN
	    DEVICENUMBERS(N)=-13
	  END IF
	  DEVICEINDEX=N
	  CALL PLTDEV(DEVICENUMBERS(N))
	END DO
	DEVICEINDEX=0
	RETURN
	END
