	SUBROUTINE PLTDEV(IDEV)
C
C  Note:  This is the Unix version.
C
C       This subroutine obtains a channel for a plot device and initializes
C  that device for the MIIPS plot package.  If IDEV=2 (command written to a
C  plot file), this subroutine only calls FACTOR followed by 
C  PLOT(-50.0,-50.0,-3).  This subroutine is called both for on-line plotting
C  and for plotting from a file.
C		Greg Quinn, Mount Stromlo Observatory, June 1980
C		Version 2, Greg Quinn, August, 1981
C		Added support for Tektronix 4662 plotter. (IDEV=7)
C		Version 3, Donald H. Gudehus, Dec., 1983
C		Added suppot for Grinnell (IDEV=8) and removed
C		call to NEWPEN(1).
C		Version 4, Donald H. Gudehus, October, 1984
C		Added support for the Lasergrafix (IDEV=10)
C		Version 5, Donald H. Gudehus, February 13, 1987
C		Added support for the GraphOn terminal (IDEV=101)
C		Version 6, Donald H. Gudehus, February 26, 1987
C		Added support for using several plot devices simultaneously
C		when called by PLOTDEVICES
C		Version 7, Donald H. Gudehus, March, 1987
C		Added code for Codonics corrupted terminal.
C		Version 8, Donald H. Gudehus, August, 1987
C		Added support for the Apple Laserwriter
C		Version 9, Jim Haywood, Jeff Youngen, August, 1988
C		Eliminated call to SYS$TRNLOG, not needed in VMS 5.
C		Version 10, Donald H. Gudehus, August, 1988
C		Added support for Imagen laser writer.
C		Version 11, Donald H. Gudehus, November, 1988
C		Added code for Micro-term terminal
C		Version 12, Donald H. Gudehus, November, 1988
C		Added code for Trapix
C		Version 13, Donald H. Gudehus, May, 1992
C		Added code for the Versaterm graphics terminal 
C		emulator.
C		Version 14, Donald H. Gudehus, June, 1993
C		Added code for the Printronix to do on-line plotting
C		Version 15, Donald H. Gudehus, October, 1994
C		Added code for SAOimage
C		Version 16, Donald H. Gudehus, June ,1999
C		Added code for EPS
C		Version 17, Donald H. Gudehus, June 24, 1999
C		Added call to SAO(0,0,17) to initialize but not load the VLT
C		Version 17U, Donald H. Gudehus, January 22, 2000
C		Modified code for Unix
C		Version 18, Donald H. Gudehus, March 30, 2000
C		Added code for Xgterm
C		Version 19, D. Gudehus, July 25, 2006
C		Incorporated new saofacts.for
C
C		The plot devices are identified as follows
C		
C		NDEV			DEVICE
C		  1			Graphics Terminal (VT100/Retrographics,
C					Visual 550)
C		101			Graphics Terminal (GraphOn)
C		201			Graphics Terminal (Codonics)
C		301			Graphics Terminal (Micro-term)
C		401			Graphics Terminal emulator (Versaterm)
C	      10001			Xterm
C	      20001			Xgterm
C		  2			File
C		  3			Ramtek
C		  4			1 and 2 (temporarily retained for 
C					compatibility)
C		  5			Imagen (via file)
C		  6			Printronix
C		  7			Tektronix 4662 flat bed plotter
C		  8			Grinnell
C		 -8			Grinnell without erasure
C		  9			Houston
C		 10			QMS Lasergrafix
C		-10			QMS Lasergrafix without opening the
C					VECT file (used in TEXPLOTCOM).
C		 11			Apple Laserwriter 
C		211			Apple Laserwriter #2
C		311			Apple Laserwriter #3
C		411			Apple Laserwriter #4
C		511			Apple Laserwriter #5
C		611			Apple Laserwriter #6
C	       9011			Digital LPS40
C	     999811			Encapsulated postscript file
C					(no printing)  	
C	     999911			Postscript file (no printing)  	
C	       -x11			Apple Laserwriter without opening
C					VECT file (used in TEXPLOTCOM).
C		 12			Trapix
C		-12			Trapix without erasure
C		 13			SAOimage
C		-13			SAOimage without erasure
C
	INTEGER CHANNELS(10),DEVICENUMBERS(10),DEVICEINDEX
	COMMON /PLOT_DEVICES/ NUMBERDEVICES,CHANNELS,DEVICENUMBERS,DEVICEINDEX,
	1INDEXLOWER
C
	COMMON /PLOT_CHAN/ NCHAN,NDEV
C
C	PARAMETER (NBYTES=134)
c	PARAMETER (NBYTES=130) !  Fudge for incorrectly configured Printronix
			       !  at UM
c	PARAMETER (NLINES=790)
c	BYTE ARRAY(NBYTES,NLINES) !  For Printronix
c	BYTE LF
c	PARAMETER (LF=10)
c	COMMON /PLOT_PRINTRONIX/ ARRAY
C
c	INTEGER*2 UNIT,PORT
c	COMMON /TRFACTS/ UNIT,PORT !  For Trapix
C
	INCLUDE 'saofacts.for'
C
C  Devices are added to this section if they require the services of the
C  print queue for on-line plotting.
	LOGICAL LASERGRAFIX,APPLE0,APPLE2,APPLE3,APPLE4,APPLE5,APPLE6,
	1LPS40,EPS,POSTSCRIPT,IMAGEN0
	COMMON /LIB_/ LASERGRAFIX,APPLE0,APPLE2,APPLE3,APPLE4,APPLE5,APPLE6,
	1LPS40,EPS,POSTSCRIPT,IMAGEN0
C
	LOGICAL INTERACT,ENTRY_INTERACT
C	CHARACTER*6 DEVICE
C
	LOGICAL TEKUSED
	COMMON /PLOT_TEKUSED/ TEKUSED
	LOGICAL FILEUSED
	COMMON /PLOT_FILEUSED/ FILEUSED
C
	ENTRY_INTERACT=.FALSE.
	GO TO 1
C
	ENTRY PLTDEV_INTERACT(IDEV,INTERACT)
C
	ENTRY_INTERACT=.TRUE.
   1	CONTINUE	
C
	NDEV=IDEV
	IF (NDEV.EQ.1.OR.NDEV.EQ.4.OR.NDEV.EQ.101.OR.NDEV.EQ.201.OR.NDEV
	1.EQ.301.OR.NDEV.EQ.401.OR.NDEV.EQ.10001.OR.NDEV.EQ.20001) THEN
	  CALL TEK(0,0,0)
	  TEKUSED=.TRUE. !  Flag for RESETTEK.FOR
	END IF
C
	IF (NDEV.EQ.2.OR.NDEV.EQ.4) THEN !  File
	  OPEN(UNIT=79,FILE='plot.plt',STATUS='UNKNOWN',
	1 FORM='UNFORMATTED')
	  FILEUSED=.TRUE.
	END IF
C
	IF (NDEV.EQ.3.) THEN !  Ramtek
c	  CALL INITL(IERR)
c	  CALL RAMCOL
	END IF
C
	IF (ABS(NDEV).EQ.5) THEN !  Imagen
C  Open the file here when making plots without TEX.
c	  IF (NDEV.EQ.5) THEN
c	    OPEN(UNIT=53,FORM='UNFORMATTED',STATUS='NEW')
c	  END IF
C  Allow printing on the Imagen as soon as an end-of-file command 
C  is sent.  It will be set .FALSE. in IMAGENPLOT upon printing.
c	  IMAGEN0=.TRUE.
c	  CALL IMAGEN(0,0,0)
	END IF
C
	IF (NDEV.EQ.6) THEN !  Printronix on-line plotting (somewhat slow)
c	  OPEN(UNIT=53,FORM='UNFORMATTED',STATUS='NEW')
c	  DO I=1,NLINES
c	    DO J=1,NBYTES-2
c	      ARRAY(J,I)='C0'X
c	    END DO
c	    ARRAY(NBYTES-1,I)=5
c	    ARRAY(NBYTES,I)=LF
c	  END DO
	END IF
C
	IF (NDEV.EQ.7) THEN !  Tektronix flat bed plotter
c	  ISTAT=SYS$ASSIGN('TEK4662',NCHAN,,)
c	  IF (.NOT.ISTAT) THEN
c	    CALL MESSAGE('Could not assign TEKTRONIX 4662 for plotting')
c	    RETURN
c	  END IF
c	  CALL TEK4662(0,0,0)
c	  CALL TEK4662(0,0,3)
	END IF
C
	IF (NDEV.EQ.8.OR.NDEV.EQ.-8) THEN !  Grinnell
c	  ISTAT=SYS$ASSIGN('_GRA0:',NCHAN,,)
c	  IF (.NOT.ISTAT) THEN
c	    CALL MESSAGE('Could not assign the Grinnell')
c	    RETURN
c	  END IF
c	  IF (NDEV.EQ.8) THEN
c	    CALL GRIN(0,0,0)
c	  ELSE
c	    NDEV=8
c	  END IF
	END IF
C
	IF (ABS(NDEV).EQ.10) THEN !  QMS Lasergrafix
C  Open the file here when making plots without TEX.  When making plots
C  with TEX, TEXPLOTCOM will open the file since the TEX commands precede 
C  the PLOT commands.
	  IF (NDEV.EQ.10) THEN
c	    OPEN(UNIT=53,CARRIAGECONTROL='LIST',FORM='FORMATTED',STATUS='NEW')
	  END IF
C  Allow printing on the LASERGRAFIX as soon as an end-of-file command is sent.
C  It will be set .FALSE. in LASERPLOT upon printing.
c	  LASERGRAFIX=.TRUE.
c	  CALL LASER(0,0,0)
	END IF
C
	IF (ABS(NDEV).EQ.11) THEN !  Apple LaserWriters
C  Open the file here when making plots without TEX.
	  IF (NDEV.EQ.11) THEN
	    OPEN(UNIT=53,CARRIAGECONTROL='LIST',FORM='FORMATTED',
	1   FILE='vect.rpl',STATUS='UNKNOWN')
	  END IF
C  Allow printing on the Apple Laserwriter as soon as an end-of-file command 
C  is sent.  It will be set .FALSE. in APPLEPLOT upon printing.
	  APPLE0=.TRUE.
	  CALL APPLE(0,0,0)
	END IF
C
	IF (ABS(NDEV).EQ.211) THEN
	  IF (NDEV.EQ.211) THEN
	    OPEN(UNIT=53,CARRIAGECONTROL='LIST',FORM='FORMATTED',
	1   FILE='vect.rpl',STATUS='UNKNOWN')
	  END IF
	  APPLE2=.TRUE.
	  CALL APPLE(0,0,0)
	END IF
C
	IF (ABS(NDEV).EQ.311) THEN
	  IF (NDEV.EQ.311) THEN
	    OPEN(UNIT=53,CARRIAGECONTROL='LIST',FORM='FORMATTED',
	1   FILE='vect.rpl',STATUS='UNKNOWN')
	  END IF
	  APPLE3=.TRUE.
	  CALL APPLE(0,0,0)
	END IF
C
	IF (ABS(NDEV).EQ.411) THEN
	  IF (NDEV.EQ.411) THEN
	    OPEN(UNIT=53,CARRIAGECONTROL='LIST',FORM='FORMATTED',
	1   FILE='vect.rpl',STATUS='UNKNOWN')
	  END IF
	  APPLE4=.TRUE.
	  CALL APPLE(0,0,0)
	END IF
C
	IF (ABS(NDEV).EQ.511) THEN
	  IF (NDEV.EQ.511) THEN
	    OPEN(UNIT=53,CARRIAGECONTROL='LIST',FORM='FORMATTED',
	1   FILE='vect.rpl',STATUS='UNKNOWN')
	  END IF
	  APPLE5=.TRUE.
	  CALL APPLE(0,0,0)
	END IF
C
	IF (ABS(NDEV).EQ.611) THEN
	  IF (NDEV.EQ.611) THEN
	    OPEN(UNIT=53,CARRIAGECONTROL='LIST',FORM='FORMATTED',
	1   FILE='vect.rpl',STATUS='UNKNOWN')
	  END IF
	  APPLE6=.TRUE.
	  CALL APPLE(0,0,0)
	END IF
C
	IF (ABS(NDEV).EQ.9011) THEN !  Digital LPS40
	  IF (NDEV.EQ.9011) THEN
	    OPEN(UNIT=53,CARRIAGECONTROL='LIST',FORM='FORMATTED',
	1   FILE='vect.rpl',STATUS='UNKNOWN')
	  END IF
	  LPS40=.TRUE.
	  CALL APPLE(0,0,0)
	END IF
C
	IF (ABS(NDEV).EQ.999811) THEN !  Encapsulted postscript file
	  IF (NDEV.EQ.999811) THEN
	    OPEN(UNIT=53,CARRIAGECONTROL='LIST',FORM='FORMATTED',
	1   FILE='plot.eps',STATUS='UNKNOWN')
	  END IF
	  EPS=.TRUE.
	  CALL APPLE(0,0,0)
	END IF
C
	IF (ABS(NDEV).EQ.999911) THEN !  Postscript file
	  IF (NDEV.EQ.999911) THEN
	    OPEN(UNIT=53,CARRIAGECONTROL='LIST',FORM='FORMATTED',
	1   FILE='plot.ps',STATUS='UNKNOWN')
	  END IF
	  POSTSCRIPT=.TRUE.
	  CALL APPLE(0,0,0)
	END IF
C
	IF (NDEV.EQ.12.OR.NDEV.EQ.-12) THEN ! Trapix
c	  CALL TRSTART
c	  NCHAN=UNIT !  Keeps NCHAN from being zero since it may be checked
c	  CALL TRFIRST !  This probably shouldn't be called here since it 
c		       !  erases the screen
c	  IF (NDEV.EQ.12) THEN
c	    CALL TRAPIX_(0,0,0) !  Erases the screen
c	  ELSE
c	    NDEV=12 !  No erasure
c	  END IF
	END IF
C
	IF (NDEV.EQ.13.OR.NDEV.EQ.-13) THEN !  SAOimage
	  IF (NDEV.EQ.13) THEN
	    IF (IFB_SAO.NE.2) THEN
	      IFB_SAO=2 !  Default buffer of 800X800
	      CALL SAOSTART !  Opens the pipes and sets the buffer size
	      CALL SAOFIRST
	      CALL SAO(0,0,0) !  Sets up coordinate system, erases screen,
			      !  and loads LUT
	    ELSE
	      CALL SAO(0,0,0)
	    END IF
	  ELSE IF (NDEV.EQ.-13) THEN
		!  No erasure of screen (good for overlays).
	    IFB_SAO=2 !  Default buffer of 800X800
	    CALL SAOSTART  !  Opens the pipes and sets the buffer size
	    CALL SAO(0,0,17) !  Sets up coordinate system but doesn't load
			     !  LUT.  Best for overlays on pictures.
	  END IF
	END IF
	IF (DEVICEINDEX.EQ.0) THEN !  When PLTDEV is initially called instead
				   !  of PLOTDEVICES.  A less versatile 
				   !  approach.
	  NUMBERDEVICESSAVE=1
	  NUMBERDEVICES=1
	  INDEXLOWERSAVE=1
	  INDEXLOWER=1
	  CHANNELS(1)=NCHAN
	  DEVICENUMBERS(1)=NDEV
	ELSE !  PLOTDEVICES initially called;  can use many devices at once
C  NUMBERDEVICES and DEVICEINDEX are established in PLOTDEVICES2
	  NUMBERDEVICESSAVE=NUMBERDEVICES
	  NUMBERDEVICES=DEVICEINDEX !  Allows PLTWRITE to loop only once 
				    !  for setting FACTOR for each device
	  INDEXLOWERSAVE=1
	  INDEXLOWER=DEVICEINDEX !  Allows PLTWRITE to loop only once 
	  CHANNELS(DEVICEINDEX)=NCHAN !  For PLTWRITE
	END IF
C
C  Initialize the plot parameters which are needed by all devices.
C  If the second argument (INTERACT) exists and has the value 
C  .FALSE. (such as when a call is made from PLOTCOM), don't initialize
C  (these commands will already be on the plot file).  When creating a plot
C  file, FACTOR is initially called with FACTOR=1 and PLOT is called in
C  order to reorigin;  when PLOTCOM is run, there is no call to FACTOR
C  or PLOT.  FACTOR calls PLTWRITE.
C
	IF (.NOT.ENTRY_INTERACT) THEN
	  IF (NDEV.EQ.8) THEN
	    CALL FACTOR(1.45) !  FACTOR calls PLTWRITE which will loop
			      !  only once for this situation
	  ELSE IF (NDEV.EQ.10) THEN
	    CALL FACTOR(1.4)
	  ELSE IF (NDEV.EQ.12) THEN
	    CALL FACTOR(1.45)
	  ELSE
	    CALL FACTOR(1.0)
	  END IF
	  CALL PLOT(-50.0,-50.0,-3)
	ELSE
	  IF (INTERACT) THEN
	    IF (NDEV.EQ.8) THEN
	      CALL FACTOR(1.45)
	    ELSE IF (NDEV.EQ.10) THEN
	      CALL FACTOR(1.4)
	    ELSE IF (NDEV.EQ.12) THEN
	      CALL FACTOR(1.45)
	    ELSE
	      CALL FACTOR(1.0)
	    END IF
	    CALL PLOT(-50.0,-50.0,-3)
	  END IF
	END IF
	INDEXLOWER=INDEXLOWERSAVE
	NUMBERDEVICES=NUMBERDEVICESSAVE
C
	RETURN
	END
