	SUBROUTINE PRTMSG(JCODE,JFLAGS)
C	
C  Note:  This is the Unix version
C
C       This subroutine prints a message corresponding to a
C  a SAD error message, a plotting error message, or a system message.
C  Refer to the VAX system service manual for additional details.
C  Usually one can set JFLAGS='F'X.  LU is optional;  if it is present,
C  the status message is also written to the logical unit.
C				Bruce Cogan, November 6, 1978
C
C			Version 2, Denis Warne, August 29, 1979
C			Added LU to argument list
C			Version 3, Greg Quinn, September 13, 1979
C			Added ability to detect SAD errors
C			Version 4, Donald H. Gudehus, October, 1984
C			Added ability to detect plotting errors
C			Version 4U, Donald H. Gudehus, December 2, 1999
C			Modified code for Unix
C	
c	INCLUDE 'sadpar.for'
	INCLUDE 'plotpar.for'
	LOGICAL SADFLG,PLOTFLG,ENTRY_LU
	CHARACTER*256 MESSGE
C	INTEGER SYS$NUMARGS
C	INTEGER*2 MSGLEN
	COMMON /LU_DEF/ LUIN,LUOUT,LOGLU,LUINFILE
        INTEGER*4 ERRTABSAD(36),ERRTABPLOT(6)
c	DATA ERRTABSAD /D$S_IMAGE,D$S_NODE,D$S_ILLICA,
c	1D$S_ILLACS,D$S_ILFORM,D$S_WRPROT,
c	2D$S_ILOPIM,D$S_NXNODE,D$S_ILNODENO,
c	3D$S_INSARR,D$S_DATLOB,D$S_ILOPND,
c	4D$S_UNSUPFMT,D$S_UNSUPFIL,D$S_UNSUPIM,
c	5D$S_IMPOSS,D$S_UNDEFKYWD,D$S_NOTAPBS,
c	6D$S_DCDERR,D$S_ILLSUBTAG,D$S_ENDIMAGE,
c	7D$S_ILNAXES,D$S_ILIMHDR,D$S_ILSUBDIV,
c	8D$S_ILLNCA,D$S_NONMULT,D$S_NOCOMMENT,
c	9D$S_NOVAL,D$S_NOTCHARKEY,D$S_RECTOOLON,
c	1D$S_ILLOOKAH,D$S_BUFOUTRNG,D$S_NOBUFAV,
c	2D$S_ILVALFORM,D$S_ZERORECLEN,D$S_NOROOM/
c	DATA ERRTABPLOT /PLT$S_ILLIPEN,PLT$S_ENDFILE,PLT$S_ENDPLOT,
c	1PLT$S_ENDALPHA,PLT$S_NOSUCHPLOT,PLT$S_NOPOINTS/
C
	ENTRY_LU=.FALSE.
	GO TO 1
C
	ENTRY PRTMSG_LU(JCODE,JFLAGS,LU)
C
	ENTRY_LU=.TRUE.
	LUPRT=LU
	IF (LU.EQ.-1) LUPRT=LOGLU
   1	CONTINUE
C
	SADFLG=.FALSE.
	PLOTFLG=.FALSE.
	NSADERRS=36
	NPLOTERRS=6
C100	FORMAT(' ', A<MSGLEN>)
C200	FORMAT(' ', A131/ 5X, A<MSGEND>)
C
        ISUBSYS=IAND(JCODE,'FFFF0000'X)
        IF (ISUBSYS.EQ.'80020000'X) THEN
C
C  Print out a SAD message
C
	  OPEN (UNIT=99,NAME='saderrs.dat',TYPE='OLD',READONLY,
	1 ACCESS='DIRECT',RECL=80)
c	1 ACCESS='DIRECT',ORGANIZATION='SEQUENTIAL')
	  DO I=1,NSADERRS
	    IF (ERRTABSAD(I).EQ.JCODE) THEN
	      READ (99,REC=I) MESSGE(1:80)
	      WRITE (6,201) MESSGE(1:79)
	      IF (ENTRY_LU) WRITE(LUPRT,201)MESSGE
 201	      FORMAT(' ',A79)
	      SADFLG=.TRUE.
	    END IF
	  END DO
	  CLOSE (UNIT=99)
	  IF (SADFLG) RETURN
	END IF
C
        ISUBSYS=IAND(JCODE,'FFFF0000'X)
        IF (ISUBSYS.EQ.'80040000'X) THEN
C
C  Print out a plotting message
C
	  OPEN (UNIT=99,NAME='ploterrs.dat',TYPE='OLD',READONLY,
	1 ACCESS='DIRECT',RECL=80)
c	1 ACCESS='DIRECT',ORGANIZATION='SEQUENTIAL')
	  DO I=1,NPLOTERRS
	    IF (ERRTABPLOT(I).EQ.JCODE) THEN
	      READ (99,REC=I) MESSGE(1:80)
	      WRITE (6,201) MESSGE(1:79)
	      IF (ENTRY_LU) WRITE(LUPRT,201)MESSGE
	      PLOTFLG=.TRUE.
	    END IF
	  END DO
	  CLOSE (UNIT=99)
	  IF (PLOTFLG) RETURN
	END IF
C
C  If a SAD error or a plot error was not printed, default to the system
C  message
C
c	CALL SYS$GETMSG(%VAL(JCODE),MSGLEN,MESSGE,%VAL(JFLAGS),)
c	IF (MSGLEN.LT.131) THEN
c	  TYPE 100, MESSGE
c	  IF(SYS$NUMARGS(DUMMY).GT.2)WRITE(LUPRT,100)MESSGE
c	ELSE
c	  MSGEND=MSGLEN-131
c	  TYPE 200, MESSGE(1:131),MESSGE(132:MSGLEN)
c	  IF(SYS$NUMARGS(DUMMY).GT.2)WRITE(LUPRT,200)
c	2 MESSGE(1:131),MESSGE(132:MSGLEN)
c	END IF
	RETURN
C
C  Force in logical unit definition
	ENTRY PRTMSG_
	CALL STR_LUDEF
	RETURN
	END
