	SUBROUTINE SAOPLOT(COMMAND,SYMFIX,TEXT,XOFF,YOFF,SCALE,
	1COSR,SINR,ISTAT)
C
C  Note:  This is the Unix version.
C
C       This subroutine is the online plot routine for SAOimage.
C  It takes the commands sent from the plot routines and
C  emulates a pen plotter on SAOimage
C			Donald H. Gudehus, October, 1994
C			Version 1U, Donald H. Gudehus, January 19, 2000
C			Converted code to Unix
C			Version 2, Donald H. Gudehus, January 22, 2000
C			Added command to change the background color
C			Version 2U, Donald H. Gudehus, September 17, 2004
C			Introduced COMMON block SAOPLOT_SAVE for holding
C			XPOS and YPOS until the next call when calling
C			SYMBOL with (999.0,999.0).  Was not necessary
C			under VMS.
C		
	COMMON /PLOT_CHAN/ NCHAN,NDEV
C
	COMMON /PLOT_DATALEVEL/ LEVEL
C
	BYTE COMMAND(0:4),OPCODE,BCOM(4),TEXT(1)
	INTEGER*2 SYMFIX(0:2),I2COM(0:1)
	INTEGER*2 XORIGIN,YORIGIN,XPOS,YPOS,XCH,YCH,
	1XOFF,YOFF,DELX,DELY,NBS,DELXBS,DELYBS
	INTEGER*4 TEMP(2),NEW(2),I4COM
	LOGICAL PLOTIT,ENGLISH,GREEK,NORMAL,SUBSCRIPT,SUPERSCRIPT
	REAL FACTOR,R4COM,SCALE
	EQUIVALENCE (BCOM,I2COM(0),R4COM,I4COM)
C
	INTEGER LCOLOR,LBCOLOR
	COMMON /PLOT_COLOR/ LCOLOR,LBCOLOR
C
	COMMON /SAOPLOT_SAVE/ XPOS,YPOS
C
	INCLUDE 'plotpar.for'
C
	DATA FACTOR,XORIGIN,YORIGIN/1.0,0.0,0.0/
C
	ISTAT=SSP$_NORMAL
	DO I=1,4
	  BCOM(I)=COMMAND(I)
	END DO
C
C  Get the opcode.
C
	OPCODE=COMMAND(PLT$B_OPC).AND.PLT$M_OPC
C
C  End-file and end of plot
C
	IF (OPCODE.EQ.PLT$OP_ENDFILE) THEN
	  ISTAT=PLT$S_ENDFILE
	ELSE IF (OPCODE.EQ.PLT$OP_ENDPLOT) THEN
	  XPOS=I2COM(PLT$W_X)
	  YPOS=I2COM(PLT$W_Y)
	  ISTAT=PLT$S_ENDPLOT
	ELSE IF (OPCODE.EQ.PLT$OP_ENDALPHA) THEN
	  CALL SAO(0,0,0)
	  ISTAT=PLT$S_ENDALPHA
C
C  Plot (pen down)
C
	ELSE IF (OPCODE.EQ.PLT$OP_PLOTDOWN) THEN
	  XPOS=I2COM(PLT$W_X)
	  YPOS=I2COM(PLT$W_Y)
	  TEMP(1)=IINT(((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*PLT$C_SAOPIX)
	  TEMP(2)=INT(((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*PLT$C_SAOPIX)
	  NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	  NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	  CALL LIMIT(NEW(1),PLT$C_SAOXPIX,NEW(2),PLT$C_SAOYPIX,PLOTIT)
	  IF (PLOTIT) CALL SAO(NEW(1),NEW(2),2)
C
C  Move (pen up)
C
	ELSE IF (OPCODE.EQ.PLT$OP_PLOTUP) THEN
	  XPOS=I2COM(PLT$W_X)
	  YPOS=I2COM(PLT$W_Y)
	  TEMP(1)=IINT(((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*PLT$C_SAOPIX)
	  TEMP(2)=IINT(((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*PLT$C_SAOPIX)
	  NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	  NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	  CALL LIMIT(NEW(1),PLT$C_SAOXPIX,NEW(2),PLT$C_SAOYPIX,PLOTIT)
	  CALL SAO(NEW(1),NEW(2),3)
C
C  Plot text string
C
	ELSE IF (OPCODE.EQ.PLT$OP_SYMBOL) THEN
	  ANGLE=SYMFIX(PLT$W_ANGLE)
	  COSA=COSD(ANGLE)
	  SINA=SIND(ANGLE)
	  ENGLISH=.TRUE.
	  GREEK=.FALSE.
	  NORMAL=.TRUE.
	  SUBSCRIPT=.FALSE.
	  SUPERSCRIPT=.FALSE.
C  Determine DELX and DELY for the initial location
	  I=1
	  NBS=0  ! Initializes the number of backspaces
	  CALL TEXTCNCH(TEXT,I2COM,I,NBS,ENGLISH,GREEK,NORMAL,SUBSCRIPT,
	1 SUPERSCRIPT,SINA,COSA,DELX,DELY,SSF,DELXBS,DELYBS)
	  IF ((COMMAND(PLT$B_OPC).AND.PLT$M_SYMBCONT).EQ.0) THEN
	    XPOS=SYMFIX(PLT$W_SYMBX)+DELX
	    YPOS=SYMFIX(PLT$W_SYMBY)+DELY
	    TEMP(1)=IINT(((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*
	1   PLT$C_SAOPIX)
	    TEMP(2)=IINT(((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*
	1   PLT$C_SAOPIX)
	    NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	    NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	    CALL LIMIT(NEW(1),PLT$C_SAOXPIX,NEW(2),
	1   PLT$C_SAOYPIX,PLOTIT)
	    CALL SAO(NEW(1),NEW(2),3)
	  END IF
	  DO WHILE (I.LE.I2COM(PLT$W_NBYT))
	    IF (ENGLISH) THEN
	      CALL GETSYM(TEXT(I),NVECS)
	    ELSE IF (GREEK) THEN
	      CALL GETSYMGR(TEXT(I),NVECS)
	    END IF
	    IF (NVECS.GT.0) THEN
	      DO J=1,NVECS
	        IF (ENGLISH) THEN
	          CALL VECSYM(J,XCH,YCH,IPEN)
	        ELSE IF (GREEK) THEN
	          CALL VECSYMGR(J,XCH,YCH,IPEN)
	        END IF
C  Note that PLT$C_CHARSIZE enters into the expression below because
C  it is necessary to scale down by the reciprocal of the maximum
C  value of YCH, 7.
	        TEMP(1)=IINT(((((XCH*COSA-YCH*SINA)*I2COM(PLT$W_HEIGHT)
	1       *PLT$C_CHARSIZE*SSF+XPOS)*FACTOR+XORIGIN)
	2       *SCALE-XOFF)*PLT$C_SAOPIX)
	        TEMP(2)=IINT(((((XCH*SINA+YCH*COSA)*I2COM(PLT$W_HEIGHT)
	1       *PLT$C_CHARSIZE*SSF+YPOS)*FACTOR+YORIGIN)
	2       *SCALE-YOFF)*PLT$C_SAOPIX)
	        NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	        NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	        CALL LIMIT(NEW(1),PLT$C_SAOXPIX,NEW(2),
	1       PLT$C_SAOYPIX,PLOTIT)
	        IF (IPEN) THEN
	          IF (PLOTIT) CALL SAO(NEW(1),NEW(2),2)
	        ELSE
	          CALL SAO(NEW(1),NEW(2),3)
	        END IF
 	      END DO
	    END IF
C  Advance to the next character location
	    XPOS=XPOS-DELX+DELXBS
	    YPOS=YPOS-DELY+DELYBS
	    I=I+1
	    NBS=0
	    CALL TEXTCNCH(TEXT,I2COM,I,NBS,ENGLISH,GREEK,NORMAL,
	1   SUBSCRIPT,SUPERSCRIPT,SINA,COSA,DELX,DELY,SSF,DELXBS,DELYBS)
	    XPOS=6*COSA*I2COM(PLT$W_HEIGHT)*PLT$C_CHARSIZE+XPOS+DELX
	    YPOS=6*SINA*I2COM(PLT$W_HEIGHT)*PLT$C_CHARSIZE+YPOS+DELY
	    TEMP(1)=IINT(((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*
	1   PLT$C_SAOPIX)
	    TEMP(2)=IINT(((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*
	1   PLT$C_SAOPIX)
	    NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	    NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	    CALL LIMIT(NEW(1),PLT$C_SAOXPIX,NEW(2),PLT$C_SAOYPIX,
	1   PLOTIT)
	    CALL SAO(NEW(1),NEW(2),3)
	  END DO
C
C  Set the plotting scale factor
C
	ELSE IF (OPCODE.EQ.PLT$OP_FACTOR) THEN
	  FACTOR=R4COM
C
C  Plot special symbol
C
	ELSE IF (OPCODE.EQ.PLT$OP_SYMBDOWN.OR.OPCODE.EQ.PLT$OP_SYMBUP)
	1THEN
	  IF (OPCODE.EQ.PLT$OP_SYMBDOWN) THEN
	    XPOS=SYMFIX(PLT$W_SYMBX)
	    YPOS=SYMFIX(PLT$W_SYMBY)
	    TEMP(1)=IINT(((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*
	1   PLT$C_SAOPIX)
	    TEMP(2)=IINT(((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*
	1   PLT$C_SAOPIX)
	    NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	    NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	    CALL LIMIT(NEW(1),PLT$C_SAOXPIX,NEW(2),
	1   PLT$C_SAOYPIX,PLOTIT)
	    CALL SAO(NEW(1),NEW(2),2)
	  ELSE IF ((COMMAND(PLT$B_OPC).AND.PLT$M_SYMBCONT).EQ.0) THEN
	    XPOS=SYMFIX(PLT$W_SYMBX)
	    YPOS=SYMFIX(PLT$W_SYMBY)
	    TEMP(1)=IINT(((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*
	1   PLT$C_SAOPIX)
	    TEMP(2)=IINT(((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*
	1   PLT$C_SAOPIX)
	    NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	    NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	    CALL LIMIT(NEW(1),PLT$C_SAOXPIX,NEW(2),
	1   PLT$C_SAOYPIX,PLOTIT)
	    CALL SAO(NEW(1),NEW(2),3)
	  END IF
	  ANGLE=SYMFIX(PLT$W_ANGLE)
	  COSA=COSD(ANGLE)
	  SINA=SIND(ANGLE)
	  CALL SPECSYM(I2COM(PLT$W_SYMBNO),NVECS)
	  IF (NVECS.GT.0) THEN
	    DO J=1,NVECS
	      CALL VECSYM(J,XCH,YCH,IPEN)
	      XCH=XCH-3
	      YCH=YCH-3
	      TEMP(1)=IINT(((((XCH*COSA-YCH*SINA)*I2COM(PLT$W_HEIGHT)
	1     *PLT$C_CHARSIZE+XPOS)*FACTOR+XORIGIN)
	2     *SCALE-XOFF)*PLT$C_SAOPIX)
	      TEMP(2)=IINT(((((XCH*SINA+YCH*COSA)*I2COM(PLT$W_HEIGHT)
	1     *PLT$C_CHARSIZE+YPOS)*FACTOR+YORIGIN)
	2     *SCALE-YOFF)*PLT$C_SAOPIX)
	      NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	      NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	      CALL LIMIT(NEW(1),PLT$C_SAOXPIX,NEW(2),
	1     PLT$C_SAOYPIX,PLOTIT)
	      IF (IPEN) THEN
	        IF (PLOTIT) CALL SAO(NEW(1),NEW(2),2)
	      ELSE
	        CALL SAO(NEW(1),NEW(2),3)
	      END IF
 	    END DO
	  END IF
	  XPOS=SYMFIX(PLT$W_SYMBX)
	  YPOS=SYMFIX(PLT$W_SYMBY)
	  TEMP(1)=IINT(((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*PLT$C_SAOPIX)
	  TEMP(2)=IINT(((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*PLT$C_SAOPIX)
	  NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	  NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	  CALL LIMIT(NEW(1),PLT$C_SAOXPIX,NEW(2),PLT$C_SAOYPIX,PLOTIT)
	  CALL SAO(NEW(1),NEW(2),3)
C
C  Select the color
C
	ELSE IF (OPCODE.EQ.PLT$OP_COLOR) THEN
	  LCOLOR=I4COM
	  CALL SAO(0,0,6)
C
C  Select the data level
C
	ELSE IF (OPCODE.EQ.PLT$OP_DATALEVEL) THEN
	  LEVEL=I2COM(PLT$B_DATALEVEL)
	  CALL SAO(0,0,8)
C
C  Go to the point plot mode
C
	ELSE IF (OPCODE.EQ.PLT$OP_POINTPLOT) THEN
	  CALL SAO(0,0,1)
C
C  Go to rectilinear graphics mode
C
	ELSE IF (OPCODE.EQ.PLT$OP_RECTILINEAR) THEN
	  CALL SAO(0,0,9)
C
C  Set the display action to immediate
C
	ELSE IF (OPCODE.EQ.PLT$OP_IMMEDIATE) THEN
	  CALL SAO(0,0,13)
C
C  Set the display action to delayed (block mode)
C
	ELSE IF (OPCODE.EQ.PLT$OP_DELAYED) THEN
	  CALL SAO(0,0,14)
C
C  Display the vectors
C
	ELSE IF (OPCODE.EQ.PLT$OP_SHOWVECT) THEN
	  CALL SAO(0,0,15)  !  Displays current vectors
C
C  Change the background color
C
	ELSE IF (OPCODE.EQ.PLT$OP_BACKGROUNDCOLOR) THEN
	  LBCOLOR=I4COM
	  CALL SAO(0,0,19) !  Changes the first color lookup table entry
C
C  Reorigin
C
	ELSE IF (OPCODE.EQ.PLT$OP_ORIG) THEN
	  IF (I2COM(PLT$W_X).EQ.(-50*PLT$C_NIBS)) THEN
	    XORIGIN=0
	    YORIGIN=0
	  ELSE IF (I2COM(PLT$W_X).EQ.(-50*PLT$C_OLDNIBS)) THEN
	    XORIGIN=0
	    YORIGIN=0
	    FACTOR=FACTOR*2.362205  ! 600/254
	  ELSE
	    XORIGIN=XORIGIN+I2COM(PLT$W_X)*FACTOR
	    YORIGIN=YORIGIN+I2COM(PLT$W_Y)*FACTOR
	  END IF
	END IF
	RETURN
	END
