	SUBROUTINE GETSYMGR(SYMBOL,NVECS)
C
C	Note:  This is the Unix version
C
C	This subroutine returns the number of bytes that are required 
C  to draw a Greek symbol.  Entry VECSYMGR returns the actual
C  X and Y moves and pen up/down movements that are required to draw the
C  Greek characters.  The special symbols replace numbers 0 through 9
C  and !, @, and # so that the special symbols may be entered interactively
C  when using XYPLOT.  This subroutine and the entries below were
C  converted to FORTRAN from the Macro 32 code for the VAX version.
C
C		Donald H. Gudehus, January 17, 2000
C		Version 2, Donald Gudehus, February 6, 2005
C		Declared SYMBOL as BYTE and SPEC_SYMBOL as INTEGER*2
C
C	SYMBOL  (C)	Symbol to be drawn
C	NVECS   (R)	Number of vectors

C
	BYTE SYMBOL,SYMBOL_STATIC
	INTEGER*2 X,Y,SPEC_SYMBOL,I2TEMP
	INTEGER*4 NVECS
	LOGICAL*1 IPEN
C
	BYTE VECT_BYTES(95),SYMBOL_BYTES(14),
	1CHAR_GEN(17,127) 
C
	COMMON /SYMGEN_STATIC/ SYMBOL_STATIC
C
C  SS=Special Symbol
	DATA VECT_BYTES/
	1 0,8,4,2,13,12,10,2,             !  Blank SS11=! " SS13=# $ % & '
	2 4,13,6,5,7,2,5,2,               !  ( SS10=) * + , - . /
	2 7,11,5,4,4,                     !  SS0=0 SS1=1 SS2=2 SS3=3 SS4=4
	3 6,5,4,                          !  SS5=5 SS6=6 SS7=7
	3 5,5,10,12,3,4,2,10,5,           !  SS8=8 SS9=9 : ; < = > ? SS12=@
	4 8,12,8,3,                       !  Alpha=A Beta=B C Delta=D 
	4 6,4,3,6,                        !  Epsilon=E Zeta=F Gamma=G Eta=H
	4 6,11,5,                         !  Iota=I Theta=J Kappa=K 
	4 2,4,4,11,                       !  Lambda=L Mu=M Nu=N Omicron=O
	5 6,17,6,5,6,                     !  Pi=P Xi=Q Rho=R Sigma=S Tau=T
	5 11,3,15,3,11,                   !  Upsilon=U V Phi=W Chi=X Psi=Y
	6 14,4,2,4,3,1,2,                 !  Omega=Z [ \ ] ^ _ `
	7 8,14,8,11,                      !  alpha=a beta=b c delta=d 
	7 8,12,7,8,                       !  epsilon=e zeta=f gamma=g eta=h
	7 5,11,6,3,                       !  iota=i theta=j kappa=k lambda=l
	7 8,6,9,7,15,                     !  mu=m nu=n omicron=o pi=p xi=q
	8 9,9,5,8,                        !  rho=r sigma=s tau=t upsilon=u 
	8 3,11,6,8,11,                    !  v phi=w chi=x psi=y omega=z
	9 6,4,5,4 /                       !  { | } ~
	DATA SYMBOL_BYTES/
	1 7,11,5,4,4,6,5,      !  Box, Oct, Tri, Plu, Cro, Dia, Hat
	2 4,5,5,13,8,5,2/      !  Tre, Zed, Why, Spi, Sta, Hou, Str
	DATA CHAR_GEN/
	1 '033'O,'236'O,'206'O,'200'O,'260'O,'266'O,'236'O,10*'0'O, ! Box
	2 '033'O,'236'O,'226'O,'204'O,'202'O,'220'O,'240'O,'262'O, ! Oct
	3 '264'O,'246'O,'236'O,6*'0'O,
	4 '033'O,'236'O,'201'O,'261'O,'236'O,12*'0'O, ! Tri
	5 '030'O,'236'O,'003'O,'263'O,13*'0'O, ! Plu
	6 '000'O,'266'O,'006'O,'260'O,13*'0'O, ! Cro
	7 '033'O,'236'O,'203'O,'230'O,'263'O,'236'O,11*'0'O, ! Dia
	8 '030'O,'236'O,'203'O,'263'O,'236'O,12*'0'O, ! Hat
	9 '000'O,'266'O,'206'O,'260'O,13*'0'O, ! Tre
	1 '000'O,'266'O,'206'O,'000'O,'260'O,12*'0'O, ! Zed
	2 '030'O,'233'O,'206'O,'033'O,'266'O,12*'0'O, ! Why
	3 '000'O,'211'O,'251'O,'260'O,'051'O,'255'O,'066'O, ! Spi
	4 '233'O,'055'O,'215'O,'206'O,'015'O,'211'O,4*'0'O,
	5 '000'O,'266'O,'006'O,'260'O,'030'O,'236'O, ! Sta
	6 '003'O,'063'O,9*'0'O,
	6 '000'O,'266'O,'206'O,'260'O,'200'O,12*'0'O, ! Hou
	7 '030'O,'236'O,15*'0'O, ! Str
	8 17*'0'O, ! Index = 15
	9 17*'0'O,
	1 17*'0'O,
	2 17*'0'O,
	3 17*'0'O,
	4 17*'0'O,
	5 17*'0'O,
	6 17*'0'O,
	7 17*'0'O,
	8 17*'0'O,
	9 17*'0'O,
	1 17*'0'O,
	2 17*'0'O,
	3 17*'0'O,
	4 17*'0'O,
	5 17*'0'O, ! Index = 30
	6 17*'0'O,
	7 17*'0'O,
	8 17*'0'O, ! UL
	9 '000'O,'211'O,'251'O,'260'O,'051'O,'255'O,'066'O, ! SS11=!=Sta
	1 '233'O,'055'O,'215'O,'206'O,'015'O,'211'O,4*'0'O,
	2 '015'O,'227'O,'035'O,'247'O,13*'0'O, ! "
	3 '000'O,'266'O,'206'O,'260'O,'200'O,12*'0'O, ! SS13=#=Str
	4 '002'O,'211'O,'231'O,'242'O,'243'O,'234'O,'214'O,'205'O, ! $
	5 '216'O,'236'O,'245'O,'027'O,'220'O,4*'0'O,
	6 '017'O,'207'O,'206'O,'216'O,'217'O,'047'O,'200'O,'040'O, ! %
	7 '230'O,'231'O,'241'O,'240'O,5*'0'O,
	8 '040'O,'215'O,'216'O,'227'O,'236'O,'235'O,'201'O,'210'O, ! &
	9 '230'O,'242'O,7*'0'O,
	1 '015'O,'227'O,15*'0'O, ! '
	2 '037'O,'226'O,'221'O,'230'O,13*'0'O, ! (
	3 '030'O,'233'O,'206'O,'033'O,'266'O,12*'0'O, ! SS10=)=Spi
	4 '021'O,'226'O,'005'O,'242'O,'045'O,'202'O,11*'0'O, ! *
	5 '021'O,'225'O,'223'O,'203'O,'243'O,12*'0'O, ! +
	6 '010'O,'211'O,'221'O,'220'O,'210'O,'020'O,'311'O,10*'0'O, ! ,
	7 '004'O,'244'O,15*'0'O, ! -
	8 '010'O,'211'O,'221'O,'220'O,'210'O,12*'0'O, ! .
	9 '047'O,'200'O,15*'0'O, ! /
	1 '033'O,'236'O,'206'O,'200'O,'260'O,'266'O,'236'O,10*'0'O, ! SS0=0=Box
	2 '033'O,'236'O,'226'O,'204'O,'202'O,'220'O,'240'O,'262'O, ! SS1=1=Oct
	3 '264'O,'246'O,'236'O,6*'0'O,
	4 '033'O,'236'O,'201'O,'261'O,'236'O,12*'0'O, ! SS2=2=Tri
	5 '030'O,'236'O,'003'O,'263'O,13*'0'O, ! SS3=3=Plu
	6 '000'O,'266'O,'006'O,'260'O,13*'0'O, ! SS4=4=Cro
	7 '033'O,'236'O,'203'O,'230'O,'263'O,'236'O,11*'0'O, ! SS5=5=Dia
	8 '030'O,'236'O,'203'O,'263'O,'236'O,12*'0'O, ! SS6=6=Hat
	9 '000'O,'266'O,'206'O,'260'O,13*'0'O, ! SS7=7=Tre
	1 '000'O,'266'O,'206'O,'000'O,'260'O,12*'0'O, ! SS8=8=Zed
	2 '030'O,'233'O,'206'O,'033'O,'266'O,12*'0'O, ! SS9=9=Why
	7 '011'O,'212'O,'222'O,'221'O,'211'O,'014'O,'215'O, ! :
	8 '225'O,'224'O,'214'O,7*'0'O,
	9 '010'O,'211'O,'221'O,'220'O,'210'O,'020'O,'311'O, ! ;
	1 '014'O,'215'O,'225'O,'224'O,'214'O,5*'0'O,
	2 '040'O,'203'O,'246'O,14*'0'O, ! <
	3 '045'O,'205'O,'003'O,'243'O,13*'0'O, ! =
	4 '243'O,'206'O,15*'0'O, ! >
	5 '020'O,'220'O,'021'O,'223'O,'245'O,'246'O,'237'O, ! ?
	6 '217'O,'206'O,'205'O,7*'0'O,
	7 '000'O,'266'O,'206'O,'260'O,'200'O,12*'0'O, ! SS12=Hou
	8 '204'O,'244'O,'004'O,'206'O,'217'O,'237'O,'246'O,'240'O, ! Alpha
	9 9*'0'O,
	1 '041'O,'230'O,'200'O,'207'O,'237'O,'246'O,'245'O,'234'O, ! Beta
	2 '204'O,8*'0'O,
	3 '046'O,'237'O,'217'O,'206'O,'201'O,'210'O,'230'O,'241'O,9*'0'O, ! C
	4 '237'O,'250'O,'200'O,14*'0'O, ! Delta
	5 '040'O,'200'O,'207'O,'247'O,'004'O,'234'O,11*'0'O, ! Epsilon
	6 '040'O,'200'O,'247'O,'207'O,13*'0'O, ! Zeta
	7 '207'O,'247'O,'246'O,14*'0'O, ! Gamma
	8 '207'O,'200'O,'040'O,'247'O,'004'O,'244'O,11*'0'O, ! Eta
	9 '010'O,'230'O,'020'O,'227'O,'017'O,'237'O,11*'0'O, ! Iota
	1 '041'O,'230'O,'210'O,'201'O,'206'O,'217'O,'237'O,'246'O, ! Theta
	2 '241'O,'044'O,'204'O,6*'0'O,
	3 '040'O,'204'O,'247'O,'007'O,'200'O,12*'0'O, ! Kappa
	4 '227'O,'240'O,15*'0'O, ! Lambda
	5 '207'O,'224'O,'247'O,'240'O,13*'0'O, ! Mu
	6 '047'O,'240'O,'207'O,'200'O,13*'0'O, ! Nu
	7 '041'O,'230'O,'210'O,'201'O,'206'O,'217'O,'237'O,'246'O, ! Omicron
	8 '241'O,'035'O,'246'O,6*'0'O,
	9 '010'O,'217'O,'247'O,'240'O,'007'O,'257'O,11*'0'O, ! Pi
	1 '240'O,'013'O,'233'O,'006'O,'246'O,'001'O,'301'O,'041'O, ! Xi
	2 '341'O,'014'O,'212'O,'034'O,'232'O,'007'O,'205'O,'047'O,
	3 '245'O,
	4 '207'O,'237'O,'246'O,'245'O,'234'O,'204'O,11*'0'O, ! Rho
	5 '040'O,'200'O,'234'O,'207'O,'247'O,12*'0'O, ! Sigma
	6 '006'O,'207'O,'247'O,'246'O,'027'O,'220'O,11*'0'O, ! Tau
	7 '005'O,'206'O,'217'O,'226'O,'220'O,'026'O,'237'O,'246'O, ! Upsilon
	8 '245'O,'010'O,'230'O,6*'0'O,
	9 '007'O,'220'O,'247'O,14*'0'O, ! V
	1 '003'O,'205'O,'216'O,'236'O,'245'O,'243'O,'232'O,'212'O, ! Phi
	2 '203'O,'020'O,'227'O,'010'O,'230'O,'017'O,'237'O,2*'0'O,
	3 '247'O,'007'O,'240'O,14*'0'O, ! Chi
	4 '006'O,'213'O,'222'O,'233'O,'246'O,'020'O,'227'O,'010'O, ! Psi
	5 '230'O,'017'O,'237'O,6*'0'O,
	6 '001'O,'210'O,'220'O,'221'O,'204'O,'205'O,'227'O,'237'O, ! Omega
	7 '255'O,'254'O,'231'O,'230'O,'240'O,'251'O,3*'0'O,
	8 '030'O,'210'O,'217'O,'237'O,13*'0'O, ! [
	9 '007'O,'240'O,15*'0'O, ! \
	1 '010'O,'230'O,'237'O,'217'O,13*'0'O, ! ]
	2 '015'O,'227'O,'235'O,14*'0'O, ! ^
	3 '240'O,16*'0'O, ! _
	4 '025'O,'217'O,15*'0'O, ! `
	5 '044'O,'220'O,'210'O,'201'O,'203'O,'214'O,'224'O,'240'O, ! alpha
	6 9*'0'O,
	7 '103'O,'215'O,'226'O,'236'O,'245'O,'244'O,'233'O,'213'O, ! beta
	8 '033'O,'242'O,'241'O,'230'O,'210'O,'201'O,3*'0'O,
	9 '041'O,'230'O,'210'O,'201'O,'203'O,'214'O,'234'O,'243'O, ! c
	1 9*'0'O,
	2 '036'O,'227'O,'216'O,'224'O,'233'O,'221'O,'210'O,'201'O, ! delta
	3 '202'O,'214'O,'224'O,6*'0'O,
	4 '030'O,'210'O,'201'O,'203'O,'214'O,'234'O,'002'O,'232'O, ! epsilon
	5 9*'0'O,
	6 '017'O,'216'O,'235'O,'255'O,'246'O,'225'O,'213'O,'212'O, ! zeta
	7 '331'O,'322'O,'312'O,'301'O,5*'0'O,
	8 '003'O,'214'O,'224'O,'233'O,'321'O,'220'O,'244'O,10*'0'O, ! gamma
	9 '213'O,'214'O,'203'O,'013'O,'224'O,'234'O,'243'O,'322'O, ! eta
	1 9*'0'O,
	2 '024'O,'211'O,'220'O,'230'O,'241'O,12*'0'O, ! iota
	3 '001'O,'215'O,'226'O,'236'O,'245'O,'231'O,'220'O,'210'O, ! theta
	4 '201'O,'003'O,'243'O,6*'0'O,
	5 '215'O,'035'O,'213'O,'013'O,'230'O,'241'O,11*'0'O, ! kappa
	6 '223'O,'007'O,'240'O,14*'0'O, ! lambda
	7 '103'O,'214'O,'211'O,'220'O,'230'O,'241'O,'244'O,'240'O, ! mu
	8 9*'0'O,
	9 '004'O,'214'O,'200'O,'221'O,'232'O,'244'O,11*'0'O, ! nu
	1 '031'O,'220'O,'210'O,'201'O,'213'O,'224'O,'234'O, ! omicron
	2 '243'O,'231'O,8*'0'O,
	3 '003'O,'214'O,'254'O,'000'O,'214'O,'030'O,'244'O,10*'0'O, ! pi
	4 '027'O,'226'O,'235'O,'255'O,'246'O,'225'O,'213'O,'222'O, ! xi
	5 '243'O,'223'O,'201'O,'210'O,'230'O,'331'O,'321'O,2*'0'O,
	6 '103'O,'213'O,'224'O,'234'O,'243'O,'241'O,'230'O,'210'O, ! rho
	7 '201'O,8*'0'O,
	8 '054'O,'214'O,'203'O,'201'O,'210'O,'220'O,'231'O,'233'O, ! sigma
	9 '224'O,8*'0'O,
	1 '003'O,'214'O,'244'O,'024'O,'210'O,12*'0'O, ! tau
	2 '004'O,'213'O,'201'O,'210'O,'220'O,'231'O,'243'O,'234'O, ! upsilon
	3 9*'0'O,
	4 '004'O,'220'O,'244'O,14*'0'O, ! v
	5 '001'O,'203'O,'214'O,'234'O,'243'O,'241'O,'230'O,'210'O, ! phi
	6 '201'O,'112'O,'236'O,6*'0'O,
	7 '003'O,'214'O,'342'O,'351'O,'102'O,'254'O,11*'0'O, ! chi
	8 '004'O,'213'O,'211'O,'220'O,'231'O,'244'O,'112'O,'236'O, ! psi
	9 9*'0'O,
	1 '014'O,'203'O,'201'O,'210'O,'221'O,'223'O,'021'O,'230'O, ! omega
	2 '241'O,'243'O,'234'O,6*'0'O,
	3 '040'O,'221'O,'225'O,'246'O,'023'O,'213'O,11*'0'O, ! {
	4 '020'O,'223'O,'024'O,'227'O,13*'0'O, ! |
	5 '221'O,'225'O,'206'O,'023'O,'233'O,12*'0'O, ! }
	6 '006'O,'217'O,'226'O,'237'O,13*'0'O/ ! ~

C
	NVECS=VECT_BYTES(SYMBOL-31)
	SYMBOL_STATIC=SYMBOL
	RETURN
C
	ENTRY SPECSYMGR(SPEC_SYMBOL,NVECS)
C
C	This entry finds the number of vectors required to draw a special
C  symbol.

	NVECS=SYMBOL_BYTES(SPEC_SYMBOL+1)
	SYMBOL_STATIC=SPEC_SYMBOL
	RETURN
C
	ENTRY VECSYMGR(I,X,Y,IPEN)
C
C	This entry decodes a byte into X and Y movements, and pen up/down
C  control.
C
C	I       (C)     I       Vector number within character
C	X       (R)     I*2     X move
C	Y       (R)     I*2     Y move
C	IPEN    (R)     L*1     .TRUE. for pen down.
C
	I2TEMP=CHAR_GEN(I,SYMBOL_STATIC+1)
	X=IAND(I2TEMP,'70'O)/8
	Y=IAND(I2TEMP,'07'O)
	IF (IAND(I2TEMP,'100'O)/64) Y=-Y
	IPEN=IAND(I2TEMP,'200'O)/128
	RETURN
	END
