	SUBROUTINE TEK(IX,IY,IPEN)
C
C  Note:  This is the Unix version
C
C       This subroutine does graphic output to a TEKTRONIX graphics 
C  terminal or a compatible graphics emulator.  It is called
C  by TEKPLOT.  If a new version of a graphics terminal is added,
C  changes must be made in PLOTDEVICES, PLOTDEVICES2, PLTDEV, PLTWRITE,
C  RESETTEK, TEKCON, TEKPAU, WHERE, PLOTCOM, PARSE, PLOTDEVQUES, as 
C  well as in TEK, and possibly in CROSSHAIR.  Because not all graphics 
C  terminals behave similarly, special code is necessary for each one.  
C  The variable PLTDEV is assigned the following values for the presently 
C  supported terminals.
C		TERMINAL			PLTDEV
C		VT100 with Retrographics	1
C		Visual 550			1
C		Graphon				101
C		Codonics			201
C		Microterm			301
C		Versaterm			401
C		Xterm			      10001
C		Xgterm			      20001
C
C			DENIS WARNE, January, 1979
C		Version 2, Greg Quin, June, 1980
C		Delays are done using event flags instead of HIBERNATE.
C		Version 3, Donald H. Gudehus, September, 1982
C		Added return to transparent mode (IPEN=4).
C		Version 4, Donald H. Gudehus & Edd Doutre,
C		November, 1982
C		Added other types of lines.  /PLOT$VECTOR/ MODE
C		COMMON block passes  codes for vector type.
C		Version 5, Donald H. Gudehus, October, 1983
C		Added IPEN=5 (setting of vector type)
C		Version 6, Donald H. Gudehus, October, 1983
C		Increased VECTORDELAY to 0.0002 second to allow
C		operation of VISUAL 550
C		Version 7, Donald H. Gudehus, January, 1984
C		Added IPEN=8 (setting of data level)
C		Version 8, Donald H. Gudehus, February, 1984
C		Added code for IPEN=9 (rectilinear graphics),
C		IPEN=10 (alphagraphics), and IPEN=11 (setting of
C		filling style)
C		Version 9, Donald H. Gudehus, February, 1987
C		Added code for GraphOn terminal.
C		Version 10, Donald H. Gudehus, March, 1987
C		Added code for Codonics corrupted terminal.
C		Version 11, Donald H. Gudehus, November, 1988
C		Added code for Micro-term terminal
C		Version 12, Donald H. Gudehus, May, 1992
C		Added code for the VersaTerm emulator
C		Version 13, Donald H. Gudehus, October, 1994
C		Added error checking and recovery for vector styles
C		for Xterm.
C		Version 13U, Donald H. Gudehus, December, 1999
C		Modified code to work under Unix.
C		Version 14, Donald H. Gudehus, January 20, 2000
C		Added IPEN=18 to flush the buffer, as required
C		for some displays such as xterm and xgterm under Unix.
C		Version 14U, Donald H. Gudehus, April 19, 2000
C		Added code for rectangular fill and color for xgterm.
C		Version 15, Donald H. Gudehus, March 25, 2004
C		Various changes for devices 401 and 20001.
C
C	CALL:
C		CALL TEK(IX,IY,IPEN)
C
C	WHERE:
C		IX=	X  Raster coordinate
C		IY=	Y  Raster coordinate
C		IPEN = 	0  Erases screen and readies terminal for
C			   drawing bright vectors.
C			1  Goes to point plot mode
C			2  Sends the new position for a point, a
C			   vector, or a rectangle.
C			3  Moves to a spot with the pen up
C			4  Goes to the transparent mode
C			5  Sets the line style
C			6  Sets the color
C			7  Rings the bell
C			8  Sets the data level:  0 = dots turned on,
C			   1 = dots turned off, 2 = dots toggled/
C			   complemented
C			9  Goes to rectilinear graphics mode
C		       10  Sets the cursor position and goes to the
C			   alphagraphics mode
C		       11  Sets the filling style
C		       12  Sets the pen width	 
C		       18  Flushes the buffer
C
	BYTE TAG(4),BUF(40)
	BYTE BYTE
	CHARACTER*12 ERASEDELAY,VECTORDELAY,RECTDELAY_401,VECTDELAY_401*11,
	1TRANSPRTDELAY,CBUFTEMP*4
	CHARACTER*20 CBUF
	EQUIVALENCE (BUF(1),CBUF(1:1))
C	INTEGER ERASTIM(2),VECTIM(2),TRANSPRTTIM(2)
	INTEGER FILL,STATIC_COLOR_24(0:9),STATIC_COLOR_8(3,0:9),
	2VERSATERM_COLOR_24(0:15),VERSATERM_COLOR_TRIPLET(3,0:15),
	3RED,GREEN,BLUE,COLOR_DIFF(0:15)
	LOGICAL PEN_UP,POINT_PLOT,RECTILINEAR
C
	COMMON /PLOT_CHAN/ NCHAN,NDEV
	COMMON /PLOT_LINESTYLE/ MODE
	COMMON /PLOT_DATALEVEL/ LEVEL
	COMMON /PLOT_FILLSTYLE/ FILL
	COMMON /PLOT_TEKSAVE/ IXOLD,IYOLD
C
	INTEGER LCOLOR,WIDTH
	COMMON /PLOT_COLOR/ LCOLOR
	COMMON /PLOT_PENWIDTH/ WIDTH
C
	BYTE SOH,STX,ETX,BEL,DLE,NAK,CAN,EM,ESC,FF,FS,GS,US,SP,RS
	BYTE IO$_WRITEVBLK,USRT1,USRT2,USRT3
	INTEGER*2 IO$M_NOFORMAT,IO_WRITE
	PARAMETER (SOH='01'X,STX='02'X,ETX='03'X,BEL='07'X,DLE='10'X,
	1NAK='15'X,CAN='18'X,EM='19'X,ESC='1B'X,FF='0C'X,FS='1C'X,
	2GS='1D'X,US='1F'X,SP='20'X,RS='1E'X,IO$_WRITEVBLK='30'X,
	3IO$M_NOFORMAT='100'X,
	4USRT1='78'X,USRT2='79'X,USRT3='7A'X)
C  The above 2 lines are the HEX codes for the diffferent types
C  of lines available on various graphics terminals.
	PARAMETER (IO_WRITE=IO$_WRITEVBLK+IO$M_NOFORMAT)
C
	DATA TAG/'20'X,'60'X,'20'X,'40'X/
	DATA ERASEDELAY,VECTORDELAY,RECTDELAY_401,VECTDELAY_401
	1/'0 ::0.5','0 ::0.0002','0 ::0.0003','0 ::0.00001'/
	DATA TRANSPRTDELAY/'0 ::0.05'/
	DATA STATIC_COLOR_24/0,16777200,16711680,65280,255,65535,16776960,
	1 16711935,16766720,7982541/
C  black, ivory1, Red, Green, Blue, Cyan, Yellow, Magenta, gold1, DarkSlateGray3
C  These colors should be listed in the .Xdefaults file.
	DATA VERSATERM_COLOR_24/16777215,0,16711680,65280,255,
	1 65535,16711935,16776960,16753920,11403055,65407,52945,
	2  10494192,16711935,9127187,8355711/
C  white, black, red, green, blue, cyan, magenta, yellow, orange,
C  green yellow, spring green1, dark turquoise, purple, magenta,
C  saddle brown, gray50
C
	DATA IXOLD,IYOLD,RECTILINEAR/0,0,.FALSE./
C
C  Define a function to set up the bit pattern for a vector or point
C
	BYTE(ICOORD,N)=(ICOORD/32**(N-1).AND.'1F'X)
C
C  Erase the screen (when beginning to plot)
C
	IF (IPEN.EQ.0) THEN
	  IF (NDEV.EQ.201) THEN
	    BUF(1)=GS
	    BUF(2)=ESC
	    BUF(3)='1'
	    BUF(4)='T'
	    BUF(5)='0'
	    BUF(6)='5'
	    BUF(7)=SP
	    BUF(8)=GS
	    DO I=1,8
	      II=PUTC(BUF(I))
	    END DO
	    CALL DELAY(0.5) !  Erase delay
	  ELSE IF (NDEV.EQ.301) THEN
C  Go to terminal mode in order to erase text
	    BUF(1)=ESC
	    BUF(2)='4F'X
	    BUF(3)=ESC
	    BUF(4)='32'X
C  Erase the text
	    BUF(5)=ESC
	    BUF(6)='5B'X
	    BUF(7)='32'X
	    BUF(8)='4A'X
C  Go to native mode
	    BUF(9)=ESC
	    BUF(10)='31'X
C  Go to PLOT10 mode
	    BUF(11)=ESC
	    BUF(12)='2A'X
	    DO I=1,12
	      II=PUTC(BUF(I))
	    END DO
	    CALL DELAY(0.5) !  Erase delay
	  ELSE IF (NDEV.EQ.401) THEN
C  For Versaterm, calculate the 8-bit color triplets
	    DO I=0,15
	      CALL COLOR_24_TRIPLET(VERSATERM_COLOR_24(I),
	1     VERSATERM_COLOR_TRIPLET(3,I),VERSATERM_COLOR_TRIPLET(2,I),
	2     VERSATERM_COLOR_TRIPLET(1,I),0)
	    END DO
	  ELSE IF (NDEV.EQ.10001.OR.NDEV.EQ.20001) THEN
	    BUF(1)=ESC
	    BUF(2)='['
	    BUF(3)='?'
	    BUF(4)='3'
	    BUF(5)='8'
	    BUF(6)='h'
	    DO I=1,6
	      II=PUTC(BUF(I))
	    END DO
	    CALL DELAY(0.05)
	  END IF
	  BUF(1)=GS !  Enters vector mode.  An FS would also work here.
	  BUF(2)=ESC
	  BUF(3)=FF !  Erases
	  DO I=1,3
	    II=PUTC(BUF(I))
	  END DO
C  For xgterm, create a colormap (for future development)
	  IF (NDEV.EQ.20001) THEN
	    BUF(1)=ESC
	    BUF(2)='r'
	    BUF(3)='w'
	    BUF(4)='c'
	    BUF(5)='['
	    BUF(6)='0'
	    BUF(7)=';'
	    BUF(8)='0'
	    BUF(9)=';'
	    BUF(10)='1'
	    BUF(11)=']'
	    BUF(12)=0
	    BUF(13)=0
	    BUF(14)=0
	    BUF(15)=0
	    BUF(16)=0
	    BUF(17)=48
	    BUF(18)=GS
	    DO I=1,18
	      II=PUTC(BUF(I))
	    END DO
C  For xgterm, calculate the 8-bit color triplets
	    DO I=0,9
	      CALL COLOR_24_TRIPLET(STATIC_COLOR_24(I),STATIC_COLOR_8(3,I),
	1     STATIC_COLOR_8(2,I),STATIC_COLOR_8(1,I),0)
	    END DO
	  END IF
	  IF (NDEV.NE.10001.AND.NDEV.NE.20001) THEN
c	    CALL DELAY(0.5)
	  END IF
	  PEN_UP=.TRUE.
C  The following is no longer necessary (it was used to initialize TEKPAU).
C	  WRITE(6,2000)
C2000	  FORMAT(' ',' ')	  
C
	  RETURN
	END IF
C
C  Enter the point plot mode
C
	IF (IPEN.EQ.1) THEN
	  POINT_PLOT=.TRUE.
	  PEN_UP=.FALSE.
	  RETURN
	END IF
C
C  Draw a dark vector
C
	IF (IPEN.EQ.3) THEN
	  POINT_PLOT=.FALSE.
	  PEN_UP=.TRUE.
	END IF
C
C  Go to the transparent mode
C
	IF (IPEN.EQ.4) THEN
C  For VersaTerm in 4105 emulation we need to send US and CAN.  In 4014
C  emulation, a CAN will do.
	  IF (NDEV.EQ.401) THEN
	    BUF(1)=US
	    BUF(2)=CAN
	    DO I=1,2
	      II=PUTC(BUF(I))
	    END DO
	  ELSE
	    BUF(1)=CAN
	    II=PUTC(BUF(1))
	  END IF
	  IF (NDEV.NE.10001.AND.NDEV.NE.20001) THEN
	    CALL DELAY(0.05)
	  END IF
	  IF (NDEV.EQ.301) THEN
C  Go to native mode
	    BUF(1)=ESC
	    BUF(2)='4F'X
C  Go to Alpha mode
	    BUF(3)=ESC
	    BUF(4)='32'X
	    DO I=1,4
	      II=PUTC(BUF(I))
	    END DO
	    CALL DELAY(0.5)
	  ELSE IF (NDEV.EQ.10001) THEN
	    BUF(1)=ESC
	    BUF(2)=ETX
	    DO I=1,2
	      II=PUTC(BUF(I))
	    END DO
	  END IF
	  RETURN
	END IF
C
C  Set the type of lines that are indicated for the vector
C
	IF (IPEN.EQ.5) THEN
	  BUF(1)=ESC !  For all types of vectors
	  IF (NDEV.EQ.10001) THEN
	    BUF(2)=MOD(MODE,7)+96 !  Values of 7 and above make Xterm crash
	  ELSE IF (NDEV.EQ.20001) THEN
	    BUF(2)=MOD(MODE,5)+96
	  ELSE 
	    BUF(2)=MODE+96
	  END IF
	  DO I=1,2
	    II=PUTC(BUF(I))
	  END DO
	  RETURN
	END IF
C
C  Set the color
C
	IF (IPEN.EQ.6) THEN
	  IF (NDEV.EQ.401) THEN
C  Get the nearest Versaterm color.  There are 16 colors in the pallet, but
C  only 10 appear to be accessible.
	    CALL COLOR_24_TRIPLET(LCOLOR,RED,GREEN,BLUE,0)
	    DO I=0,15
	      COLOR_DIFF(I)=ABS(RED-VERSATERM_COLOR_TRIPLET(3,I))+
	1     ABS(GREEN-VERSATERM_COLOR_TRIPLET(2,I))+
	2     ABS(BLUE-VERSATERM_COLOR_TRIPLET(1,I))
	    END DO
	    IDIFF=3*255
	    IMIN=0
	    DO I=0,15
	      IF (COLOR_DIFF(I).LT.IDIFF) THEN
	        IDIFF=COLOR_DIFF(I)
	        IMIN=I
	      END IF
	    END DO
	    BUF(1)=ESC
	    BUF(2)='M'
	    BUF(3)='L'
	    ITEMP=MOD(IMIN,16)
	    ITEMP=IOR(ITEMP,'30'X)
	    BUF(4)=ITEMP
	    DO I=1,4
	      II=PUTC(BUF(I))
	    END DO
	  ELSE IF (NDEV.EQ.20001) THEN
	    BUF(1)=ESC
	    BUF(2)='/'
	    IF (LCOLOR.EQ.STATIC_COLOR_24(0)) THEN
	      BUF(3)='0' !  black (Background)
	    ELSE IF (LCOLOR.EQ.STATIC_COLOR_24(1)) THEN
	      BUF(3)='1' !  ivory1 (Foreground)
	    ELSE IF (LCOLOR.EQ.STATIC_COLOR_24(2)) THEN
	      BUF(3)='2' !  Red
	    ELSE IF (LCOLOR.EQ.STATIC_COLOR_24(3)) THEN
	      BUF(3)='3' !  Green
	    ELSE IF (LCOLOR.EQ.STATIC_COLOR_24(4)) THEN
	      BUF(3)='4' !  Blue
	    ELSE IF (LCOLOR.EQ.STATIC_COLOR_24(5)) THEN
	      BUF(3)='5' !  Cyan
	    ELSE IF (LCOLOR.EQ.STATIC_COLOR_24(6)) THEN
	      BUF(3)='6' !  Yellow
	    ELSE IF (LCOLOR.EQ.STATIC_COLOR_24(7)) THEN
	      BUF(3)='7' !  Magenta
	    ELSE IF (LCOLOR.EQ.STATIC_COLOR_24(8)) THEN
	      BUF(3)='8' !  gold1
	    ELSE IF (LCOLOR.EQ.STATIC_COLOR_24(9)) THEN
	      BUF(3)='9' !  DarkSlateGray3
	    ELSE
C  Search for the nearest static color
	      CALL COLOR_24_TRIPLET(LCOLOR,RED,GREEN,BLUE,0)
	      DO I=0,9
	        COLOR_DIFF(I)=ABS(RED-STATIC_COLOR_8(3,I))+
	1       ABS(GREEN-STATIC_COLOR_8(2,I))+
	2       ABS(BLUE-STATIC_COLOR_8(1,I))
	      END DO
	      IDIFF=3*255
	      IMIN=0
	      DO I=0,9
	        IF (COLOR_DIFF(I).LT.IDIFF) THEN
	          IDIFF=COLOR_DIFF(I)
	          IMIN=I
	        END IF
	      END DO
	      BUF(3)=48+IMIN
	    END IF
	    BUF(4)='c'
	    DO I=1,4
	      II=PUTC(BUF(I))
	    END DO
	  END IF
	  RETURN
	END IF
C
C  Ring the bell
C
	IF (IPEN.EQ.7) THEN
	  BUF(1)=BEL
	  II=PUTC(BUF(1))
	  RETURN
	END IF
C
C  Set the data level
C
	IF (IPEN.EQ.8) THEN
C  Xterm under Unix cannot handle the following commands without producing
C  characters on the screen.
	  IF (NDEV.NE.101.AND.NDEV.NE.201.AND.NDEV.NE.10001) THEN
	    BUF(1)=ESC
	    BUF(2)='/'
	    BUF(3)=LEVEL+48
	    BUF(4)='d'
	    DO I=1,4
	      II=PUTC(BUF(I))
	    END DO
	  ELSE IF (NDEV.EQ.101) THEN
	    BUF(1)=ESC
	    IF (LEVEL.EQ.0) THEN
	      BUF(2)=SOH
	    ELSE IF (LEVEL.EQ.1) THEN
	      BUF(2)=DLE
	    ELSE IF (LEVEL.EQ.2) THEN
	      BUF(2)=NAK
	    ELSE IF (LEVEL.EQ.3) THEN
	      BUF(2)=EM
	    END IF
	    DO I=1,2
	      II=PUTC(BUF(I))
	    END DO
	  ELSE IF (NDEV.EQ.201) THEN
	    BUF(1)=ESC
	    BUF(2)='1'
	    BUF(3)='L'
	    BUF(4)='T'
	    IF (LEVEL.EQ.0) THEN
	      BUF(5)='0'
	    ELSE IF (LEVEL.EQ.1) THEN
	      BUF(5)='1'
	    ELSE IF (LEVEL.EQ.2) THEN
	      BUF(5)='2'
	    ELSE IF (LEVEL.EQ.3) THEN
	      BUF(5)='3'
	    END IF
	    BUF(6)=SP
	    BUF(7)=GS
	    DO I=1,7
	      II=PUTC(BUF(I))
	    END DO
	  END IF
	  RETURN
	END IF
C
C  Go to the rectilinear mode
C
	IF (IPEN.EQ.9) THEN
	  RECTILINEAR=.TRUE.
	  RETURN
	END IF
C
C  Go to the alphagraphics mode
C
	IF (IPEN.EQ.10) THEN
	  BUF(1)=US
	  II=PUTC(BUF(1))
	  RETURN
	END IF
C
C  Set the filling style
C
	IF (IPEN.EQ.11) THEN
	  IFILL=ABS(FILL)
	  IF (NDEV.EQ.1.OR.NDEV.EQ.4) THEN
	    BUF(1)=ESC
	    BUF(2)='@' !  Default
	    IF (FILL.EQ.0) BUF(2)='@'
	    IF (FILL.EQ.1) BUF(2)='A'
	    IF (FILL.EQ.2) BUF(2)='B'
	    IF (FILL.EQ.3) BUF(2)='C'
	    IF (FILL.EQ.4) BUF(2)='D'
	    IF (FILL.EQ.5) BUF(2)='E'
	    IF (FILL.EQ.6) BUF(2)='F'
	    IF (FILL.EQ.7) BUF(2)='G'
	    DO I=1,2
	      II=PUTC(BUF(I))
	    END DO
	  ELSE IF (NDEV.EQ.101) THEN
	    BUF(1)=ESC
	    BUF(2)=STX
	    BUF(3)=ESC
	    BUF(4)='`' !  Default
	    IF (FILL.EQ.0) BUF(4)='`'
	    IF (FILL.EQ.1) BUF(4)='a'
	    IF (FILL.EQ.2) BUF(4)='b'
	    IF (FILL.EQ.3) BUF(4)='c'
	    IF (FILL.EQ.4) BUF(4)='d'
	    IF (FILL.EQ.5) BUF(4)='e'
	    IF (FILL.EQ.6) BUF(4)='f'
	    IF (FILL.EQ.7) BUF(4)='g'
	    BUF(5)=ESC
	    BUF(6)=ETX
	    DO I=1,6
	      II=PUTC(BUF(I))
	    END DO
	  ELSE IF (NDEV.EQ.201) THEN
	    BUF(1)=ESC
	    BUF(2)='1'
	    BUF(3)='U'
	    BUF(4)='M'
C  Each pattern is user defined.  Only FILL=0 and 1 is ready.
	    IF (FILL.EQ.0) THEN
	      BUF(5)='F'
	      BUF(6)='F'
	      BUF(7)='F'
	      BUF(8)='F'
	      BUF(9)='F'
	      BUF(10)='F'
	      BUF(11)='F'
	      BUF(12)='F'
	      BUF(13)='F'
	      BUF(14)='F'
	      BUF(15)='F'
	      BUF(16)='F'
	      BUF(17)='F'
	      BUF(18)='F'
	      BUF(19)='F'
	      BUF(20)='F'
	    ELSE IF (FILL.EQ.1) THEN
	      BUF(5)='A'
	      BUF(6)='A'
	      BUF(7)='5'
	      BUF(8)='5'
	      BUF(9)='A'
	      BUF(10)='A'
	      BUF(11)='5'
	      BUF(12)='5'
	      BUF(13)='A'
	      BUF(14)='A'
	      BUF(15)='5'
	      BUF(16)='5'
	      BUF(17)='A'
	      BUF(18)='A'
	      BUF(19)='5'
	      BUF(20)='5'
	    END IF
	    DO I=1,20
	      II=PUTC(BUF(I))
	    END DO
	    BUF(1)=GS
	    II=PUTC(BUF(1))
	    CALL DELAY(0.0002)
	  ELSE IF (NDEV.EQ.401) THEN
	    BUF(1)=ESC
	    BUF(2)='M'
	    BUF(3)='P'
	    IF (IFILL.LT.50) THEN
	      ITEMP=MOD(IFILL,16)
	      ITEMP=IOR(ITEMP,'20'X)
	      IF (FILL.GT.0) ITEMP=IOR(ITEMP,'10'X)
	      BUF(4)=ITEMP
	      IB=4
	    ELSE IF (IFILL.GE.50.AND.IFILL.LE.174) THEN
	      ITEMP=IFILL/16
	      ITEMP=IAND(ITEMP,'3F'X)
	      ITEMP=IOR(ITEMP,'40'X)
	      BUF(4)=ITEMP
	      ITEMP=IAND(IFILL,'0F'X)
	      ITEMP=IOR(ITEMP,'20'X)
	      IF (FILL.GT.0) ITEMP=IOR(ITEMP,'10'X)
	      BUF(5)=ITEMP
	      IB=5
	    END IF
	    DO I=1,IB
	      II=PUTC(BUF(I))
	    END DO
	  END IF
	  RETURN
	END IF
C
C  Set the pen width
C
	IF (IPEN.EQ.12) THEN
          IF (NDEV.EQ.20001) THEN
            BUF(1)=ESC
            BUF(2)='/'
            IF (WIDTH/12.LE.1) THEN
              BUF(3)='0' 
            ELSE IF (WIDTH/12.EQ.2) THEN
              BUF(3)='1'
	    ELSE IF (WIDTH/12.EQ.3) THEN
	      BUF(3)='2'
	    END IF
	    BUF(4)='w'
	    DO I=1,4
	      II=PUTC(BUF(I))
	    END DO
	  END IF
	  RETURN
	END IF
C
C  Flush the buffer
C
	IF (IPEN.EQ.18) THEN
C	  BUF(1)=US
C	  BUF(2)=LF
C	  BUF(2)=GS
C	  DO I=1,2
C	    II=PUTC(BUF(I))
C	  END DO
	  PRINT *, ' '
	  RETURN
	END IF
C
C  Send the new location;  either a point, a dark vector, a
C  bright vector, or a filled rectangle  will result.  Erasure will
C  occur if the data level was set to 1.
C
	IF (RECTILINEAR) THEN
	  IF (NDEV.EQ.1.OR.NDEV.EQ.4) THEN
	    BUF(1)=ESC
	    BUF(2)='/'
	    IF ((IX-IXOLD).GT.0) THEN
	      ENCODE(4,1000,CBUFTEMP) IXOLD
1000	      FORMAT (I4)
	    ELSE !  Plot file was rotated
	      ENCODE(4,1000,CBUFTEMP) IX
	    END IF
	    BUF(3)=ICHAR(CBUFTEMP(1:1))
	    BUF(4)=ICHAR(CBUFTEMP(2:2))
	    BUF(5)=ICHAR(CBUFTEMP(3:3))
	    BUF(6)=ICHAR(CBUFTEMP(4:4))
	    BUF(7)=';'
	    IF ((IY-IYOLD).GT.0) THEN
	      ENCODE(4,1000,CBUFTEMP) IYOLD
	    ELSE  ! Plot file was rotated
	      ENCODE(4,1000,CBUFTEMP) IY
	    END IF
	    BUF(8)=ICHAR(CBUFTEMP(2:2))
	    BUF(9)=ICHAR(CBUFTEMP(3:3))
	    BUF(10)=ICHAR(CBUFTEMP(4:4))
	    BUF(11)=';'
	    DO I=3,10
	      IF (BUF(I).EQ.32) BUF(I)=48
	    END DO
	    DO I=1,11
	      II=PUTC(BUF(I))
	    END DO
	    ENCODE(4,1000,CBUFTEMP) ABS(IX-IXOLD)
	    BUF(1)=ICHAR(CBUFTEMP(1:1))
	    BUF(2)=ICHAR(CBUFTEMP(2:2))
	    BUF(3)=ICHAR(CBUFTEMP(3:3))
	    BUF(4)=ICHAR(CBUFTEMP(4:4))
	    BUF(5)=';'
	    ENCODE(4,1000,CBUFTEMP) ABS(IY-IYOLD)
	    BUF(6)=ICHAR(CBUFTEMP(2:2))
	    BUF(7)=ICHAR(CBUFTEMP(3:3))
	    BUF(8)=ICHAR(CBUFTEMP(4:4))
	    BUF(9)='y'
	    DO I=1,8
	      IF (BUF(I).EQ.32) BUF(I)=48
	    END DO
	    DO I=1,9
	      II=PUTC(BUF(I))
	    END DO
C  Do the block for the GraphOn graphics terminal
C  No correction for a rotated plot file has yet been made
	  ELSE IF (NDEV.EQ.101) THEN
	    BUF(1)=GS
	    II=PUTC(BUF(1))
	    BUF(1)=BYTE(IYOLD,2).OR.TAG(1)
	    BUF(2)=BYTE(IYOLD,1).OR.TAG(2)
	    BUF(3)=BYTE(IXOLD,2).OR.TAG(3)
	    BUF(4)=BYTE(IXOLD,1).OR.TAG(4)
	    DO I=1,4
	      II=PUTC(BUF(I)) !  Untested
	    END DO
C
	    BUF(1)=ESC
	    BUF(2)=STX
	    DO I=1,2
	      II=PUTC(BUF(I))
	    END DO
	    BUF(1)=BYTE(IY,2).OR.TAG(1)
	    BUF(2)=BYTE(IY,1).OR.TAG(2)
	    BUF(3)=BYTE(IX,2).OR.TAG(3)
	    BUF(4)=BYTE(IX,1).OR.TAG(4)
	    DO I=1,4
	      II=PUTC(BUF(I))
	    END DO
	    BUF(1)=ESC
	    BUF(2)=ETX
	    DO I=1,2
	      II=PUTC(BUF(I))
	    END DO
C  Do the block for the Codonics graphics terminal
	  ELSE IF (NDEV.EQ.201) THEN
	    BUF(1)=GS
	    II=PUTC(BUF(1))
	    BUF(1)=BYTE(IYOLD,2).OR.TAG(1)
	    BUF(2)=BYTE(IYOLD,1).OR.TAG(2)
	    BUF(3)=BYTE(IXOLD,2).OR.TAG(3)
	    BUF(4)=BYTE(IXOLD,1).OR.TAG(4)
	    DO I=1,4
	      II=PUTC(BUF(I)) !  Untested
	    END DO
C
	    IF (IXOLD.GT.IX.OR.IYOLD.GT.IY) THEN !  Resets the lower left
						 !  corner in case the plot
						 !  file was rotated
	      BUF(1)=BYTE(MIN(IYOLD,IY),2).OR.TAG(1)
	      BUF(2)=BYTE(MIN(IYOLD,IY),1).OR.TAG(2)
	      BUF(3)=BYTE(MIN(IXOLD,IX),2).OR.TAG(3)
	      BUF(4)=BYTE(MIN(IXOLD,IX),1).OR.TAG(4)
	      DO I=1,4
	        II=PUTC(BUF(I))
	      END DO
	      CALL DELAY(0.0002)
	    END IF
	    BUF(1)=ESC
	    BUF(2)='1'
	    BUF(3)='A'
	    BUF(4)='R'
	    ENCODE(4,1000,CBUFTEMP) MAX(IXOLD,IX)
	    BUF(5)=ICHAR(CBUFTEMP(1:1))
	    BUF(6)=ICHAR(CBUFTEMP(2:2))
	    BUF(7)=ICHAR(CBUFTEMP(3:3))
	    BUF(8)=ICHAR(CBUFTEMP(4:4))
	    BUF(9)=SP
	    ENCODE(4,1000,CBUFTEMP) MAX(IYOLD,IY)
	    BUF(10)=ICHAR(CBUFTEMP(2:2))
	    BUF(11)=ICHAR(CBUFTEMP(3:3))
	    BUF(12)=ICHAR(CBUFTEMP(4:4))
	    BUF(13)=SP
	    DO I=5,8
	      IF (BUF(I).EQ.32) BUF(I)=48
	    END DO
	    DO I=10,12
	      IF (BUF(I).EQ.32) BUF(I)=48
	    END DO
	    DO I=1,13
	      II=PUTC(BUF(I))
	    END DO
	    BUF(1)=GS
	    II=PUTC(BUF(1))
C  Do the block for Versaterm
	  ELSE IF (NDEV.EQ.401) THEN	  
C  Versaterm in 4014 emulation for Unix writes a vector from the lower left
C  to the upper right of the rectangle using the color of the next rectangle.
C  Sending a pen up command seems to fix that.  
	    BUF(1)=FS
	    BUF(2)=IOR(BYTE(IYOLD,2),TAG(1))
	    BUF(3)=IOR(BYTE(IYOLD,1),TAG(2))
	    BUF(4)=IOR(BYTE(IXOLD,2),TAG(3))
	    BUF(5)=IOR(BYTE(IXOLD,1),TAG(4))
	    DO I=1,5
	      II=PUTC(BUF(I))
	    END DO
	    BUF(1)=GS
	    II=PUTC(BUF(1))
C  Now fill the rectangle
C  No correction for rotated plot yet
	    BUF(1)=ESC
	    BUF(2)='L'
	    BUF(3)='P'
	    BUF(4)=BYTE(IYOLD,2).OR.TAG(1)
	    BUF(5)=BYTE(IYOLD,1).OR.TAG(2)
	    BUF(6)=BYTE(IXOLD,2).OR.TAG(3)
	    BUF(7)=BYTE(IXOLD,1).OR.TAG(4)
	    BUF(8)='0'
	    BUF(9)=GS
	    BUF(10)=BYTE(IYOLD,2).OR.TAG(1)
	    BUF(11)=BYTE(IYOLD,1).OR.TAG(2)
	    BUF(12)=BYTE(IXOLD,2).OR.TAG(3)
	    BUF(13)=BYTE(IXOLD,1).OR.TAG(4)
	    BUF(14)=BYTE(IY,2).OR.TAG(1)
	    BUF(15)=BYTE(IY,1).OR.TAG(2)
	    BUF(16)=BYTE(IXOLD,2).OR.TAG(3)
	    BUF(17)=BYTE(IXOLD,1).OR.TAG(4)
	    BUF(18)=BYTE(IY,2).OR.TAG(1)
	    BUF(19)=BYTE(IY,1).OR.TAG(2)
	    BUF(20)=BYTE(IX,2).OR.TAG(3)
	    BUF(21)=BYTE(IX,1).OR.TAG(4)
	    BUF(22)=BYTE(IYOLD,2).OR.TAG(1)
	    BUF(23)=BYTE(IYOLD,1).OR.TAG(2)
	    BUF(24)=BYTE(IX,2).OR.TAG(3)
	    BUF(25)=BYTE(IX,1).OR.TAG(4)
	    BUF(26)=BYTE(IYOLD,2).OR.TAG(1)
	    BUF(27)=BYTE(IYOLD,1).OR.TAG(2)
	    BUF(28)=BYTE(IXOLD,2).OR.TAG(3)
	    BUF(29)=BYTE(IXOLD,1).OR.TAG(4)
	    BUF(30)=ESC
	    BUF(31)='L'
	    BUF(32)='E'
	    DO I=1,32
	     II=PUTC(BUF(I))
	    END DO
C  Put in a pause for VersaTerm
	  ELSE IF (NDEV.EQ.20001) THEN
	    BUF(1)=ESC
	    BUF(2)=RS
	    BUF(3)=BYTE(IY,2).OR.TAG(1)
	    BUF(4)=BYTE(IY,1).OR.TAG(2)
	    BUF(5)=BYTE(IXOLD,2).OR.TAG(3)
	    BUF(6)=BYTE(IXOLD,1).OR.TAG(4)
	    BUF(7)=BYTE(IY,2).OR.TAG(1)
	    BUF(8)=BYTE(IY,1).OR.TAG(2)
	    BUF(9)=BYTE(IX,2).OR.TAG(3)
	    BUF(10)=BYTE(IX,1).OR.TAG(4)
	    BUF(11)=BYTE(IYOLD+0,2).OR.TAG(1)
	    BUF(12)=BYTE(IYOLD+0,1).OR.TAG(2)
	    BUF(13)=BYTE(IX,2).OR.TAG(3)
	    BUF(14)=BYTE(IX,1).OR.TAG(4)
	    BUF(15)=BYTE(IYOLD+0,2).OR.TAG(1)
	    BUF(16)=BYTE(IYOLD+0,1).OR.TAG(2)
	    BUF(17)=BYTE(IXOLD,2).OR.TAG(3)
	    BUF(18)=BYTE(IXOLD,1).OR.TAG(4)
	    BUF(19)=BYTE(IYOLD,2).OR.TAG(1)
	    BUF(20)=BYTE(IYOLD,1).OR.TAG(2)
	    BUF(21)=BYTE(IXOLD,2).OR.TAG(3)
	    BUF(22)=BYTE(IXOLD,1).OR.TAG(4)
	    DO I=1,18
	      II=PUTC(BUF(I))
	    END DO
	  END IF
	ELSE
	  IF (IPEN.EQ.2) THEN
	    IF (PEN_UP) THEN !  From a previous IPEN=3
	      BUF(1)=GS
	      II=PUTC(BUF(1))
	      BUF(1)=BYTE(IYOLD,2).OR.TAG(1)
	      BUF(2)=BYTE(IYOLD,1).OR.TAG(2)
	      BUF(3)=BYTE(IXOLD,2).OR.TAG(3)
	      BUF(4)=BYTE(IXOLD,1).OR.TAG(4)
	      DO I=1,4
	        II=PUTC(BUF(I))
	      END DO
	    ELSE IF (POINT_PLOT) THEN
	      BUF(1)=FS
	      II=PUTC(BUF(1))
	    END IF
	    PEN_UP=.FALSE.
	    POINT_PLOT=.FALSE.
	    IF (IXOLD.EQ.IX.AND.IYOLD.EQ.IY) THEN
	      BUF(1)=FS
	      II=PUTC(BUF(1))
	    END IF
	    BUF(1)=BYTE(IY,2).OR.TAG(1)
	    BUF(2)=BYTE(IY,1).OR.TAG(2)
	    BUF(3)=BYTE(IX,2).OR.TAG(3)
	    BUF(4)=BYTE(IX,1).OR.TAG(4)
	    DO I=1,4
	      II=PUTC(BUF(I))
	    END DO
	  END IF
	END IF
	IXOLD=IX 
	IYOLD=IY
	RECTILINEAR=.FALSE.
C
C  Pause for the devices and links to keep up
	IF (IPEN.EQ.2.AND.(NDEV.NE.10001.AND.NDEV.NE.20001
	1.AND.NDEV.NE.401)) THEN
	  CALL DELAY(0.0002)
	ELSE IF (IPEN.EQ.2.AND.NDEV.EQ.401) THEN
c	  CALL DELAY(0.00001)
	END IF
C
	RETURN
C
	END
