	SUBROUTINE TEKPLOT(COMMAND,SYMFIX,TEXT,XOFF,YOFF,SCALE,
	1COSR,SINR,ISTAT)
C
C  Note:  This is the Unix version
C
C       This subroutine is the online plot routine for the TEKTRONIX.
C  It takes the commands sent from the plot routines and
C  emulates a pen plotter on a graphics terminal.  This subroutine is
C  called by PLTWRITE.FOR for online plotting and by PLOTCOM.FOR when
C  plotting from a file.
C		Greg Quinn, Mount Stromlo Observatory, June 1980
C
C			Version 2, G. Quinn, November, 1980
C			Changed code to take scaling factor into account
C			when reorigining plot
C			Version 3, Donald H. Gudehus, October, 1982
C			Added command for end of alpha mode and return
C			to transparent mode
C			Version 4, Donald H. Gudehus, October, 1983
C			Added code for selecting line style and
C			changed NEW to INTEGER*4
C			Version 5, Donald H. Gudehus, January, 1984
C			Added code for color, data level, point plot
C			mode, and bell.
C			Version 6, Donald H. Gudehus, February, 1984
C			Added code for alphagrpahics, rectilinear
C			graphics, and fill style.
C			Version 7, Donald H. Gudehus, October, 1984
C			Added code for Greek alphabet, pen width,
C			and rotation
C			Version 8, Donald H. Gudehus, October, 1994
C			Eliminated code for unused plot commands
C			Version 8U, Donald H. Gudehus, January, 2000
C			Modified code for Unix
C			Version 9, Donald H. Gudehus, March 30, 2000
C			Added code for Xgterm
C			Version 10, Donald H. Gudehus, March 25, 2004
C			Various changes
C			Version 10U, Donald H. Gudehus, September 17, 2004
C			Introduced COMMON block TEKPLOT_SAVE for holding
C			XPOS and YPOS until the next call when calling
C			SYMBOL with (999.0,999.0).  Was not necessary
C			under VMS.
C
	COMMON /PLOT_CHAN/ NCHAN,NDEV
C
	COMMON /PLOT_LINESTYLE/ MODE
C
	COMMON /PLOT_DATALEVEL/ LEVEL
C
	COMMON /PLOT_FILLSTYLE/ FILL
C
	COMMON /PLOT_PENWIDTH/ WIDTH
C
	COMMON /PLOT_COLOR/ LCOLOR
C
	BYTE COMMAND(0:4),OPCODE,BCOM(4),TEXT(1)
	INTEGER*2 SYMFIX(0:2),I2COM(0:1)
	INTEGER*2 XORIGIN,YORIGIN,XPOS,YPOS,XCH,YCH,
	1XOFF,YOFF,DELX,DELY,NBS,DELXBS,DELYBS
	INTEGER*4 TEMP(2),NEW(2),FILL,WIDTH,LCOLOR,I4COM
	LOGICAL PLOTIT,ENGLISH,GREEK,NORMAL,SUBSCRIPT,SUPERSCRIPT
	REAL FACTOR,R4COM,SCALE
	EQUIVALENCE (BCOM,I2COM(0),R4COM,I4COM)
C
	COMMON /TEKPLOT_SAVE/ XPOS,YPOS
C
	INCLUDE 'plotpar.for'
C
	DATA FACTOR,XORIGIN,YORIGIN/1.0,0.0,0.0/
C
	ISTAT=SSP$_NORMAL
	DO I=1,4
	  BCOM(I)=COMMAND(I)
	END DO
C
C  Get the opcode.
C
	OPCODE=IAND(COMMAND(PLT$B_OPC),PLT$M_OPC)
C	OPCODE=COMMAND(PLT$B_OPC).AND.PLT$M_OPC
C
C  Endfile and endplot
C
	IF (OPCODE.EQ.PLT$OP_ENDFILE) THEN
	  ISTAT=PLT$S_ENDFILE
	ELSE IF (OPCODE.EQ.PLT$OP_ENDPLOT) THEN
	  XPOS=I2COM(PLT$W_X)
	  YPOS=I2COM(PLT$W_Y)
	  ISTAT=PLT$S_ENDPLOT
	ELSE IF (OPCODE.EQ.PLT$OP_ENDALPHA) THEN
	  CALL TEK(0,0,0)
	  CALL TEK(0,0,4)
	  ISTAT=PLT$S_ENDALPHA
C
C  Plot (pen down)
C
	ELSE IF (OPCODE.EQ.PLT$OP_PLOTDOWN) THEN
	  XPOS=I2COM(PLT$W_X)
	  YPOS=I2COM(PLT$W_Y)
	  TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*PLT$C_TEKPIX
	  TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*PLT$C_TEKPIX
	  NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	  NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	  CALL LIMIT(NEW(1),PLT$C_TEKXPIX,NEW(2),PLT$C_TEKYPIX,PLOTIT)
	  IF (PLOTIT) CALL TEK(NEW(1),NEW(2),2)
C
C  Move (pen up)
C
	ELSE IF (OPCODE.EQ.PLT$OP_PLOTUP) THEN
	  XPOS=I2COM(PLT$W_X)
	  YPOS=I2COM(PLT$W_Y)
	  TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*PLT$C_TEKPIX
	  TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*PLT$C_TEKPIX
	  NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	  NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	  CALL LIMIT(NEW(1),PLT$C_TEKXPIX,NEW(2),PLT$C_TEKYPIX,PLOTIT)
	  CALL TEK(NEW(1),NEW(2),3)
C
C  Plot text string
C
	ELSE IF (OPCODE.EQ.PLT$OP_SYMBOL) THEN
	  ANGLE=SYMFIX(PLT$W_ANGLE)
	  COSA=COSD(ANGLE)
	  SINA=SIND(ANGLE)
	  ENGLISH=.TRUE.
	  GREEK=.FALSE.
	  NORMAL=.TRUE.
	  SUBSCRIPT=.FALSE.
	  SUPERSCRIPT=.FALSE.
C  Determine DELX and DELY for the initial location
	  I=1
	  NBS=0  ! Initializes the number of backspaces
	  CALL TEXTCNCH(TEXT,I2COM,I,NBS,ENGLISH,GREEK,NORMAL,SUBSCRIPT,
	1 SUPERSCRIPT,SINA,COSA,DELX,DELY,SSF,DELXBS,DELYBS)
	  IF (IAND(COMMAND(PLT$B_OPC),PLT$M_SYMBCONT).EQ.0) THEN
	    XPOS=SYMFIX(PLT$W_SYMBX)+DELX
	    YPOS=SYMFIX(PLT$W_SYMBY)+DELY
	    TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*PLT$C_TEKPIX
	    TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*PLT$C_TEKPIX
	    NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	    NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	    CALL LIMIT(NEW(1),PLT$C_TEKXPIX,NEW(2),
	1   PLT$C_TEKYPIX,PLOTIT)
	    CALL TEK(NEW(1),NEW(2),3)
	  END IF
	  DO WHILE (I.LE.I2COM(PLT$W_NBYT))
	    IF (ENGLISH) THEN
	      CALL GETSYM(TEXT(I),NVECS)
	    ELSE IF (GREEK) THEN
	      CALL GETSYMGR(TEXT(I),NVECS)
	    END IF
	    IF (NVECS.GT.0) THEN
	      DO 450 J=1,NVECS
	        IF (ENGLISH) THEN
	          CALL VECSYM(J,XCH,YCH,IPEN)
	        ELSE IF (GREEK) THEN
	          CALL VECSYMGR(J,XCH,YCH,IPEN)
	        END IF
C  Note that PLT$C_CHARSIZE enters into the expression below because
C  it is necessary to scale down by the reciprocal of the maximum
C  value of YCH, 7.
	        TEMP(1)=((((XCH*COSA-YCH*SINA)*I2COM(PLT$W_HEIGHT)
	1       *PLT$C_CHARSIZE*SSF+XPOS)*FACTOR+XORIGIN)
	2       *SCALE-XOFF)*PLT$C_TEKPIX
	        TEMP(2)=((((XCH*SINA+YCH*COSA)*I2COM(PLT$W_HEIGHT)
	1       *PLT$C_CHARSIZE*SSF+YPOS)*FACTOR+YORIGIN)
	2       *SCALE-YOFF)*PLT$C_TEKPIX
	        NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	        NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	        CALL LIMIT(NEW(1),PLT$C_TEKXPIX,NEW(2),
	1       PLT$C_TEKYPIX,PLOTIT)
	        IF (IPEN) THEN
	          IF (PLOTIT) CALL TEK(NEW(1),NEW(2),2)
	        ELSE
	          CALL TEK(NEW(1),NEW(2),3)
	        END IF
 450	      CONTINUE
	    END IF
C  Advance to the next character location
	    XPOS=XPOS-DELX+DELXBS
	    YPOS=YPOS-DELY+DELYBS
	    I=I+1
	    NBS=0
	    CALL TEXTCNCH(TEXT,I2COM,I,NBS,ENGLISH,GREEK,NORMAL,
	1   SUBSCRIPT,SUPERSCRIPT,SINA,COSA,DELX,DELY,SSF,DELXBS,DELYBS)
	    XPOS=6*COSA*I2COM(PLT$W_HEIGHT)*PLT$C_CHARSIZE+XPOS+DELX
	    YPOS=6*SINA*I2COM(PLT$W_HEIGHT)*PLT$C_CHARSIZE+YPOS+DELY
	    TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*PLT$C_TEKPIX
	    TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*PLT$C_TEKPIX
	    NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	    NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	    CALL LIMIT(NEW(1),PLT$C_TEKXPIX,NEW(2),PLT$C_TEKYPIX,PLOTIT)
	    CALL TEK(NEW(1),NEW(2),3)
	  END DO
C
C  Set the plotting scale factor
C
	ELSE IF (OPCODE.EQ.PLT$OP_FACTOR) THEN
	  FACTOR=R4COM
C
C  Plot special symbol
C
	ELSE IF (OPCODE.EQ.PLT$OP_SYMBDOWN.OR.OPCODE.EQ.PLT$OP_SYMBUP) 
	1THEN
	  IF (OPCODE.EQ.PLT$OP_SYMBDOWN) THEN
	    XPOS=SYMFIX(PLT$W_SYMBX)
	    YPOS=SYMFIX(PLT$W_SYMBY)
	    TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*PLT$C_TEKPIX
	    TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*PLT$C_TEKPIX
	    NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	    NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	    CALL LIMIT(NEW(1),PLT$C_TEKXPIX,NEW(2),
	1   PLT$C_TEKYPIX,PLOTIT)
	    CALL TEK(NEW(1),NEW(2),2)
	  ELSE IF (IAND(COMMAND(PLT$B_OPC),PLT$M_SYMBCONT).EQ.0) THEN
	    XPOS=SYMFIX(PLT$W_SYMBX)
	    YPOS=SYMFIX(PLT$W_SYMBY)
	    TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*PLT$C_TEKPIX
	    TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*PLT$C_TEKPIX
	    NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	    NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	    CALL LIMIT(NEW(1),PLT$C_TEKXPIX,NEW(2),
	1   PLT$C_TEKYPIX,PLOTIT)
	    CALL TEK(NEW(1),NEW(2),3)
	  END IF
	  ANGLE=SYMFIX(PLT$W_ANGLE)
	  COSA=COSD(ANGLE)
	  SINA=SIND(ANGLE)
	  CALL SPECSYM(I2COM(PLT$W_SYMBNO),NVECS)
	  IF (NVECS.GT.0) THEN
	    DO 550 J=1,NVECS
	      CALL VECSYM(J,XCH,YCH,IPEN)
	      XCH=XCH-3
	      YCH=YCH-3
	      TEMP(1)=((((XCH*COSA-YCH*SINA)*I2COM(PLT$W_HEIGHT)
	1     *PLT$C_CHARSIZE+XPOS)*FACTOR+XORIGIN)
	2     *SCALE-XOFF)*PLT$C_TEKPIX
	      TEMP(2)=((((XCH*SINA+YCH*COSA)*I2COM(PLT$W_HEIGHT)
	1     *PLT$C_CHARSIZE+YPOS)*FACTOR+YORIGIN)
	2     *SCALE-YOFF)*PLT$C_TEKPIX
	      NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	      NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	      CALL LIMIT(NEW(1),PLT$C_TEKXPIX,NEW(2),
	1     PLT$C_TEKYPIX,PLOTIT)
	      IF (IPEN) THEN
	        IF (PLOTIT) CALL TEK(NEW(1),NEW(2),2)
	      ELSE
	        CALL TEK(NEW(1),NEW(2),3)
	      END IF
 550	    CONTINUE
	  END IF
	  XPOS=SYMFIX(PLT$W_SYMBX)
	  YPOS=SYMFIX(PLT$W_SYMBY)
	  TEMP(1)=((XPOS*FACTOR+XORIGIN)*SCALE-XOFF)*PLT$C_TEKPIX
	  TEMP(2)=((YPOS*FACTOR+YORIGIN)*SCALE-YOFF)*PLT$C_TEKPIX
	  NEW(1)=COSR*TEMP(1)-SINR*TEMP(2)
	  NEW(2)=SINR*TEMP(1)+COSR*TEMP(2)
	  CALL LIMIT(NEW(1),PLT$C_TEKXPIX,NEW(2),PLT$C_TEKYPIX,PLOTIT)
	  CALL TEK(NEW(1),NEW(2),3)
C
C  Select the line style
C
	ELSE IF (OPCODE.EQ.PLT$OP_LINESTYLE) THEN
	  MODE=I2COM(PLT$B_LINESTYLE)
	  CALL TEK(0,0,5)
C
C  Select the color
C
	ELSE IF (OPCODE.EQ.PLT$OP_COLOR) THEN
	  LCOLOR=I4COM
	  CALL TEK(0,0,6)
C
C  Set the data level
C
	ELSE IF (OPCODE.EQ.PLT$OP_DATALEVEL) THEN
	  LEVEL=I2COM(PLT$B_DATALEVEL)
	  CALL TEK(0,0,8)
C
C  Go to the point plot mode
C
	ELSE IF (OPCODE.EQ.PLT$OP_POINTPLOT) THEN
	  CALL TEK(0,0,1)
C
C  Ring the bell
C
	ELSE IF (OPCODE.EQ.PLT$OP_BELL) THEN
	  CALL TEK(0,0,7)
C
C  Go to alphagraphics
C
	ELSE IF (OPCODE.EQ.PLT$OP_ALPHAGRAPHICS) THEN
	  CALL TEK(0,0,10)
C
C  Go to rectilinear graphics
C
	ELSE IF (OPCODE.EQ.PLT$OP_RECTILINEAR) THEN
	  CALL TEK(0,0,9)
C
C  Set the filling style
C
	ELSE IF (OPCODE.EQ.PLT$OP_FILLSTYLE) THEN
	  FILL=I2COM(PLT$B_FILLSTYLE)
	  CALL TEK(0,0,11)
C
C  Set the pen width (for xgterm)
C
	ELSE IF (OPCODE.EQ.PLT$OP_PENWIDTH) THEN
	  WIDTH=I2COM(PLT$B_PENWIDTH)
	  CALL TEK(0,0,12)
C
C  Flush the buffer.  This is needed on Unix for xterm, and especially
C  for xgterm.
C
	ELSE IF (OPCODE.EQ.PLT$OP_FLUSHBUFFER) THEN
	  CALL TEK(0,0,18)
C
C  Reorigin
C
	ELSE IF (OPCODE.EQ.PLT$OP_ORIG) THEN
	  IF (I2COM(PLT$W_X).EQ.(-50*PLT$C_NIBS)) THEN
	    XORIGIN=0
	    YORIGIN=0
	  ELSE IF (I2COM(PLT$W_X).EQ.(-50*PLT$C_OLDNIBS)) THEN
	    XORIGIN=0
	    YORIGIN=0
	    FACTOR=FACTOR*2.362205  ! 600/254
	  ELSE
	    XORIGIN=XORIGIN+I2COM(PLT$W_X)*FACTOR
	    YORIGIN=YORIGIN+I2COM(PLT$W_Y)*FACTOR
	  END IF
	END IF
	RETURN
	END
