      SUBROUTINE TRANSPARENT_TO_TEK
C
C  Note:  This is the Unix version
C
C       This subroutine will cause a graphics display to switch from the
C  transparent mode to graphics mode without erasing the screens.  This
C  operation is convenient when using a graphics display which has separate
C  windows for normal text operation (transparent mode) and graphics
C  operation (TEK window).  Thus, this subroutine should be used with the 
C  Xterm and Versaterm displays.  The delay for other activies to complete
C  before transferring control to the TEK window is currently set at 0.5
C  seconds.  Depending on the calling application, this may have to be 
C  increased.  A call to DELAY will accomplish this.  This subroutine is 
C  called by XYPLOT, MESHPLOT, and CONTOURPLOT.
C				Donald H. Gudehus, July, 1993
C			Version 1U, Donald H. Gudehus, January 11, 2000
C			Converted code to Unix
C
	BYTE BUF(10)
	BYTE ESC,FF,GS
	PARAMETER (ESC='1B'X,FF='0C'X,GS='1D'X)
	COMMON /PLOT_CHAN/ NCHAN,NDEV
	INCLUDE 'plotpar.for'
C
C  Allow other activities to complete before sending new commands.
	CALL DELAY(0.1)
C  We are only interested in the device which is first, if many devices
C  are being used simultaneously.  This will be the device from which
C  cursor readback is obtained, and which is contained in the COMMON
C  block /PLOT$CHAN/.  
	IF (NDEV.EQ.10001) THEN  ! Xterm but not Xgterm
C  Access the TEK window in Xterm, in case transparent mode was in prior use
	  BUF(1)=ESC
	  BUF(2)='['
	  BUF(3)='?'
	  BUF(4)='3'
	  BUF(5)='8'
	  BUF(6)='h'
	  DO I=1,6
	    II=PUTC(BUF(I))
	  END DO
	END IF
	BUF(1)=GS  ! Enters vector mode.  An FS would also work here.
	II=PUTC(BUF(1))
	RETURN
	END
