	SUBROUTINE VECTMODE(LTYPE)
C
C       This subroutine sets the type of vector to be displayed
C  on the plot device and puts the appropriate value in the common
C  block PLOT$VECTOR and then calls PLOT with IPEN=5 in order to send
C  the line type to the divice driver or to a plot file.  Some devices
C  have restrictions on the allowed values of LTYPE, e.g. Xterm.  
C  Error checking and subsequent action must be done in the driver
C  routines for those devices.  Here, we only check that LTYPE is
C  less or equal to 15.
C
C			Donald H. Gudehus, November 2, 1982
C
C	LTYPE	(C)	The type of line desired on the plotting device
C			The types are:
C			Solid			LTYPE=0		VT100
C			Dotted			LTYPE=1		VT100
C			Dot-dashed		LTYPE=2		VT100
C			Short-dashed		LTYPE=3		VT100
C			Long-dashed		LTYPE=4		VT100
C			Double-dot long-dash	LTYPE=5		GraphOn
C			Long-dot long-dash	LTYPE=6		GraphOn
C			Medium-dash		LTYPE=7		GraphOn
C
C			Solid			LTYPE=0		Lasergrafix
C			Long-dash space		LTYPE=1		Lasergrafix
C			Dotted			LTYPE=2		Lasergrafix
C			Short-dashed		LTYPE=3		Lasergrafix
C			Long-dashed		LTYPE=4		Lasergrafix
C			Short-dash space	LTYPE=5		Lasergrafix
C			Double long-dashed	LTYPE=6		Lasergrafix
C			Long-dash dot		LTYPE=7		Lasergrafix
C			etc. to LTYPE=15
C
C			Solid			LTYPE=0		Xterm
C			Short-dashed		LTYPE=1		Xterm
C			Dash-dash-short_space	LTYPE=2		Xterm
C			Dash-short_space	LTYPE=3		Xterm
C			Dash-long_space		LTYPE=4		Xterm
C			Dash-long_space		LTYPE=5		Xterm
C			Dash-long_space		LTYPE=6		Xterm
C			LTYPE >=7 causes Xterm to crash
C
C			Solid			LTYPE=0		Laserwriter
C			Short-dashed		LTYPE=1		Laserwriter
C			Dash-dash-short_space	LTYPE=2		Laserwriter
C			Dash-short_space	LTYPE=3		Laserwriter
C			Dash-long_space		LTYPE=4		Laserwriter
C			Long dash-long_space	LTYPE=5		Laserwriter
C			Long dash-short_space	LTYPE=6		Laserwriter
C			Dash-long_dash		LTYPE=7		Laserwriter


	COMMON /PLOT_LINESTYLE/ MODE
C
	MODE=0 !  Initialization
C
C  Check for illegal LTYPE's.
	IF (LTYPE.GT.15.OR.LTYPE.LT.0)THEN
	  CALL MESSAGE('Illegal value in call to VECTMODE')
	ELSE  ! LTYPE is valid
	  MODE=LTYPE
	END IF
	CALL PLOT(0.0,0.0,5)
	RETURN
	END
