	SUBROUTINE SAVE_SAVE_AS(LU_IN,LU_TEMP,LU_OUT,MAPS_IN,NMAPS_IN,STATUS)
C
C       This subroutine saves a map from a temporary file to either the same
C  map in the original file (Choice = Save) or to an existing file or a 
C  new file (Choice = Save As).  In the Save As cases, the map is saved to
C  the end of the file.  It is necessary to have opened both the original
C  file on LU_IN and the temporary file on LU_TEMP by having called the
C  subroutine OPEN_TEMP_FITS.
C			Donald H. Gudehus, Jan. 7, 2008
C
C	LU_IN	     (C)    The logical unit that the input file was opened on
C	LU_TEMP	     (C)    The logical unit that the temporary file was opened
C			    on in OPEN_TEMP_FITS.
C	LU_OUT	     (C)    The logical unit that the output file will be 
C			    opened on.
C	MAPS_IN	     (C)    The input maps that will be operated on by the
C			    calling routine
C	NMAPS_IN     (C)    The number of the above input maps
C	STATUS	     (R)    A status return.  If there are no errors, the
C			    returned value is 0
C			    
	INCLUDE 'miipspar.for'
	INCLUDE 'fitsfacts.for'
C
	CHARACTER*2 CHOICE
	CHARACTER*80 FILENAME_IN,FILENAME_TEMP,FILENAME_OUT
	CHARACTER*120 COMMAND
	INTEGER STATUS,I4
	INTEGER MAPS_IN(MAPMAX),MAPS_OUT(MAPMAX)
C
	CHARACTER*80 DNAME
	COMMON /DFILE/ DNAME
C
	CHOICE=' '
	DO WHILE (CHOICE.NE.'S'.AND.CHOICE.NE.'SA')
	  CALL MESSAGE('Enter a choice for saving your results:')
	  CALL MESSAGE('     S  = Save:  saves to the same map')
	  CALL USRINP(%REF(CHOICE),1,'A',2,0,'CHOICE=',
	1 '     SA = Save As:  saves to a new file, or to the end of '//
	2 'an existing file')
	  CALL ALPHA(%REF(CHOICE),1,2,NCHAR,NFULL,NREST,2)
	END DO
	FILENAME_IN=FITSFILENAME(LU_IN)
	FILENAME_TEMP=FITSFILENAME(LU_TEMP)
	CALL GET_LEN_NONBLANK(FILENAME_TEMP,LT)
	IF (CHOICE.EQ.'S') THEN
	  CALL GET_LEN_NONBLANK(FILENAME_IN,LI)
	  CALL CLOSEFITS(LU_IN)
	  CALL CLOSEFITS(LU_TEMP)
	  COMMAND='mv -f '//FILENAME_TEMP(1:LT)//' '//FILENAME_IN(1:LI)
	  I4=SYSTEM(COMMAND(1:7+LT+LI))
	ELSE IF (CHOICE.EQ.'SA') THEN
	  CALL CLOSEFITS(LU_IN)
	  FILENAME_OUT=' '
	  CALL COPY_FITS_RECORDS(LU_TEMP,LU_OUT,FILENAME_OUT,MAPS_IN,NMAPS_IN,
	1 MAPS_OUT,STATUS)
	  CALL CLOSEFITS(LU_TEMP)
	  CALL CLOSEFITS(LU_OUT)
C  Delete the temporary file
	  COMMAND='rm '//FILENAME_TEMP(1:LT)
	  I4=SYSTEM(COMMAND(1:3+LT))
	END IF
	RETURN
	END
