	SUBROUTINE OPENCF(LU,KEYF,KEYWORD,KEYN)
C
C	Note:  This is the UNIX version.
C
C  	This subroutine opens a character file.
C				S. M. Simkin
C
C			Version 2, G. Quinn, June, 1981
C			Changed file name to 40 characters.
C			Version 3, D. H. Gudehus, September, 1982
C			Added common block for file name and encoding
C			and common block USEGRIN.  Added KEYN to
C			the argument list and added documentation.
C			Added ACCESS='APPEND' for old files.
C			Version 4, D. H. Gudehus, October, 1984
C			Added KEYF=0
C			Version 5, D. H. Gudehus, September, 1985
C			Changed default to name from COMMON block
C			if FILENAME .NE. ' '.
C			Version 6, D. H. Gudehus, August, 1987
C			Added KEYF=3 for opening a file for reading only;
C			this is useful for group members wanting to read
C			a file protected against writing
C			Version 7, D. H. Gudehus, October, 1992
C			Eliminated default to logical unit, since
C			it was not useful and confusing.
C			Version 8, D. H. Gudehus, December, 1994
C			Expanded range of KEYF to include values,
C			10, 11, 12, and 13 which are used when working
C			with a file with CARRIAGECONTROL='LIST'.
C			Version 9, D. H. Gudehus, December, 1994
C			Increased size of FILENAME from 40 to 80 bytes
C			Version 9U, D. H. Gudehus, May, 1997
C			For UNIX operation, commented out USRINPG,
C			removed variable length argument list feature, and
C			called ALPHA before calling OPEN so that blanks
C			will not remain in filename.  Also modified call 
C			to USRINP.
C			Version 10U, D. H. Gudehus, October 14, 1999
C			Added call to DOES_FILE_EXIST to avoid crash
C			when an existing file is opened as a new file.
C			Version 10UM D. H. Gudehus, February 6, 2005
C			Modified USRINP for Absoft compiler on Mac OS
C
C	LU	(C)	The logical unit number.
C	KEYF	(C)	The key for opening the file.  If KEYF=0, the
C			user is prompted for whether results are to
C			be added to an old file or a new one.  The logical
C			results are placed in the COMMON block OLDFILE.  If 
C			KEYF=1, the file is assumed to be an old file opened
C			for reading and updating.  Since it is opened at its 
C			end, one should REWIND if reading is to take place.  To
C			go back one record, use BACKSPACE, but only after
C			rewinding.  If KEYF=2, the file is asssumed to be a 
C			new file.  If KEYF=3, the file is assumed to be an
C			old file opened for reading only.
C			If 10 is added to the above values, the file is
C			of type CARRIAGECONTROL='LIST'.
C	KEYWORD	(C)	The keyord which is displayed in the call to
C			USRINP
C	KEYN	(C)	The key for opening a file with the name
C			supplied in the common block.  If KEYN is 
C			less than or equal to zero, USRINP is called;
C			if KEYN is positive, the name in the common block is
C			used;  if this name is blank, the logical unit
C			number is used.  When KEYN is 0, USRINP is called and
C			there is no default;  if KEYN is -1, USRINP is called
C			and the default is the last entry.
C
	CHARACTER*(*) KEYWORD
	CHARACTER*3 CNUM
	CHARACTER*4 CLU
C
	CHARACTER*80 FILENAME
	COMMON /CFILE/ FILENAME
C
C	INTEGER SYS$NUMARGS
C
	LOGICAL USEGRIN,OFIL,LIST,RESPONSE,GET_ANOTHER_NAME
	COMMON /GRINPROMPT/ USEGRIN
C
	COMMON /OLDFILE/ OFIL
C
C
	KEYFDUM=MOD(KEYF,10)
	IF (KEYF.GE.10) LIST=.TRUE.
C  If KEYN is less than or equal to 0, and MOD(KEYF,10)=0, ask the
C  user whether the file is old or new.
C  Also ask what the name is if FILENAME=' '.
	GET_ANOTHER_NAME=.TRUE.
C  Begin a loop where the file name is checked against existing names
	DO WHILE(GET_ANOTHER_NAME)
	  IF (KEYN.LE.0) THEN !  USRINP is called
	    IF (KEYFDUM.EQ.0) THEN
	      OFIL=.FALSE.
	      IF (USEGRIN) THEN
C	        CALL USRINPG(OFIL,1,'L',4,1,'OLD=',
C	1     'ADD THE RESULTS TO AN EXISTING FILE?  (DEFAULT = N)')
	      ELSE
	        CALL USRINP(OFIL,1,'L',4,1,'OLD=',
	1       'Add the results to an existing file?  (default = N)')
	      END IF
	      IF (OFIL) THEN
	        KEYFDUM=1
	      ELSE
	        KEYFDUM=2
	      END IF
	    END IF
	    IF (KEYN.EQ.0) THEN ! No default possible
	      IF (USEGRIN) THEN
C	        CALL USRINPG(%REF(FILENAME),1,'A',40,0,KEYWORD,
C	1       'ENTER THE FILE NAME:')
	      ELSE
	        CALL USRINP_CHAR(1,'A',40,0,KEYWORD,
	1       'Enter the file name:',%REF(FILENAME))
	      END IF
	    ELSE IF (KEYN.EQ.-1) THEN ! Default can be used
	      IF (USEGRIN) THEN
C	        CALL USRINPG(%REF(FILENAME),1,'A',40,1,KEYWORD,
C	1       'ENTER THE FILE NAME:  (DEFAULT = LAST ENTRY)')
	      ELSE
	        CALL USRINP_CHAR(1,'A',40,1,KEYWORD,
	1       'Enter the file name:  (default = last entry)',
	2       %REF(FILENAME))
	      END IF
	    END IF
	    CALL ALPHA(%REF(FILENAME),1,40,NCHAR,NFULL,NREST,2)
	  END IF
	  CALL ALPHA(%REF(FILENAME),1,40,NC,NF,NR,1)  ! Required for UNIX
C  Because Unix can't handle file name extensions, find out it the file
C  already exists if a new file has been requested
	  IF (KEYFDUM.EQ.2) THEN
	    RESPONSE=.TRUE.
	    CALL DOES_FILE_EXIST(LU,FILENAME,NC,RESPONSE,GET_ANOTHER_NAME)
	  ELSE
	    GET_ANOTHER_NAME=.FALSE.
	  END IF
	END DO
C  Irrespective of the value of KEYN, open 
C  the file according to the value of KEYFDUM.
	IF (KEYFDUM.EQ.1) THEN  ! Old file for reading and writing
	  IF (FILENAME.EQ.' ')  THEN
	    IF (LIST) THEN
	      OPEN(UNIT=LU,TYPE='OLD',CARRIAGECONTROL='LIST',ACCESS='APPEND')
	    ELSE
	      OPEN(UNIT=LU,TYPE='OLD',ACCESS='APPEND')
	    END IF
	    LUNIT=LU+1000  ! In order to produce leading zeros
	    ENCODE(4,1000,CLU) LUNIT
1000	    FORMAT(I4)
	    FILENAME='FOR'//CLU(2:4)//'.DAT'
	  ELSE
	    IF (LIST) THEN
	      OPEN(UNIT=LU,NAME=FILENAME(1:NC),TYPE='OLD',
	1     CARRIAGECONTROL='LIST',ACCESS='APPEND') 
	    ELSE
	      OPEN(UNIT=LU,NAME=FILENAME(1:NC),TYPE='OLD',ACCESS='APPEND')
	    END IF
	  END IF
	ELSE IF (KEYFDUM.EQ.2) THEN  ! New file for writing
	  IF (FILENAME.EQ.' ') THEN
	    IF (LIST) THEN
	      OPEN(UNIT=LU,TYPE='NEW',CARRIAGECONTROL='LIST')
	    ELSE
	      OPEN(UNIT=LU,TYPE='NEW')
	    END IF
	    LUNIT=LU+1000
	    ENCODE(4,1000,CLU)LUNIT
	    FILENAME='FOR'//CLU(2:4)//'.DAT'
	  ELSE
C  Check if the file exists.  In Unix we can't create a higher version
C  so we have to change the name.  Since this section is noninteractive,
C  add ".n" to the file name and then check if it exists.
	    IF (KEYN.GT.0) THEN
	      GET_ANOTHER_NAME=.TRUE.
	      NUM=100
	      DO WHILE (GET_ANOTHER_NAME)
	        NUM=NUM+1
	        IF (NUM.GE.200)
	1         CALL ERROR(-4,'Giving up on creating file extension')
C  Use 2 characters from CNUM with a leading 0
	        ENCODE(3,3000,CNUM) NUM
3000	        FORMAT(I3)
	        FILENAME=FILENAME(1:NC)//"."//CNUM(2:3)
	        NC_NEW=NC+3
	        RESPONSE=.FALSE.
	        CALL DOES_FILE_EXIST(LU,FILENAME,NC_NEW,RESPONSE,
	1       GET_ANOTHER_NAME)
	      END DO
	    ELSE !  The user has already entered a name and it has been
                 !  checked.
	      NC_NEW=NC
	    END IF
	    IF (LIST) THEN
	      OPEN(UNIT=LU,NAME=FILENAME(1:NC_NEW),TYPE='NEW',
	1     CARRIAGECONTROL='LIST')
	    ELSE
	      OPEN(UNIT=LU,NAME=FILENAME(1:NC_NEW),TYPE='NEW')
	    END IF
	  END IF
	ELSE IF (KEYFDUM.EQ.3) THEN  ! Old file for reading only
	  IF (FILENAME.EQ.' ') THEN
	    IF (LIST) THEN
	      OPEN(UNIT=LU,TYPE='OLD',CARRIAGECONTROL='LIST',READONLY)
	    ELSE 
	      OPEN(UNIT=LU,TYPE='OLD',READONLY)
	    END IF
	    LUNIT=LU+1000
	    ENCODE(4,1000,CLU)LUNIT
	    FILENAME='FOR'//CLU(2:4)//'.DAT'
	  ELSE
	    IF (LIST) THEN
	      OPEN(UNIT=LU,NAME=FILENAME(1:NC),TYPE='OLD',
	1     CARRIAGECONTROL='LIST',READONLY)
	    ELSE
	      OPEN(UNIT=LU,NAME=FILENAME(1:NC),TYPE='OLD',READONLY)
	    END IF
	  END IF
	END IF
	RETURN
	END
C
C
	SUBROUTINE DOES_FILE_EXIST(LU,FILENAME,NC,RESPONSE,GET_ANOTHER_NAME)
C
	LOGICAL RESPONSE,GET_ANOTHER_NAME,WRITE_OVER_FILE
C
	CHARACTER*(*) FILENAME
C
	GET_ANOTHER_NAME=.FALSE.
	OPEN(LU,NAME=FILENAME(1:NC),TYPE='OLD',ERR=20)
	IF (RESPONSE) THEN !  Requests a response from the user
	  WRITE_OVER_FILE=.TRUE.
	  CALL USRINP(WRITE_OVER_FILE,1,'L',4,1,'WRITE_OVER_FILE=',
	1 'This file already exists;  do you wish to write over it?  '//
	2' (default = Y)')
	  IF (WRITE_OVER_FILE) THEN
C  Do nothing
	  ELSE
	    CALL MESSAGE('Please think of another file name')
	    GET_ANOTHER_NAME=.TRUE.
	  END IF
	ELSE !  Automatic
	  GET_ANOTHER_NAME=.TRUE.
	END IF
  20	RETURN
	END
